Package: ClustIRR
Type: Package
Title: Clustering of Immune Receptor Repertoires
Version: 1.9.35
Authors@R: c(
    person("Simo", "Kitanovski", email = "simokitanovski@gmail.com", 
    role = c("aut", "cre"), comment=c(ORCID="0000-0003-2909-5376")),
    person("Kai", "Wollek", email = "kai.wollek@uni-duisburg-essen.de", 
    role = c("aut"), comment=c(ORCID="0009-0008-5941-9160")))
Description: ClustIRR analyzes repertoires of B- and T-cell receptors. It 
    starts by identifying communities of immune receptors with similar 
    specificities, based on the sequences of their complementarity-determining 
    regions (CDRs). Next, it employs a Bayesian probabilistic models to 
    quantify differential community occupancy (DCO) between repertoires, 
    allowing the identification of expanding or contracting communities 
    in response to e.g. infection or cancer treatment.
License: GPL-3 + file LICENSE
Depends: R (>= 4.3.0)
Imports: grDevices, igraph, methods, Rcpp (>= 0.12.0), RcppParallel (>=
        5.0.1), reshape2, rstan (>= 2.18.1), rstantools (>= 2.4.0),
        stats, stringdist, utils, posterior, visNetwork, dplyr, tidyr,
        ggplot2, ggforce, scales, msa, Biostrings, RADanalysis,
        ggseqlogo, rBLAST
Suggests: BiocStyle, knitr, testthat, ggrepel, patchwork, htmlwidgets
SystemRequirements: GNU make, ncbi-blast+
Encoding: UTF-8
LazyData: false
NeedsCompilation: yes
biocViews: Clustering, ImmunoOncology, SingleCell, Software,
        Classification, Bayesian, BiomedicalInformatics,
        ImmunoOncology, MathematicalBiology
RoxygenNote: 7.2.3
VignetteBuilder: knitr
URL: https://github.com/snaketron/ClustIRR
BugReports: https://github.com/snaketron/ClustIRR/issues
Biarch: true
LinkingTo: BH (>= 1.66.0), Rcpp (>= 0.12.0), RcppEigen (>= 0.3.3.3.0),
        RcppParallel (>= 5.0.1), rstan (>= 2.18.1), StanHeaders (>=
        2.18.0)
git_url: https://git.bioconductor.org/packages/ClustIRR
git_branch: devel
git_last_commit: ababdf1
git_last_commit_date: 2026-04-21
Repository: Bioconductor 3.23
Date/Publication: 2026-04-22
Packaged: 2026-04-22 21:07:48 UTC; biocbuild
Author: Simo Kitanovski [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-2909-5376>),
  Kai Wollek [aut] (ORCID: <https://orcid.org/0009-0008-5941-9160>)
Maintainer: Simo Kitanovski <simokitanovski@gmail.com>

# ClustIRR: Clustering of Immune Receptor Repertoires

![Build Status](https://github.com/snaketron/ClustIRR/actions/workflows/r.yml/badge.svg)

## Overview 
ClustIRR analyzes repertoires of B- and T-cell receptors. It begins the 
analysis by identifying communities (i.e., specificity groups) of immune 
receptors with similar specificities, based on the sequences of their 
complementarity determining regions (CDRs). Next, it employs a Bayesian 
probabilistic models to quantify differential community occupancy (DCO) 
between repertoires, allowing the identification of expanding or contracting 
communities in response to factors such as infection or cancer treatment.

## How to use ClustIRR
ClustIRR is an R-package available from Bioconductor: 

https://bioconductor.org/packages/ClustIRR/

To install this package, start R and enter:

```r
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("ClustIRR")
```

To use the development version of ClustIRR you can install it from Github.
To do this, start R and enter:

```r
library(devtools)
install_github("snaketron/ClustIRR")
```

Case studies are provided in the directory /vignettes

## Workflow & output 

![clustirr workflow](/inst/extdata/logo.png)

# Description:
# Given input data, get the number of chains that ought to be analyzed
# one by one.
# x = columns(data_sample)
get_chains <- function(x) {
  js <- c(which(x=="CDR3b"), 
          which(x=="CDR3a"), 
          which(x=="CDR3g"),
          which(x=="CDR3d"), 
          which(x=="CDR3h"), 
          which(x=="CDR3l"))
  return(x[js])
}

# Description:
# cut the left/right flanks of each CDR3 sequence by flank_size amino
# acids
get_trimmed_flanks <- function(x, flank_size) {
  n <- ifelse(test = deparse(substitute(x)) == "cdr3",
              yes = "sample",
              no = "reference")
  t <- flank_size*2
  l <- nchar(x)
  if(max(l, na.rm = TRUE) <= t) {
    stop("all input CDR3s are shorter than 2 x trim_flank_aa")
  }
  
  x <- substr(x = x, start = flank_size + 1, stop = nchar(x) - flank_size)
  
  x[x == ""] <- NA
  
  if(any(is.na(x))) {
    warning("some input CDR3s are shorter than 2 x trim_flank_aa")
  }
  
  return(x)
}

# This function packs the results into clust_irr object
get_clustirr_obj <- function(clust, s, meta, control) {
    
    # keep meta data
    if(is.null(meta)==TRUE | missing(meta)==TRUE) {
        meta <- NULL
    }
    
    return(new("clust_irr", 
               clust = clust, 
               inputs = list(s = s, meta = meta, control = control)))
}

get_clone_size <- function(x) {
  # clone size addition
  if(is.null(x)==TRUE) {
   return(NULL) 
  }
  if(("clone_size" %in% colnames(x))==FALSE) {
    x$clone_size <- 1
    return(x)
  }
  return(x)
}

get_sample <- function(x) {
  # clone size addition
  if(is.null(x)==TRUE) {
    return(NULL) 
  }
  if(("sample" %in% colnames(x))==FALSE) {
    x$sample <- paste0("S", sample(x = 1:10^5, size = 1))
    return(x)
  }
  return(x)
}

get_blosum62 <- function() {
    # get blosum matrix
    data_env <- new.env(parent = emptyenv())
    data("BLOSUM62", envir = data_env, package = "ClustIRR")
    # ensure: min(BLOSUM62)=0
    # data_env[["BLOSUM62"]] <- data_env[["BLOSUM62"]] + 4
    return(data_env)
}


# This is the class of the outputs produced by function clust_irr. Object
# from this class are used as input of plot_graph
setClass("clust_irr", representation(clust = "list", inputs = "list"))

# Accessors
setGeneric(name = "get_clustirr_clust", 
           def = function(x) {standardGeneric("get_clustirr_clust")})
setGeneric(name = "get_clustirr_inputs", 
           def = function(x) {standardGeneric("get_clustirr_inputs")})

setMethod(f = "get_clustirr_clust", 
          signature = signature("clust_irr"), 
          definition = function(x) {x@clust})
setMethod(f = "get_clustirr_inputs", 
          signature = signature("clust_irr"), 
          definition = function(x) {x@inputs})

# Description:
# Compute the statistics of a given community feature
get_community_feature_stats <- function(node_summary, 
                                        node_feature,
                                        community_id) {
    
    if(missing(node_summary) || is.null(node_summary)) {
        stop("missing node_summary")
    }
    if(is.data.frame(node_summary) == FALSE) {
        stop("node_summary must be a data.frame")
    }
    
    if(missing(node_feature) || is.null(node_feature)) {
        stop("missing node_feature")
    }
    if(length(node_feature) != 1) {
        stop("node_feature length != 1")
    }
    if(is.character(node_feature)==FALSE) {
        stop("node_feature must be character")
    }
    
    if(missing(community_id) || is.null(community_id)) {
        stop("missing community_id")
    }
    if(length(community_id) != 1) {
        stop("community_id length != 1")
    }
    if(is.numeric(community_id)==FALSE) {
        stop("community_id must be character")
    }
    
    
    if(!any(colnames(node_summary) %in% node_feature)) {
        stop("node_feature not found among node attributes")
    }
    if(!any(colnames(node_summary) %in% "community")) {
        stop("community not found in node_summary")
    }
    c <- node_summary[, "community"]
    f <- node_summary[, node_feature]
    
    i <- which(c == community_id)
    if(length(i)==0) {
        stop("community not found")
    }
    c <- c[i]
    f <- f[i]
    
    feature_type <- NA
    if(is.numeric(f)) {
        feature_type <- "num"
        return(data.frame(community = community_id, 
                          feature = node_feature,
                          feature_mean = mean(f), 
                          feature_median = median(f), 
                          feature_sum = sum(f),
                          feature_type = feature_type,
                          n = length(f)))
    }
    if(is.character(f) | is.factor(f) | is.logical(f)) {
        
        # distinguish between binary vs. non-binary
        
        feature_type <- "cat"
        f <- data.frame(table(f))
        colnames(f) <- c("feature", "feature_count")
        f$feature_prop <- f$feature_count/sum(f$feature_count)
        f$community <- community_id
        f$feature_type <- feature_type
        f$n <- length(c)
        f <- f[,c("community", "feature", "feature_count", 
                  "feature_prop", "feature_type", "n")]
        f <- f[order(f$feature_prop, decreasing = TRUE),]
        return(f)
    }
}




# Description:
# compute purity of communities with respect to a node feature: 
# numeric (e.g., gene expression) via coefficient of variation 
# or categorical (e.g., tissue type) via gini impurity
get_community_feature_purity <- function(node_summary, 
                                         node_feature) {
    
    if(missing(node_summary) || is.null(node_summary)) {
        stop("missing node_summary")
    }
    if(is.data.frame(node_summary) == FALSE) {
        stop("node_summary must be a data.frame")
    }
    
    if(missing(node_feature) || is.null(node_feature)) {
        stop("missing node_feature")
    }
    if(length(node_feature) != 1) {
        stop("node_feature length != 1")
    }
    if(is.character(node_feature)==FALSE) {
        stop("node_feature must be character")
    }
    
    
    if(!any(colnames(node_summary) %in% node_feature)) {
        stop("node_feature not found among node attributes")
    }
    if(!any(colnames(node_summary) %in% "community")) {
        stop("community not found in node_summary")
    }
    c <- node_summary[, "community"]
    f <- node_summary[, node_feature]
    
    feature_type <- NA
    if(is.numeric(f)) {
        feature_type <- "num"
    }
    if(is.character(f) | is.factor(f) | is.logical(f)) {
        feature_type <- "cat"
    }
    if(is.na(feature_type)) {
        stop("node_feature must be categorical or numeric")  
    }
    
    if(feature_type == "cat") {
        return(get_gini_cat(ls = f, cs = c))
    } 
    return(get_gini_num(fs = f, cs = c))
}


get_gini_cat <- function(ls, cs) {
    # Vectorized GI function
    get_gi <- function(l) {
        p <- tabulate(match(l, unique(l))) / length(l)
        return(sum(p^2))
    }
    
    get_h <- function(l) {
        p <- tabulate(match(l, unique(l))) / length(l)
        return(-sum(p*log(p)))
    }
    
    get_d <- function(l, ls, b) {
        if(b==FALSE) {
            return(NA)
        }
        n <- length(l)
        f <- tabulate(match(l, ls), nbins = 2)
        return((f[1]-f[2])/n)
    }
    
    # split ls by cs
    groups <- split(ls, cs)
    
    # if binary compute D
    b <- length(unique(ls))==2
    
    # Compute GI and size per community
    return(data.frame(community = as.numeric(names(groups)),
                      GI = 1 - vapply(groups, get_gi, numeric(1)),
                      H = vapply(groups, get_h, numeric(1)),
                      D = vapply(groups, get_d, numeric(1), 
                                 ls = sort(unique(ls), decreasing = TRUE), 
                                 b = b),
                      n = lengths(groups),
                      row.names = NULL))
}

get_gini_num <- function(fs, cs) {
    
    groups <- split(fs, cs)
    
    gi <- data.frame(community = as.numeric(names(groups)),
                     mean = vapply(groups, mean, numeric(1)),
                     sd   = vapply(groups, sd,   numeric(1)),
                     n    = lengths(groups),
                     row.names = NULL)
    
    gi$cv <- gi$sd/gi$mean
    return(gi)
}

# Download VDJdb .tsv file from: https://vdjdb.cdr3.net/
t <- read.csv(file = "SearchTable-2025-01-09 15_15_58.769.tsv", sep = "\t")

tb <- t[t$Gene=="TRB", c("CDR3", "Species", "Epitope.species", 
                         "Epitope.gene", "Reference")]
tb$CDR3a <- NA
tb$CDR3b <- tb$CDR3
tb$CDR3 <- NULL
tb <- tb[, c("CDR3a", "CDR3b", "Species", "Epitope.species", 
             "Epitope.gene", "Reference")]

ta <- t[t$Gene=="TRA", c("CDR3", "Species", "Epitope.species", 
                         "Epitope.gene", "Reference")]
ta$CDR3a <- ta$CDR3
ta$CDR3b <- NA
ta$CDR3 <- NULL
ta <- ta[, c("CDR3a", "CDR3b", "Species", "Epitope.species", 
             "Epitope.gene", "Reference")]

t <- rbind(ta, tb)
t <- t[duplicated(t)==F,]

colnames(t) <- c("CDR3a", "CDR3b", "CDR3_species",
                 "Antigen_species", "Antigen_gene",
                 "Reference")

t$CDR3g <- NA
t$CDR3d <- NA
t$CDR3h <- NA
t$CDR3l <- NA

t <- t[, c("CDR3a", "CDR3b",
           "CDR3g", "CDR3d", 
           "CDR3h", "CDR3l", 
           "CDR3_species", "Antigen_species", 
           "Antigen_gene", "Reference")]

vdjdb <- t
save(vdjdb, file = "data/vdjdb.RData", compress = T)

detect_communities <- function(graph, 
                               algorithm = "leiden", 
                               metric = "average",
                               resolution = 1,
                               iterations = 100,
                               chains) {
    
    check_inputs(graph = graph,
                 algorithm = algorithm, 
                 metric = metric,
                 resolution = resolution,
                 iterations = iterations,
                 chains = chains)
    
    message("[1/5] formatting graph...")
    cg <- get_formatted_graph(graph = graph, 
                              metric = metric, 
                              chains = chains) 
    
    message("[2/5] community detection...")
    cg <- get_community_detection(g = cg, 
                                  algorithm = algorithm, 
                                  resolution = resolution,
                                  iterations = iterations)
    
    message("[3/5] community summary...")
    cs <- get_community_summary(g = cg$graph, chains = chains)
    
    message("[4/5] extracting community occupancy matrix...")
    cm <- get_community_matrix(g = cg$graph)
    
    message("[5/5] extracting nodes")
    vs <- igraph::as_data_frame(x = cg$graph, what = "vertices")
    
    # save configs
    config <- list(input_g = graph, 
                   algorithm = algorithm, 
                   resolution = resolution,
                   metric = metric,
                   chains = chains)
    
    return(list(community_occupancy_matrix = cm, 
                community_summary = cs, 
                node_summary = vs, 
                graph = cg$graph, 
                graph_structure_quality = list(modularity = cg$modularity,
                                               quality = cg$quality),
                input_config = config))
}

get_formatted_graph <- function(graph,
                                metric,
                                chains) {
    
    set_chain <- function(graph, chains) {
        i <- which(!E(graph)$chain %in% chains)
        if(length(i)!=0) {
            graph <- delete_edges(graph = graph, i)
        }
        return(graph)
    }
    
    graph <- set_chain(graph = graph, chains = chains)
    
    graph <- simplify(graph, edge.attr.comb = list(ncweight = "concat",
                                                   nweight = "concat",
                                                   chain = "concat",
                                                   "ignore"))
    
    if(metric == "average") {
        E(graph)$nweight <- vapply(X = E(graph)$nweight, 
                                   FUN.VALUE = numeric(1),
                                   FUN = function(x) {return(sum(x)/2)})
        E(graph)$ncweight <- vapply(X = E(graph)$ncweight, 
                                    FUN.VALUE = numeric(1),
                                    FUN = function(x) {return(sum(x)/2)})
    }
    if(metric == "max") {
        E(graph)$nweight <- vapply(X = E(graph)$nweight, 
                                   FUN.VALUE = numeric(1),
                                   FUN = function(x) {return(max(x))})
        E(graph)$ncweight <- vapply(X = E(graph)$ncweight, 
                                    FUN.VALUE = numeric(1),
                                    FUN = function(x) {return(max(x))})
     }
    
    E(graph)$w <- E(graph)$nweight
    
    # if trim*2 > CDR3 lengths -> NA
    i <- which(E(graph)$w <= 0 | is.na(E(graph)$w))
    if(length(i)!=0) {
        graph <- delete_edges(graph = graph, i)
    }
    return(graph)
}

get_community_detection <- function(g, 
                                    algorithm, 
                                    resolution,
                                    iterations) {
    
    m <- NA
    q <- NA
    if(algorithm == "louvain") {
        c <- cluster_louvain(graph = g, 
                             weights = E(g)$w, 
                             resolution = resolution)
        V(g)$community <- c$membership
        m <- c$modularity[length(c$modularity)]
    }
    if(algorithm == "leiden") {
        c <- cluster_leiden(graph = g, 
                            weights = E(g)$w, 
                            resolution = resolution,
                            n_iterations = iterations)
        V(g)$community <- c$membership
        m <- modularity(g, membership = c$membership, weights = E(g)$w, 
                        resolution = resolution, directed = FALSE)
        q <- c$quality
    }
    if(algorithm == "infomap") {
        c <- cluster_infomap(graph = g, 
                             e.weights = E(g)$w, 
                             nb.trials = iterations)
        V(g)$community <- c$membership
        m <- c$modularity[length(c$modularity)]
    }
    
    return(list(graph = g, quality = q, modularity = m))
}

get_community_summary <- function(g, chains) {
    
    get_estats <- function(e, v, chains) {
        e <- merge(x = e, y = v[,c("name", "community")], 
                   all.x = TRUE, by.x = "from", by.y = "name")
        e <- merge(x = e, y = v[,c("name", "community", "sample")], 
                   all.x = TRUE, by.x = "to", by.y = "name")
        e <- e[e$community.x==e$community.y,]
        if(nrow(e)==0) {
            return(NULL)
        }
        
        e$community <- e$community.x
        e <- e[,c("community", "chain", "nweight", "ncweight", "w")]
        e$n_edges <- 1
        es <- vector(mode = "list", length = length(chains))
        names(es) <- chains
        
        for(c in chains) {
            x <- e[e$chain == c, ] %>%
                group_by(community) %>%
                summarise(across(c(nweight, ncweight, w), mean, na.rm = TRUE),
                          n_edges = sum(n_edges, na.rm = TRUE), 
                          .groups = "drop") %>%
                ungroup()
            x$chain <- NULL  
            colnames(x) <- c("community",paste0(c("nweight", "ncweight", 
                                                  "w", "n_edges"), "_", c))
            es[[c]] <- x
        }
        
        if(length(chains)>1) {
            es <- merge(x = es[[chains[1]]], y = es[[chains[2]]], 
                        by = "community", all = TRUE)
            es[is.na(es)] <- 0
            es <- es[,sort(colnames(es))]
        } else {
            es <- es[[chains[1]]]
        }
        return(es)
    }
    
    get_vstats <- function(v, wide) {
        
        v$cells <- v$clone_size
        v$clones <- 1
        
        if(wide) {
            # number of cells
            vcells <- aggregate(cells~community+sample, data = v, FUN = sum)
            vcells <- acast(data = vcells, formula = community~sample, 
                            value.var = "cells", fill = 0)
            vcells <- data.frame(vcells)
            vcells$n <- apply(X = vcells, MARGIN = 1, FUN = sum)
            colnames(vcells) <- paste0("cells_", colnames(vcells))
            vcells$community <- rownames(vcells)
            vcells$community <- as.numeric(as.character(vcells$community))
            vcells <- vcells[order(vcells$community, decreasing = FALSE), ]
            
            # number of clones
            vclones <- aggregate(clones~community+sample, data = v, FUN = sum)
            vclones <- acast(data = vclones, formula = community~sample, 
                             value.var = "clones", fill = 0)
            vclones <- data.frame(vclones)
            vclones$n <- apply(X = vclones, MARGIN = 1, FUN = sum)
            colnames(vclones) <- paste0("clones_", colnames(vclones))
            vclones$community <- rownames(vclones)
            vclones$community <- as.numeric(as.character(vclones$community))
            vclones <- vclones[order(vclones$community, decreasing = FALSE), ]
            
            # merge clones and cells
            vstats <- merge(x = vclones, y = vcells, by = "community")
        } 
        else {
            # number of cells
            vcells <- aggregate(cells~community+sample, data = v, 
                                FUN = sum, drop = FALSE)
            
            # number of clones
            vclones <- aggregate(clones~community+sample, data = v, 
                                 FUN = sum, drop = FALSE)
            
            # merge clones and cells
            vstats <- merge(x = vclones, y = vcells, 
                            by = c("community", "sample"))
            vstats$cells[is.na(vstats$cells)] <- 0
            vstats$clones[is.na(vstats$clones)] <- 0
        }
        
        return(vstats)
    }
    
    b <- igraph::as_data_frame(x = g, what = "both")
    es <- get_estats(e = b$edges, v = b$vertices, chains = chains)
    vs <- get_vstats(v = b$vertices, wide = TRUE)
    
    # merge results
    cs <- merge(x = vs, y = es, by = "community", all.x = TRUE)
    cs <- cs[order(cs$community, decreasing = FALSE), ]
    cs[is.na(cs)] <- 0
    return(cs)
}

get_community_matrix <- function(g) {
    vs <- igraph::as_data_frame(x = g, what = "vertices")
    
    cm <- acast(data = vs, formula = community~sample, 
                value.var = "clone_size", 
                fun.aggregate = sum, fill = 0)
    
    return(cm)
}

check_inputs <- function(graph, 
                         algorithm, 
                         metric,
                         resolution,
                         iterations, 
                         chains) {
    
    
    # check graph
    if(missing(graph)) {
        stop("graph must be an igraph object")
    }
    if(is_igraph(graph)==FALSE) {
        stop("graph must be an igraph object")
    }
    
    # check algorithm
    if(missing(algorithm)) {
        stop("algorithm must be louvain, leiden or infomap")
    }
    if(length(algorithm)!=1) {
        stop("algorithm must be louvain, leiden or infomap")
    }
    if(is.character(algorithm)==FALSE) {
        stop("algorithm must be character")
    }
    if(!algorithm %in% c("louvain", "leiden", "infomap")) {
        stop("algorithm must be louvain, leiden or infomap")
    }
    
    # check metric
    if(missing(metric)) {
        stop("metric must be average or max")
    }
    if(length(metric)!=1) {
        stop("metric must be average or max")
    }
    if(is.character(metric)==FALSE) {
        stop("metric must be character")
    }
    if(!metric %in% c("average", "max")) {
        stop("metric must be average or max")
    }
    
    # check resolution
    if(missing(resolution)) {
        stop("resolution must be a number > 0")
    }
    if(length(resolution)!=1) {
        stop("resolution must be a number > 0")
    }
    if(is.numeric(resolution)==FALSE) {
        stop("resolution must be a number > 0")
    }
    if(is.finite(resolution)==FALSE) {
        stop("resolution must be a number > 0")
    }
    if(resolution<=0) {
        stop("resolution must be a number > 0")
    }
    
    
    # check iterations
    if(missing(iterations)) {
        stop("iterations must be a number > 0")
    }
    if(length(iterations)!=1) {
        stop("iterations must be a number > 0")
    }
    if(is.numeric(iterations)==FALSE) {
        stop("iterations must be a number > 0")
    }
    if(is.finite(iterations)==FALSE) {
        stop("iterations must be a number > 0")
    }
    if(iterations<=0) {
        stop("iterations must be a number > 0")
    }

    # check chains
    if(missing(chains)) {
        stop("chains must be a character vector")
    }
    if(length(chains)<1 | length(chains)>2) {
        stop("chains must be a character vector")
    }
    if(is.character(chains)==FALSE) {
        stop("chains must be a character vector")
    }
    if(any(chains %in% c("CDR3a", "CDR3b", "CDR3g", 
                         "CDR3d", "CDR3h", "CDR3l"))==FALSE) {
        stop("chains must be a character vector")
    }
}

set_chain <- function(graph, chains) {
    i <- which(!E(graph)$chain %in% chains)
    if(length(i)!=0) {
        graph <- delete_edges(graph = graph, i)
    }
    return(graph)
}

# Description:
# Check user provided input and generate errors and warnings, if necessary
input_check <- function(s, meta, control) {
  check_s(s = s)
  check_trim_flank_aa(control$trim_flank_aa)
  check_blast_gmi(blast_gmi = control$blast_gmi)
  check_blast_cores(blast_cores = control$blast_cores)
  check_db_custom(db_custom = control$db_custom)
  check_db_dist(db_dist = control$db_dist)
  check_knn(knn = control$knn, k = control$k)
  check_meta(s = s, meta = meta)
}

check_s <- function(s) {
  check_missing(s)
  check_dataframe(s)
  check_s_cols(s)
  check_rowcount(s)
  check_dataframe_na(s)
  check_dataframe_empty(s)
  check_aa(s)
}

check_trim_flank_aa <- function(trim_flank_aa) { # boundary_size
  check_singlevalue(trim_flank_aa)
  check_infinity(trim_flank_aa)
  check_numeric(trim_flank_aa)
  check_wholenumber(trim_flank_aa)
  check_positive(trim_flank_aa)
}

check_as_visnet <- function(as_visnet) {
  if(missing(as_visnet)) {
    stop("as_visnet missing")
  }
  check_singlevalue(x = as_visnet)
  check_logical(x = as_visnet)
}

check_show_singletons <- function(show_singletons) {
  if(missing(show_singletons)) {
    stop("show_singletons missing")
  }
  check_singlevalue(x = show_singletons)
  check_logical(x = show_singletons)
}

check_select_by <- function(select_by) {
  if(missing(select_by)) {
    stop("select_by is missing")
  }
  check_singlevalue(x = select_by)
  if(is.null(select_by) || is.na(select_by)) {
    stop("select_by is NULL or NA")
  }
  if(is.character(select_by)==FALSE) {
    stop("type of select_by must be character")
  }
  if(select_by %in% c("Ag_species", "Ag_gene") == FALSE) {
    stop("select_by can be either Ag_species or Ag_gene")
  }
}

check_node_opacity <- function(node_opacity) {
    check_infinity(node_opacity)
    check_numeric(node_opacity)
    check_singlevalue(node_opacity)
    check_probability(node_opacity)
}

check_blast_gmi <- function(blast_gmi) {
  check_infinity(blast_gmi)
  check_numeric(blast_gmi)
  check_singlevalue(blast_gmi)
  check_probability(blast_gmi)
}

check_blast_cores <- function(blast_cores) {
    check_infinity(blast_cores)
    check_numeric(blast_cores)
    check_wholenumber(blast_cores)
    check_singlevalue(blast_cores)
    check_lessthan(blast_cores, 1)
}

check_knn <- function(knn, k) {
    check_missing(knn)
    check_singlevalue(knn)
    check_logical(knn)
    
    check_missing(k)
    check_infinity(k)
    check_numeric(k)
    check_singlevalue(k)
    check_wholenumber(k)
    check_lessthan(k, 1)
}

# Description:
# Setup control list.
# control_in: user generated list (if missing -> use default)
get_control <- function(control_in) {
  control = list(blast_gmi = 0.8,
                 blast_cores = 1,
                 trim_flank_aa = 3,
                 db_dist = 0,
                 db_custom = NULL,
                 knn = FALSE,
                 k = 30)
  
  # if missing control_in -> use default values
  if(missing(control_in) || is.null(control_in)) {
    return(control)
  }
  if(is.list(control_in) == FALSE) {
    stop("control must be a list")
  }
  if(all(names(control_in) %in% names(control)) == FALSE) {
    stop("unrecognized elements found in control")
  }
  
  ns <- names(control_in)
  for (i in seq_len(length(control_in))) {
    control[[ns[i]]] <- control_in[[ns[i]]]
  }
  return(control)
}


check_clustirr <- function(clust_irr) {
  # if missing control_in -> use default values
  if(missing(clust_irr) || is.null(clust_irr)) {
    stop("input clust_irr is empty")
  }
  
  if(is(clust_irr, class2 = "clust_irr")==FALSE) {
    stop("input clust_irr is not class clust_irr")
  }
}


check_db_custom <- function(db_custom) {
  if(missing(db_custom)) {
    return(NULL)
  }
  if(is.null(db_custom)) {
    return(NULL)
  }
  
  if(is.data.frame(db_custom)==FALSE) {
    stop("db_custom must be a data.frame") 
  }
  if(nrow(db_custom)<=0) {
    stop("db_custom must be a data.frame") 
  }
  
  e <- new.env()
  name <- data("tcr3d", package = "ClustIRR", envir = e)[1]
  e <- e[[name]]
  if(all(colnames(db_custom) == colnames(e))==FALSE) {
    stop("wrong columns in db_custom, see internal data tcr3d.")
  }
}


check_db_dist <- function(db_dist) {
  check_infinity(db_dist)
  check_numeric(db_dist)
  check_wholenumber(db_dist)
  check_singlevalue(db_dist)
  check_lessthan(db_dist, 0)
}


check_meta <- function(s, meta) {
    if(missing(meta)==FALSE & is.null(meta)==FALSE) {
        if(is.data.frame(meta)==FALSE) {
            stop("meta is provided but not as data.frame")
        }
        if(nrow(meta)!=nrow(s)) {
            stop("meta is provided but nrow(meta) != nrow(s)")
        }
    }
}



#### Helper functions ####

check_aa <- function(x) {
  aa <- "[^ACDEFGHIKLMNPQRSTVWY]"
  for(col in get_chains(colnames(x))) {
    res <- lapply(x[,col], function(y) length(grep(aa, y)) != 0)
    if(any(unlist(res))) {
      stop("non-standard amino acid symbols in input CDR")
    }
  }
}

check_dataframe <- function(x) {
  w <- paste0(deparse(substitute(x)), " has to be a dataframe")
  if(!is.data.frame(x)) {
    stop(w)
  }
}

check_s_cols <- function(x) {
  chains <- paste0("CDR3", c("a","b","g","d","l","h"))
  if(!any(colnames(x) %in% c("clone_size", "sample", chains))) {
    stop(paste0("allowed columns in s: ", chains, " clone_size and sample"))
  }
  if((any(colnames(x) %in% chains[c(1,2)])==TRUE &
      all(colnames(x) %in% c(chains[c(1,2)], "clone_size", "sample"))==FALSE)|
     (any(colnames(x) %in% chains[c(3,4)])==TRUE &
      all(colnames(x) %in% c(chains[c(3,4)], "clone_size", "sample"))==FALSE)|
     (any(colnames(x) %in% chains[c(5,6)])==TRUE &
      all(colnames(x) %in% c(chains[c(5,6)], "clone_size", "sample"))==FALSE)) {
    stop(paste0("allowed chain pairs: CDR3a-CDR3b CDR3d-CDR3g CDR3l-CDR3h"))
  }
  
  if(any(colnames(x) == "clone_size")) {
    if(any(is.numeric(x$clone_size)==FALSE)) {
      stop("clone_size must be numeric")
    }
  }
  if(any(colnames(x) == "sample")) {
    if(any(is.character(x$sample)==FALSE)) {
      stop("sample must be character")
    }
  }
}

check_dataframe_empty <- function(x) {
  w <- paste0(
    deparse(substitute(x)),
    " contains empty values"
  )
  if(any(x == "", na.rm = TRUE)) {
    warning(w)
  }
}

check_dataframe_na <- function(x) {
  w <- paste0(
    deparse(substitute(x)),
    " contains NA value"
  )
  if(any(is.na(x))) {
    warning(w)
  }
}

check_greaterthan <- function(x, v) {
  w <- paste0(
    deparse(substitute(x)),
    " has to be <= ",
    v
  )
  if(any(x > v)) {
    stop(w)
  }
}

check_infinity <- function(x) {
  w <- paste0(
    deparse(substitute(x)),
    " has to be a finite number"
  )
  if(any(is.infinite(x))) {
    stop(w)
  }
}

check_lessthan <- function(x, v) {
  w <- paste0(
    deparse(substitute(x)),
    " has to be >= ",
    v
  )
  if(any(x < v)) {
    stop(w)
  }
}

check_logical <- function(x) {
  w <- paste0(
    deparse(substitute(x)),
    " has to be logical"
  )
  if(any(is.na(x))) {
    stop(w)
  }
  if(!is.logical(x)) {
    stop(w)
  }
}

check_matrix <- function(x) {
  w <- paste0(
    deparse(substitute(x)),
    " has to be of type matrix"
  )
  if(!is.matrix(x)) {
    stop(w)
  }
}

check_matrix_column_count <- function(x, c) {
  w <- paste0(
    deparse(substitute(x)),
    " has to have ", c, " columns"
  )
  if(ncol(x) != c) {
    stop(w)
  }
}

check_matrix_type <- function(x, type) {
  w <- paste0(
    deparse(substitute(x)),
    " has to be a numeric matrix"
  )
  
  if(type == "numeric") {
    if(is.numeric(x) == FALSE) {
      stop(w)
    }
  }
  if(type == "character") {
    if(is.character(x) == FALSE) {
      stop(w)
    }
  }
}

check_missing <- function(x) {
  w <- paste0(
    deparse(substitute(x)),
    " is missing"
  )
  if(missing(x) || is.null(x)) {
    stop(w)
  }
}

check_numeric <- function(x) {
  w <- paste0(
    deparse(substitute(x)),
    " has to be numeric"
  )
  if(any(!is.numeric(x))) {
    stop(w)
  }
}

check_rowcount <- function(x) {
  w <- paste0(
    deparse(substitute(x)),
    " contains zero rows"
  )
  if(nrow(x) == 0) {
    stop(w)
  }
}

check_singlevalue <- function(x) {
  w <- paste0(
    deparse(substitute(x)),
    " has to be a single value"
  )
  if(any(is.na(x))) {
    stop(w)
  }
  if(length(x) != 1) {
    stop(w)
  }
}

check_wholenumber <- function(x) {
  w <- paste0(
    deparse(substitute(x)),
    " has to be a whole number"
  )
  if(any(!(abs(x - round(x)) < .Machine$double.eps^0.5))) {
    stop(w)
  }
}

check_positive <- function(x) {
  w <- paste0(
    deparse(substitute(x)),
    " has to be positive number"
  )
  if(x < 0) {
    stop(w)
  }
}

check_probability <- function(x) {
    w <- paste0(deparse(substitute(x)), " must be probability")
    if(x < 0 | x > 1) {
        stop(w)
    }
}

get_graph <- function(clust_irr) {
    
    get_edges <- function(clust_irr) {
        eg <- vector(mode="list", length =length(get_clustirr_clust(clust_irr)))
        names(eg) <- names(get_clustirr_clust(clust_irr))
        for(chain in names(get_clustirr_clust(clust_irr))) {
            g <- get_clustirr_clust(clust_irr)[[chain]]
            if(is.null(g) == FALSE && nrow(g) != 0) {
                eg[[chain]] <- g
            }
        }
        eg <- do.call(rbind, eg)
        return(eg)
    }
    
    get_edge_order <- function(x) {
        return(paste0(sort(c(x[1], x[2])), collapse = '-'))
    }
    
    build_graph <- function(e, cs, sample_id, chains) {
        
        add_edges <- function(e, ig) {
            es <- as.vector(apply(X = e[, c("from", "to")], MARGIN = 1,
                                     FUN = function(x) {return(x)}))
            
            ig <- igraph::add_edges(graph = ig, 
                                    edges = es,
                                    weight = e$weight,
                                    cweight = e$cweight,
                                    nweight = e$nweight,
                                    ncweight = e$ncweight,
                                    type = "within-repertoire",
                                    chain = e$chain)
            
            return(ig)
        }

        ig <- graph_from_data_frame(d = data.frame(from = cs$name[1], 
                                                   to = cs$name[1]),
                                    directed = FALSE,
                                    vertices = cs)
        ig <- delete_edges(ig, edges = 1)
        
        # add global edges
        if(is.null(e)==FALSE && nrow(e)!=0) {
            for(chain in chains) {
                chain_ge <- e[e$chain == chain, ]
                if(nrow(chain_ge)!=0) {
                    ig <- add_edges(e = chain_ge, ig = ig)
                }
            }
        }
        
        return(ig)
    }
    
    check_clustirr(clust_irr = clust_irr)
    
    # get chains
    chains <- get_chains(x = colnames(get_clustirr_inputs(clust_irr)$s))
    
    # cells
    s <- get_clustirr_inputs(clust_irr)$s
    # setting up the sample id
    sample_id <- s$sample[1]
    
    # meta
    meta <- get_clustirr_inputs(clust_irr)$meta
    
    # get clones
    cs <- get_clones(sample_id = sample_id, s = s, meta = meta)
    
    # get edges between clones
    e <- get_edges(clust_irr = clust_irr)
    
    # build graph with only vertices
    if(is.null(e)) {
        ig <- graph_from_data_frame(d = data.frame(from = cs$name[1], 
                                                   to = cs$name[1]), 
                                    directed = FALSE, vertices = cs)
        ig <- delete_edges(ig, edges = 1)
        
        return(list(graph = ig, clust_irrs = clust_irr, 
                    clones = cs, multigraph = FALSE))
    }
    
    # build graph
    message("creating graph (", sample_id, ") \n")
    ig <- build_graph(e = e, cs = cs, sample_id = sample_id, chains = chains)
    
    return(list(graph = ig, clust_irrs = clust_irr, 
                clones = cs, multigraph = FALSE))
}


get_joint_graph <- function(clust_irrs) {
    
    check_input <- function(clust_irrs) {
        if(missing(clust_irrs)==TRUE) {
            stop("clust_irrs input missing")
        }
        if(is.list(clust_irrs)==FALSE) {
            stop("clust_irrs must be a list of clust_irr objects")
        }
        for(i in 1:length(clust_irrs)) {
            check_clustirr(clust_irr = clust_irrs[[i]])
        }
        
        # check if same chain names
        cs <- colnames(get_clustirr_inputs(clust_irrs[[1]])$s)
        for(i in 2:length(clust_irrs)) {
            if(any(colnames(get_clustirr_inputs(clust_irrs[[i]])$s)!=cs)) {
                stop("different chains in graphs")
            }
        }
    }
    
    get_clust_irrs_names <- function(clust_irrs) {
        clust_irrs_names <- names(clust_irrs)
        if(is.null(clust_irrs_names)) {
            names(clust_irrs) <- paste0("s", 1:length(clust_irrs))
        }
        
        for(i in 1:length(clust_irrs)) {
            clust_irrs[[i]]@inputs[["sample_id"]] <- names(clust_irrs)[i]
        }
        
        return(clust_irrs)
    }
    
    get_v_e <- function(x, what) {
        return(igraph::as_data_frame(x$graph, what = what))
    }
    
    # check input
    check_input(clust_irrs = clust_irrs)
    
    # get clust_irrs names
    clust_irrs <- get_clust_irrs_names(clust_irrs = clust_irrs)
    
    # get joint controls
    control <- get_joint_controls(clust_irrs = clust_irrs)
    
    # build graphs
    message("[1/3] generating individual graphs... \n")
    igs <- lapply(X = clust_irrs, FUN = get_graph)
    names(igs) <- names(clust_irrs)
    
    # get chains
    chains <- get_chains(x = colnames(get_clustirr_inputs(clust_irrs[[1]])$s))
    
    message("[2/3] joining graphs... \n")
    ige <- get_intergraph_edges(igs = igs, chains = chains, control = control)
    
    # get the vertices/edges of the graph
    df_v <- do.call(rbind, lapply(X = igs, FUN = get_v_e, what = "vertices"))
    df_e <- do.call(rbind, lapply(X = igs, FUN = get_v_e, what = "edges"))
    
    # these are the cols we want to keep in this order
    cols <- c("from", "to", "weight", "cweight", "nweight", "ncweight",
              "type", "chain")
    
    if(nrow(df_e)!=0) {
        if(is.null(ige)==FALSE && nrow(ige)!=0) {
            df_e <- rbind(df_e[, cols], ige[, cols])
        }
    } else {
        if(is.null(ige)==FALSE && nrow(ige)!=0) {
            df_e <- ige[, cols]
        }
    }
    
    message("[3/3] optimizing joint graph... \n")
    # delete duplicate edges (if any)
    key <- data.frame(pmin(df_e$from, df_e$to), 
                      pmax(df_e$from, df_e$to), df_e$chain)
    df_e <- df_e[!duplicated(key), ]
    
    # clean unused vars
    rm(igs, ige)
    
    # build joint graph
    g <- graph_from_data_frame(df_e, directed = FALSE, vertices = df_v)
    
    return(list(graph = g, clust_irrs = clust_irrs, multigraph = TRUE))
}


plot_graph <- function(g,
                       select_by = "Ag_species",
                       as_visnet = FALSE, 
                       show_singletons = TRUE,
                       node_opacity = 1) {
    
    check_graph <- function(g) {
        if(missing(g)) {
            stop("missing input g")
        }
        if(is.list(g)==FALSE) {
            stop("missing input g")
        }
        if(is_igraph(g$graph)==FALSE) {
            stop("wrong input g")
        }
        if(is.null(g$graph)) {
            stop("wrong input g")
        }
        if(is.logical(g$multigraph)==FALSE) {
            stop("wrong input g")
        }
    }
    
    check_graph(g = g)
    check_as_visnet(as_visnet = as_visnet)
    check_show_singletons(show_singletons = show_singletons)
    check_select_by(select_by = select_by)
    check_node_opacity(node_opacity = node_opacity)
    
    # unpack g
    ig <- g$graph
    cs <- igraph::as_data_frame(ig, what = "vertices")
    is_jg <- g$multigraph
    
    if(!show_singletons){
        k <- which(degree(ig) == 0 & V(ig)$clone_size <= 1)
        if(length(k)!=0) {
            ig <- delete_vertices(ig, k)
        }
    }
    
    ig <- config_vertices_plot(g = ig, is_jg = is_jg, 
                               node_opacity = node_opacity)
    if(as_visnet == FALSE) {
        plot(ig, vertex.label = NA)
    }
    if(as_visnet == TRUE) {
        V(ig)$size <- V(ig)$size*5
        if(length(E(ig))==0) {
            message("no edges found in the graph, dummy self-edge added")
            # apparently if no edges, visnetwork can't plot
            ig <- add_edges(graph = ig, edges = c(V(ig)[1],V(ig)[1]))
        } 
        else {
            if(all(E(ig)$width == 1)==FALSE) {
                E(ig)$width <- 2*(1/(1+exp(-(-6-0.1*E(ig)$weight))))
            }
        }
        
        vi <- visIgraph(igraph = ig,
                        idToLabel = TRUE,
                        layout = "layout_components",
                        randomSeed = 1234,
                        physics = FALSE,
                        smooth = FALSE,
                        type = "square")
        
        # set vertex titles -> CDR sequences
        chains <- get_chains(x = colnames(vi$x$nodes))
        vi$x$nodes$title <- apply(X = vi$x$nodes[, chains, drop = FALSE], 
                                  y = chains, 
                                  MARGIN = 1, FUN = function(x, y) {
                                      paste0(paste0("<b>", y, "</b>", ':', x), 
                                             collapse = '<br>')})
        
        u <- unique(unlist(strsplit(x=unique(cs[, select_by]),split = ',')))
        vi <- vi %>% visOptions(selectedBy = list(variable = select_by,
                                                  values = u,
                                                  multiple = TRUE))
        
        return(vi)
    }
}

get_intergraph_edges <- function(igs,
                                 chains,
                                 control) {

    get_igg <- function(x, ix, igs, control) {
        # prepare pair-rep data
        s1_name <- ix$name_i[x]
        s2_name <- ix$name_j[x]
        chain <- ix$chain[x]
        s1 <- igs[[ix$index_i[x]]]$clones
        s2 <- igs[[ix$index_j[x]]]$clones
        rm(igs)
        
        message("joining (", x, ") ", s1_name, ' and ', s2_name, "\n")

        s1$chain <- chain
        s1$cdr3 <- s1[, chain]
        s1 <- s1[is.na(s1$cdr3)==FALSE,]
        if(nrow(s1)==0) {
            return(NULL)
        }
        if(is.null(s1)) {
            return(NULL)
        }
        
        s2$chain <- chain
        s2$cdr3 <- s2[, chain]
        s2 <- s2[is.na(s2$cdr3)==FALSE,]
        if(nrow(s2)==0) {
            return(NULL)
        }
        if(is.null(s2)) {
            return(NULL)
        }
        
        b <- get_score_pair(s_from = s1, s_to = s2, control = control)
        
        if(is.null(b)==FALSE && nrow(b)!=0) {
            b$chain <- chain
            b$sample <- paste0(s1_name, "|", s2_name)
            b$type <- "between-repertoire"
            return(b)
        }
        
        return(NULL)
    }
    
    get_ix <- function(xs, ns, chains, control) {
        ixs <- c()
        for(c in chains) {
            if(control$knn==TRUE) {
                ix <- expand.grid(1:xs, 1:xs, KEEP.OUT.ATTRS = FALSE)
                colnames(ix) <- c("index_i", "index_j")
                ix <- ix[ix$index_i!=ix$index_j,]
                ix$name_i <- ns[ix$index_i]
                ix$name_j <- ns[ix$index_j]
                ix$chain <- c
                ixs <- rbind(ixs, ix)
            } else {
                ix <- subset(expand.grid(1:xs, 1:xs, KEEP.OUT.ATTRS = FALSE), 
                             Var1 < Var2)
                colnames(ix) <- c("index_i", "index_j")
                ix$name_i <- ns[ix$index_i]
                ix$name_j <- ns[ix$index_j]
                ix$chain <- c
                ixs <- rbind(ixs, ix)
            }
        }
        return(ixs)
    }
    
    # indices 
    ix <- get_ix(xs = length(igs), ns = names(igs), 
                 chains = chains, control = control)
    
    # find global similarities between pairs of clone tables
    message("merging clust_irrs: ", nrow(ix), "\n")
    ige <- lapply(X = seq_len(nrow(ix)),
                  ix = ix,
                  FUN = get_igg,
                  igs = igs,
                  control = control)
    ige <- do.call(rbind, ige)

    return(ige)
}

get_clones <- function(sample_id, s, meta) {
    s$name <- s$id
    s <- s[, rev(colnames(s))]
    
    # append s and meta
    if(is.null(meta)==FALSE & missing(meta)==FALSE) {
        cols <- intersect(colnames(s), colnames(meta))
        if(length(cols)!=0) {
            meta <- meta[, (colnames(meta) %in% cols)==FALSE, drop = FALSE]
        }
        if(ncol(meta)!=0) {
            s <- cbind(s, meta)
        }
    }
    
    return(s)
}

# Description:
# Compare the control lists of individual clust_irr objects. If they match,
# then extract the control list from one list.
get_joint_controls <- function(clust_irrs) {
    # if these tests pass -> extract controls of any of the elements
    for(i in 1:(length(clust_irrs)-1)) {
        for(j in (i+1):length(clust_irrs)) {
            c_i <- get_clustirr_inputs(clust_irrs[[i]])$control
            c_j <- get_clustirr_inputs(clust_irrs[[j]])$control
            
            if(length(c_i)!=length(c_j)) {
                stop("different controls used in individual clust_irrs")
            }
            
            c_ij <- vapply(X = names(c_i), c_i = c_i, c_j = c_j,
                           FUN = function(x, c_i, c_j) {
                               if(is.null(c_i[[x]]) & is.null(c_j[[x]])) {
                                   return(TRUE)
                               }
                               if(is.na(c_i[[x]]) & is.na(c_j[[x]])) {
                                   return(TRUE)
                               }
                               return(c_i[[x]]==c_j[[x]])}, 
                           FUN.VALUE = logical(1))
            
            if(any(c_ij==FALSE)) {
                stop("different controls used in individual clust_irrs")
            }
        } 
    }
    
    return(get_clustirr_inputs(x = clust_irrs[[1]])$control)
}

get_nrads <- function(community_occupancy_matrix, B = 1000) {
    
    check_inputs <- function(community_occupancy_matrix, B) {
        
        # check community_occupancy_matrix
        if(missing(community_occupancy_matrix)) {
            stop("community_occupancy_matrix must be a matrix")
        }
        if(is.matrix(community_occupancy_matrix)==FALSE) {
            stop("community_occupancy_matrix must be a matrix")
        }
        n <- ncol(community_occupancy_matrix)
        if(n==1) {
            stop("ncol(community_occupancy_matrix) must be >1")
        }
        
        # check B
        if(missing(B)) {
            stop("B must be a number > 0")
        }
        if(length(B)!=1) {
            stop("B must be a number > 0")
        }
        if(is.numeric(B)==FALSE) {
            stop("B must be a number > 0")
        }
        if(is.finite(B)==FALSE) {
            stop("B must be a number > 0")
        }
        if(B<=0) {
            stop("B must be a number > 0")
        }
    }
    
    check_inputs(community_occupancy_matrix = community_occupancy_matrix, B = B)
    
    rads <- apply(X = community_occupancy_matrix, MARGIN = 2, 
                  FUN = function(x) {return(sort(x, decreasing = TRUE))})
    max_rank <- min(apply(X = rads, MARGIN = 2, 
                          FUN = function(x) {sum(x!=0)}))
    
    nrads <- RADnormalization_matrix(input = t(rads), max_rank = max_rank, 
                                     average_over = B, sample_in_row = TRUE)
    
    nd <- nrads$norm_matrix
    rownames(nd) <- colnames(rads)
    nd <- reshape2::melt(nd)
    colnames(nd) <- c("rownames", "rank", "norm.abundance")
    nd$sample <- nd$rownames
    return(nd)
}

get_beta_violin_ag <- function(beta,
                               node_summary,
                               ag,
                               ag_species = TRUE,
                               db = "vdjdb") {
    if(ag_species) {
        h <- get_ag_species_hits(node_summary = node_summary, 
                                 db = db, 
                                 ag_species = ag)
    } else {
        h <- get_ag_gene_hits(node_summary = node_summary, 
                              db = db, 
                              ag_gene = ag)
    }
    
    
    h$node_summary$spec <- ifelse(
        test = apply(X=h$node_summary[,h$new_columns], MARGIN=1, FUN=sum)==0,
        yes = "-", no = "+")
    h <- h$node_summary
    h <- aggregate(clone_size~sample+spec+community, data = h, FUN = sum)
    dup <- which(h$community %in% h$community[h$spec=="+"] & h$spec=="-")
    if(length(dup)!=0) {
        h <- h[-dup,]
    }
    
    h$size <- ifelse(test = h$spec == "+", yes = h$clone_size, no = 1)
    o <- merge(x = h, y = beta, by = c("sample", "community"), all.x = TRUE)
    
    g <- ggplot(data = o)+
        geom_sina(aes(x = sample, y = mean, col = spec, size = size), 
                  stroke = 0.02, alpha = 0.4)+
        theme_bw(base_size = 10)+
        ggtitle(label = '', 
                subtitle = paste0("Ag=", ag, ", DB=", db))+
        ylab(label = expression(beta))+
        xlab(label = "repertoire")+
        scale_radius(name = "# cells", 
                     breaks = scales::pretty_breaks(n = 4),
                     range = c(1, 4))+
        scale_color_manual(name = "specificity", 
                           values = c("steelblue", "orange"))+
        guides(size = guide_legend(order = 2), 
               colour = guide_legend(order = 1))
    
    return(g)
}



get_beta_cprob_ag <- function(beta,
                              node_summary,
                              ag,
                              ag_species = TRUE,
                              db = "vdjdb") {
    
    getc <- function(x, h) {
        q <- h[h$sample == x, ]
        z <- cumsum(q$clone_size)
        p <- z/max(z)
        p[is.infinite(p)|is.nan(p)] <- 0
        return(data.frame(p = p, b = q$mean, sample = x))
    }
    
    if(ag_species) {
        h <- get_ag_species_hits(node_summary = node_summary, 
                                 db = db, 
                                 ag_species = ag)
    } else {
        h <- get_ag_gene_hits(node_summary = node_summary, 
                              db = db, 
                              ag_gene = ag)
    }
    
    h$node_summary$spec <- ifelse(
        test = apply(X = h$node_summary[,h$new_columns], MARGIN=1, FUN=sum)==0,
        yes = FALSE, no = TRUE)
    h <- h$node_summary
    h <- merge(x = h, y = beta, by = c("sample", "community"), all.x = TRUE)
    
    ha <- aggregate(clone_size~community+sample+mean+spec, data = h, FUN = sum)
    ha$clone_size[ha$spec == FALSE] <- 0
    ha <- ha[order(ha$mean, decreasing = TRUE),]
    ha <- do.call(rbind, lapply(X = unique(ha$sample), h = ha))
    colnames(ha) <- c("p_ag", "b", "sample")
    
    hb <- aggregate(clone_size~community+sample+mean, data = h, FUN = sum)
    hb <- hb[order(hb$mean, decreasing = TRUE),]
    hb <- do.call(rbind, lapply(X = unique(hb$sample), h = hb))
    colnames(hb) <- c("p_b", "b", "sample")
    
    hab <- merge(x = ha, y = hb, by = c("b", "sample"))
    hab <- hab[order(hab$b, decreasing = TRUE),]
    
    g <- ggplot(data = v)+
        facet_wrap(~sample)+
        geom_line(data = hab[order(hab$p_b, decreasing = TRUE),],
                  aes(x = b, y = p_b, col = Ag),
                  linetype = "dashed", size = .5, alpha = 0.7, col = "black")+
        geom_line(data = hab[order(hab$p_ag, decreasing = TRUE),],
                  aes(x = b, y = p_ag, col = Ag), size = .5, alpha = 0.7)+
        xlab(label = expression(beta))+
        ylab(label = "Cumulative probability")+
        scale_color_discrete(name = "Antigen")+
        theme(legend.position = "top", 
              strip.text.x = element_text(margin = margin(0.02,0,0.02,0, "cm")))
    
    return(list(data = hab, g = g))
}

get_cosine_similarity <- function(com) {
    n <- sqrt(colSums(com^2))
    cos_sim <- crossprod(com)/(n %o% n)
    colnames(cos_sim) <- colnames(com)
    rownames(cos_sim) <- colnames(com)
    cos_sim <- reshape2::melt(cos_sim, varnames = c("i", "j"), value.name="CS")
    
    g <- ggplot(data = cos_sim)+
        geom_tile(aes(x = i, y = j, fill = CS), col = "white")+
        geom_text(aes(x = i, y = j, label = round(CS, digits = 2)), 
                  size = 2.75, col = "black")+
        scale_fill_distiller(palette = "Spectral", 
                             limits = c(-0.01, 1.01),
                             breaks = c(0, 0.25, 0.5, 0.75, 1.0),
                             labels = c(0, 0.25, 0.5, 0.75, 1.0))+
        theme(legend.position = "right")+
        guides(fill = guide_colourbar(barheight = 5, barwidth = 0.5))+
        xlab(label = '')+
        ylab(label = '')
    
    return(list(g = g, cs = cos_sim))
}

# Download McPAS-TCR data
# McPAS-TCR - http://friedmanlab.weizmann.ac.il/McPAS-TCR/
t <- read.csv("McPAS-TCR.csv", sep = ",")
t <- t[, c("CDR3.alpha.aa", "CDR3.beta.aa", "Species", "Pathology",
           "Antigen.protein", "PubMed.ID")]
t <- t[duplicated(t)==FALSE, ]

colnames(t) <- c("CDR3a", "CDR3b", "CDR3_species", "Antigen_species",
                 "Antigen_gene", "Reference")

t$CDR3g <- NA
t$CDR3d <- NA
t$CDR3h <- NA
t$CDR3l <- NA

t <- t[, c("CDR3a", "CDR3b",
           "CDR3g", "CDR3d", 
           "CDR3h", "CDR3l", 
           "CDR3_species", "Antigen_species", 
           "Antigen_gene", "Reference")]

mcpas <- t
mcpas$Antigen_gene <- gsub(pattern = "\\|", replacement = ',', 
                           x = mcpas$Antigen_gene)
save(mcpas, file = "data/mcpas.RData", compress = T)

dco <- function(community_occupancy_matrix, 
                mcmc_control, 
                compute_delta = TRUE,
                groups = NA) {
    # check control
    mcmc_control <- process_mcmc_control(control_in = mcmc_control)
    
    n <- ncol(community_occupancy_matrix)
    if(n==1) {
        stop("ncol(community_occupancy_matrix) must be >1")
    }
    
    # check compute_delta
    if(missing(compute_delta)) {
        compute_delta <- TRUE
    }
    if(length(compute_delta)!=1) {
        stop("compute_delta must be logical")
    }
    if(is.logical(compute_delta)==FALSE) {
        stop("compute_delta must be logical")
    }
    compute_delta <- ifelse(test = compute_delta == TRUE, yes = 1, no = 0)
    
    
    # check groups
    if(missing(groups)) {
        groups <- NA
    }
    has_groups <- all(is.na(groups)==FALSE)
    if(has_groups) {
        if(length(groups)!=n) {
            stop("length(groups) != ncol(community_occupancy_matrix)")
        }
        if(all(is.numeric(groups))==FALSE) {
            stop("groups must integers")
        }
        if(all(1:max(groups) %in% groups)==FALSE) {
            stop("missing group in 1:max(groups)")
        }
    }
    
    # select normal or hierarchical model
    if(has_groups) {
        model <- stanmodels$dmh
        pars <- c("alpha", "beta", "beta_mu", "beta_sigma", 
                  "kappa", "y_hat", "log_lik")
        if(compute_delta == 1) {
            pars <- c("alpha", "beta", "beta_mu", "beta_sigma", "delta", 
                      "epsilon", "kappa", "y_hat", "log_lik")
        }
    } 
    else {
        model <- stanmodels$dm
        pars <- c("alpha", "beta", "kappa", "y_hat", "log_lik")
        if(compute_delta == 1) {
            pars <- c("alpha", "beta", "delta", "epsilon", 
                      "kappa", "y_hat", "log_lik")
        }
    }
    
    
    # fit
    message("[1/2] fit...")
    f <- sampling(object = model,
                  data = list(K = nrow(community_occupancy_matrix), 
                              N = n, 
                              y = t(community_occupancy_matrix),
                              G = groups,
                              compute_delta = compute_delta),
                  chains = mcmc_control$mcmc_chains, 
                  cores = mcmc_control$mcmc_cores, 
                  iter = mcmc_control$mcmc_iter, 
                  warmup = mcmc_control$mcmc_warmup,
                  control = list(adapt_delta = mcmc_control$adapt_delta,
                                 max_treedepth = mcmc_control$max_treedepth),
                  algorithm = mcmc_control$mcmc_algorithm,
                  include = TRUE,
                  pars = pars)
    
    # summaries
    message("[2/2] posterior summary...")
    s <- get_posterior_summaries(cm = community_occupancy_matrix, 
                                 f = f, 
                                 groups = groups,
                                 has_groups = has_groups,
                                 compute_delta = compute_delta)
    
    return(list(fit = f, 
                posterior_summary = s, 
                community_occupancy_matrix = community_occupancy_matrix, 
                mcmc_control = mcmc_control,
                compute_delta = compute_delta,
                groups = groups))
}


process_mcmc_control <- function(control_in) {
    
    check_mcmc_iter <- function(mcmc_iter,
                                mcmc_warmup) {
        
        if(length(mcmc_iter) != 1) {
            stop("mcmc_iter must be a positive integer")
        }
        if(length(mcmc_warmup) != 1) {
            stop("mcmc_warmup must be a positive integer")
        }
        
        if(is.numeric(mcmc_iter) == FALSE) {
            stop("mcmc_iter must be a positive integer")
        }
        if(is.numeric(mcmc_warmup) == FALSE) {
            stop("mcmc_warmup must be a positive integer")
        }
        
        if(is.finite(mcmc_iter) == FALSE) {
            stop("mcmc_iter must be a positive integer")
        }
        if(is.finite(mcmc_warmup) == FALSE) {
            stop("mcmc_warmup must be a positive integer")
        }
        
        if((abs(mcmc_iter - round(mcmc_iter)) 
            < .Machine$double.eps^0.5) == FALSE) {
            stop("mcmc_iter must be a positive integer")
        }
        if((abs(mcmc_warmup - round(mcmc_warmup)) 
            < .Machine$double.eps^0.5) == FALSE) {
            stop("mcmc_warmup must be a positive integer")
        }
        
        
        if(mcmc_iter <= mcmc_warmup) {
            stop("mcmc_iter must be larger than mcmc_warmup")
        }
    }
    
    check_mcmc_chains <- function(mcmc_chains) {
        if(length(mcmc_chains) != 1) {
            stop("mcmc_chains must be a positive integer")
        }
        
        if(!is.numeric(mcmc_chains)) {
            stop("mcmc_chains must be a positive integer")
        }
        
        if(is.finite(x = mcmc_chains) == FALSE) {
            stop("mcmc_chains must be a positive integer")
        }
        
        if(as.integer(x = mcmc_chains) <= 0) {
            stop("mcmc_chains must be a positive integer")
        }
    }
    
    check_mcmc_cores <- function(mcmc_cores) {
        if(length(mcmc_cores) != 1) {
            stop("mcmc_cores must be a positive integer")
        }
        
        if(is.numeric(mcmc_cores) == FALSE) {
            stop("mcmc_cores must be a positive integer")
        }
        
        if(is.finite(x = mcmc_cores) == FALSE) {
            stop("mcmc_cores must be a positive integer")
        }
        
        if(as.integer(x = mcmc_cores) <= 0) {
            stop("mcmc_cores must be a positive integer")
        }
    }
    
    check_adapt_delta <- function(adapt_delta) {
        if(length(adapt_delta) != 1) {
            stop("adapt_delta must be in the range between 0 and 1")
        }
        
        if(is.numeric(adapt_delta) == FALSE) {
            stop("adapt_delta must be in the range between 0 and 1")
        }
        
        if(is.finite(x = adapt_delta) == FALSE) {
            stop("adapt_delta must be in the range between 0 and 1")
        }
        
        if(adapt_delta<0 | adapt_delta>1) {
            stop("adapt_delta must be in the range between 0 and 1")
        }
    }
    
    check_max_treedepth <- function(max_treedepth) {
        if(length(max_treedepth) != 1) {
            stop("max_treedepth must be a positive integer")
        }
        
        if(is.numeric(max_treedepth) == FALSE) {
            stop("max_treedepth must be a positive integer")
        }
        
        if(is.finite(x = max_treedepth) == FALSE) {
            stop("max_treedepth must be a positive integer")
        }
        
        if((abs(max_treedepth - round(max_treedepth)) 
            < .Machine$double.eps^0.5) == FALSE) {
            stop("max_treedepth must be a positive integer")
        }
        
        if(as.integer(x = max_treedepth) <= 0) {
            stop("max_treedepth must be a positive integer")
        }
    }
    
    check_mcmc_algorithm <- function(mcmc_algorithm) {
        if(length(mcmc_algorithm) != 1) {
            stop("mcmc_algorithm must be set to NUTS")
        }
        
        if(is.character(mcmc_algorithm) == FALSE) {
            stop("mcmc_algorithm must be set to NUTS")
        }
        
        if(mcmc_algorithm!="NUTS") {
            stop("mcmc_algorithm must be set to NUTS")
        }
    }
    
    
    control <- list(mcmc_warmup = 750,
                    mcmc_iter = 1500,
                    mcmc_chains = 4,
                    mcmc_cores = 1,
                    mcmc_algorithm = "NUTS",
                    adapt_delta = 0.95,
                    max_treedepth = 12)
    
    # if missing control_in -> use default values
    if(missing(control_in) || is.null(control_in)) {
        return(control)
    }
    if(is.list(control_in) == FALSE) {
        stop("control must be a list")
    }
    if(all(names(control_in) %in% names(control)) == FALSE) {
        stop("unrecognized elements found in control")
    }
    
    ns <- names(control_in)
    for (i in seq_len(length(control_in))) {
        control[[ns[i]]] <- control_in[[ns[i]]]
    }
    
    
    check_mcmc_iter(mcmc_iter = control$mcmc_iter,
                    mcmc_warmup = control$mcmc_warmup)
    check_mcmc_chains(mcmc_chains = control$mcmc_chains)
    check_mcmc_cores(mcmc_cores = control$mcmc_cores)
    check_adapt_delta(adapt_delta = control$adapt_delta)
    check_max_treedepth(max_treedepth = control$max_treedepth)
    check_mcmc_algorithm(mcmc_algorithm = control$mcmc_algorithm)
    return(control)
}


get_posterior_summaries <- function(cm, 
                                    f, 
                                    compute_delta, 
                                    has_groups, 
                                    groups) {
    
    post_yhat <- function(f, samples) {
        
        s <- data.frame(summary(f, par = "y_hat")$summary)
        s <- s[, c("mean", "X50.", "X2.5.", "X97.5.", "n_eff", "Rhat")]
        colnames(s) <- c("mean", "median", "L95", "H95", "n_eff", "Rhat")

        # maintain original index order
        s$i <- 1:nrow(s)
        m <- rownames(s)
        m <- gsub(pattern = "y_hat\\[|\\]", replacement = '', x = m)
        
        m <- do.call(rbind, strsplit(x = m, split = "\\,"))
        s$s <- as.numeric(m[,1])
        s$community <- as.numeric(m[,2])
        meta <- data.frame(s = 1:length(samples), sample = samples)
        s <- merge(x = s, y = meta, by.x = "s", by.y = "s", all.x = TRUE)
        s <- s[order(s$i, decreasing = FALSE),]
        
        return(s)
    }
    
    post_alpha <- function(f) {
        
        s <- data.frame(summary(f, par = "alpha")$summary)
        s <- s[, c("mean", "X50.", "X2.5.", "X97.5.", "n_eff", "Rhat")]
        colnames(s) <- c("mean", "median", "L95", "H95", "n_eff", "Rhat")
        
        m <- rownames(s)
        m <- gsub(pattern = paste0("alpha\\[|\\]"), replacement = '', x = m)
        s$community <- as.numeric(m)
        return(s)
    }
    
    post_beta <- function(f, samples) {
        
        s <- data.frame(summary(f, par = "beta")$summary)
        s <- s[, c("mean", "X50.", "X2.5.", "X97.5.", "n_eff", "Rhat")]
        colnames(s) <- c("mean", "median", "L95", "H95", "n_eff", "Rhat")
        
        # maintain original index order
        s$i <- 1:nrow(s)
        m <- rownames(s)
        m <- gsub(pattern = "beta\\[|\\]", replacement = '', x = m)
        
        m <- do.call(rbind, strsplit(x = m, split = "\\,"))
        s$s <- as.numeric(m[,1])
        s$community <- as.numeric(m[,2])
        meta <- data.frame(s = 1:length(samples), sample = samples)
        s <- merge(x = s, y = meta, by.x = "s", by.y = "s", all.x = TRUE)
        s <- s[order(s$i, decreasing = FALSE),]
        
        return(s)
    }
    
    post_sample <- function(f, par) {
        
        s <- data.frame(summary(f, par = par)$summary)
        s <- s[, c("mean", "X50.", "X2.5.", "X97.5.", "n_eff", "Rhat")]
        colnames(s) <- c("mean", "median", "L95", "H95", "n_eff", "Rhat")
        
        m <- rownames(s)
        m <- gsub(pattern = paste0(par,"\\[|\\]"), replacement = '', x = m)
        
        s$s <- as.numeric(m)
        meta <- data.frame(s = 1:length(samples), sample = samples)
        s <- merge(x = s, y = meta, by.x = "s", by.y = "s", all.x = TRUE)
        
        return(s)
    }
    
    post_kappa <- function(f, has_groups) {
        s <- data.frame(summary(f, par = "kappa")$summary)
        s <- s[, c("mean", "X50.", "X2.5.", "X97.5.", "n_eff", "Rhat")]
        colnames(s) <- c("mean", "median", "L95", "H95", "n_eff", "Rhat")
        s$par <- rownames(s)
        
        if(has_groups==FALSE) {
            return(s)
        } 
        else {
            s$i <- 1:nrow(s)
            m <- rownames(s)
            m <- gsub(pattern = "kappa\\[|\\]", replacement = '', x = m)
            s$g <- as.numeric(m)
            return(s)
        }
    }
    
    post_betamu <- function(f, has_groups) {
        if(has_groups==FALSE) {
            return(NA)
        }
        
        s <- data.frame(summary(f, par = "beta_mu")$summary)
        s <- s[, c("mean", "X50.", "X2.5.", "X97.5.", "n_eff", "Rhat")]
        colnames(s) <- c("mean", "median", "L95", "H95", "n_eff", "Rhat")
        
        # maintain original index order
        s$i <- 1:nrow(s)
        m <- rownames(s)
        m <- gsub(pattern = "beta\\_mu\\[|\\]", replacement = '', x = m)
        
        m <- do.call(rbind, strsplit(x = m, split = "\\,"))
        s$g <- as.numeric(m[,1])
        s$community <- as.numeric(m[,2])
        
        return(s)
    }
    
    post_betasigma <- function(f, has_groups) {
        if(has_groups==FALSE) {
            return(NA)
        }
        s <- data.frame(summary(f, par = "beta_sigma")$summary)
        s <- s[, c("mean", "X50.", "X2.5.", "X97.5.", "n_eff", "Rhat")]
        colnames(s) <- c("mean", "median", "L95", "H95", "n_eff", "Rhat")
        m <- rownames(s)
        m <- gsub(pattern = "beta\\_sigma\\[|\\]", replacement = '', x = m)
        s$group <- as.numeric(m)
        return(s)
    }
    
    post_delta <- function(f, samples, compute_delta, par, pmaxv) {
        if(compute_delta==0) {
            return(NA)
        }
        
        get_meta <- function(samples) {
            m <- c()
            k <- 1
            for(i in 1:(length(samples)-1)) {
                for(j in (i+1):length(samples)) {
                    m <- rbind(m, data.frame(k = k, 
                                             sample_1 = samples[i],
                                             sample_2 = samples[j]))
                    k <- k + 1
                }   
            }
            m$contrast <- paste0(m$sample_1, '-', m$sample_2)
            return(m)
        }
        
        meta <- get_meta(samples = samples)
        
        # pmax
        p <- as_draws(f)
        p <- subset_draws(p, variable = par)
        p <- summarise_draws(p, pmax =~2*max(mean(.>=pmaxv), mean(.<=pmaxv))-1)
        m <- gsub(pattern = paste0(par,"\\[|\\]"), replacement = '', 
                  x = p$variable)
        m <- do.call(rbind, strsplit(x = m, split = "\\,"))
        p$k <- as.numeric(m[,1])
        p$community <- as.numeric(m[,2])
        
        # main summary
        s <- data.frame(summary(f, par = par)$summary)
        s <- s[, c("mean", "X50.", "X2.5.", "X97.5.", "n_eff", "Rhat")]
        colnames(s) <- c("mean", "median", "L95", "H95", "n_eff", "Rhat")
        
        # maintain original index order
        s$i <- 1:nrow(s)
        m <- rownames(s)
        m <- gsub(pattern = paste0(par,"\\[|\\]"), replacement = '', x = m)
        m <- do.call(rbind, strsplit(x = m, split = "\\,"))
        s$k <- as.numeric(m[,1])
        s$community <- as.numeric(m[,2])
        
        
        s <- merge(x = s, y = p[,c("k", "community", "pmax")], 
                   by = c("k", "community"))
        s <- merge(x = s, y = meta, by.x = "k", by.y = "k", all.x = TRUE)
        s <- s[order(s$i, decreasing = FALSE),]
        s$i <- NULL
        
        
        # get reverse effects
        sr <- s
        sr$mean <- sr$mean*-1
        sr$median <- sr$median*-1
        x <- sr$L95*-1
        y <- sr$H95*-1
        sr$L95 <- y
        sr$H95 <- x
        x <- sr$sample_1
        y <- sr$sample_2
        sr$sample_2 <- x
        sr$sample_1 <- y
        
        s <- rbind(s, sr)
        s$contrast <- paste0(s$sample_1, '-', s$sample_2)
        
        return(s)
    }
    
    post_deltamu <- function(f, groups, compute_delta, par, pmaxv) {
        if(compute_delta==0) {
            return(NA)
        }
        
        get_meta <- function(groups) {
            m <- c()
            k <- 1
            for(i in 1:(length(groups)-1)) {
                for(j in (i+1):length(groups)) {
                    m <- rbind(m, data.frame(k = k, 
                                             group_1 = groups[i],
                                             group_2 = groups[j]))
                    k <- k + 1
                }   
            }
            m$contrast <- paste0(m$group_1, '-', m$group_2)
            return(m)
        }
        
        meta <- get_meta(groups = groups)
        
        # pmax
        p <- as_draws(f)
        p <- subset_draws(p, variable = par)
        p <- summarise_draws(p, pmax =~2*max(mean(.>=pmaxv), mean(.<=pmaxv))-1)
        m <- gsub(pattern = paste0(par,"\\[|\\]"), replacement = '', 
                  x = p$variable)
        m <- do.call(rbind, strsplit(x = m, split = "\\,"))
        p$k <- as.numeric(m[,1])
        p$community <- as.numeric(m[,2])
        
        # main summary
        s <- data.frame(summary(f, par = par)$summary)
        s <- s[, c("mean", "X50.", "X2.5.", "X97.5.", "n_eff", "Rhat")]
        colnames(s) <- c("mean", "median", "L95", "H95", "n_eff", "Rhat")
        
        # maintain original index order
        s$i <- 1:nrow(s)
        m <- rownames(s)
        m <- gsub(pattern = paste0(par,"\\[|\\]"), replacement = '', x = m)
        m <- do.call(rbind, strsplit(x = m, split = "\\,"))
        s$k <- as.numeric(m[,1])
        s$community <- as.numeric(m[,2])
        
        
        s <- merge(x = s, y = p[,c("k", "community", "pmax")], 
                   by = c("k", "community"))
        s <- merge(x = s, y = meta, by.x = "k", by.y = "k", all.x = TRUE)
        s <- s[order(s$i, decreasing = FALSE),]
        s$i <- NULL
        
        
        # get reverse effects
        sr <- s
        sr$mean <- sr$mean*-1
        sr$median <- sr$median*-1
        x <- sr$L95*-1
        y <- sr$H95*-1
        sr$L95 <- y
        sr$H95 <- x
        x <- sr$group_1
        y <- sr$group_2
        sr$group_2 <- x
        sr$group_1 <- y
        
        s <- rbind(s, sr)
        s$contrast <- paste0(s$group_1, '-', s$group_2)
        
        return(s)
    }
    
    samples <- colnames(cm)
    groups <- unique(groups)
    
    o <- list(beta = post_beta(f = f, samples = samples),
              beta_mu = post_betamu(f = f, has_groups = has_groups),
              beta_sigma = post_betasigma(f = f, has_groups = has_groups),
              alpha = post_alpha(f = f),
              y_hat = post_yhat(f = f, samples = samples),
              kappa = post_kappa(f = f, has_groups = has_groups))
    
    # compute delta
    if(has_groups==FALSE) {
        o[["delta"]] <- post_delta(f = f, samples = samples, 
                                   compute_delta = compute_delta, 
                                   par = "delta", pmaxv = 0)
        o[["epsilon"]] <- post_delta(f = f, samples = samples,
                                     compute_delta = compute_delta, 
                                     par = "epsilon", pmaxv = 0)
    } else {
        o[["delta"]] <- post_deltamu(f = f, groups = groups, 
                                     compute_delta = compute_delta, 
                                     par = "delta", pmaxv = 0)
        o[["epsilon"]] <- post_deltamu(f = f, groups = groups,
                                       compute_delta = compute_delta, 
                                       par = "epsilon", pmaxv = 0)
    }
    o$y_hat$y_obs <- c(cm)
    
    return(o)
}

## ----include=FALSE------------------------------------------------------------
knitr::opts_chunk$set(comment = "", warning = FALSE, message = FALSE)

## -----------------------------------------------------------------------------
library(knitr)
library(ClustIRR)
library(ggplot2)
library(patchwork)
library(ggforce)
library(rBLAST)
theme_set(new = theme_bw(base_size = 10))

## ----include = FALSE----------------------------------------------------------
# only run code if blast+ is installed
run <- has_blast()

## ----echo = FALSE, eval = !run, results='asis'--------------------------------
cat("**Note: BLAST was not installed when this vignette was built!**")

## ----eval=run-----------------------------------------------------------------
# # System requirements
# #  The BLAST+ software needs to be installed on your system. Installation
# # instructions are available in this package's
# # [INSTALL](https://github.com/mhahsler/rBLAST/blob/devel/INSTALL) file and
# # at \url{https://www.ncbi.nlm.nih.gov/books/NBK569861/}.
# 
# # R needs to be able to find the executable. After installing the software,
# # try in R
# Sys.which("blastp")
# 
# # If the command returns "" instead of the path to the executable,
# # then you need to set the environment variable called PATH. In R
# Sys.setenv(PATH = paste(Sys.getenv("PATH"),
#    "path_to_your_BLAST_installation", sep=.Platform$path.sep))

## ----eval=run-----------------------------------------------------------------
# data("D2", package = "ClustIRR")

## ----eval=run-----------------------------------------------------------------
# cl <- clustirr(s = D2, control = list(blast_gmi = 0.8))

## ----eval=run-----------------------------------------------------------------
# gcd <- detect_communities(graph = cl$graph,
#                           algorithm = "leiden",
#                           metric = "average",
#                           resolution = 1,
#                           iterations = 100,
#                           chains = c("CDR3a", "CDR3b"))

## ----eval=run-----------------------------------------------------------------
# dim(gcd$community_occupancy_matrix)

## ----fig.width=8, fig.height=9, eval=run--------------------------------------
# honeycomb <- get_honeycombs(com = gcd$community_occupancy_matrix)
# wrap_plots(honeycomb, nrow = 5, ncol = 3)+
#     plot_annotation(tag_levels = 'A')

## ----eval=run-----------------------------------------------------------------
# d <- dco(community_occupancy_matrix = gcd$community_occupancy_matrix,
#          groups = c(1, 1, 1, 2, 2, 2),
#          mcmc_control = list(mcmc_warmup = 300,
#                              mcmc_iter = 600,
#                              mcmc_chains = 2,
#                              mcmc_cores = 1,
#                              mcmc_algorithm = "NUTS",
#                              adapt_delta = 0.9,
#                              max_treedepth = 10))

## ----fig.width=6, fig.height=3, eval=run--------------------------------------
# ggplot(data = d$posterior_summary$beta)+
#     geom_sina(aes(x = sample, y = mean))|
#     ggplot(data = d$posterior_summary$beta_mu)+
#     geom_sina(aes(x = as.character(g), y = mean))

## ----fig.width=7, fig.height=3, eval=run--------------------------------------
# ggplot(data = d$posterior_summary$epsilon)+
#     facet_wrap(facets = ~contrast, ncol = 2)+
#     geom_errorbar(aes(x = community, y = mean, ymin = L95, ymax = H95),
#                   col = "lightgray", width = 0)+
#     geom_point(aes(x = community, y = mean), shape = 21, fill = "black",
#                stroke = 0.4, col = "white", size = 1.25)+
#     theme(legend.position = "top")+
#     ylab(label = expression(delta))+
#     scale_x_continuous(expand = c(0,0))

# Description:
# find components, cliques, subgraphs in a community
decode_community <- function(community_id,
                             graph, 
                             edge_filter = NULL,
                             node_filter = NULL) {
    
    check_graph(graph = graph)
    check_community_id(graph = graph, community_id = community_id)
    check_edge_filter(edge_filter = edge_filter, graph = graph)
    check_node_filter(node_filter = node_filter, graph = graph)
    check_node_and_edges_filter(node_filter = node_filter,
                                edge_filter = edge_filter)
    
    # subset graph
    graph <- subgraph(graph = graph, vids = V(graph)$community == community_id)
    
    graph <- filter_edges(g = graph, edge_filter = edge_filter)
    graph <- filter_nodes(g = graph, node_filter = node_filter)
    return(graph)
}

decode_all_communities <- function(graph, 
                                   edge_filter = NULL, 
                                   node_filter = NULL) {
    check_graph(graph = graph)
    check_edge_filter(edge_filter = edge_filter, graph = graph)
    check_node_filter(node_filter = node_filter, graph = graph)
    check_node_and_edges_filter(node_filter = node_filter,
                                edge_filter = edge_filter)
    
    cs <- unique(V(graph)$community)
    o <- lapply(X = cs, 
                FUN = decode_community, 
                graph = graph, 
                edge_filter = edge_filter,
                node_filter = node_filter)
    names(o) <- cs
    return(o)
}

get_component_stats <- function(x) {
    
    # what is he
    community_id <- V(x)$community[1]
    
    # number of nodes per component
    count_n <- table(V(x)$component_id)
    
    # components has more than one node
    i <- which(count_n>1)
    stats_components <- c()
    if(length(i)>0) {
        stats_components <- lapply(X = names(i), g = x, FUN = function(x, g) {
            o <- subgraph(g, vids = which(V(g)$component_id==x))
            
            ncweight <- E(o)$ncweight
            if(length(ncweight)==0) {
                ncweight <- NA
            }
            nweight <- E(o)$nweight
            if(length(nweight)==0) {
                nweight <- NA
            }
            
            return(data.frame(component_id = x,
                              community = V(o)$community[1],
                              mean_ncweight = mean(ncweight),
                              mean_nweight = mean(nweight),
                              n_nodes = length(o),
                              n_edges = length(E(o)),
                              n_clique_edges = length(o)*(length(o)-1)/2,
                              diameter = diameter(o)))
        })
        stats_components <- do.call(rbind, stats_components)
    }
    
    i <- which(count_n==1)
    stats_singletons <- c()
    if(length(i)>0) {
        stats_singletons <- data.frame(component_id = names(i),
                                       community = community_id,
                                       mean_ncweight = NA,
                                       mean_nweight = NA,
                                       n_nodes = 1,
                                       n_edges = 0,
                                       n_clique_edges = 0,
                                       diameter = 0)
    }
    
    return(rbind(stats_components, stats_singletons))
}

check_graph <- function(graph) {
    if(missing(graph)) {
        stop("missing graph")
    }
    if(is_igraph(graph)==FALSE) {
        stop("graph is not igraph")
    }
    if(any(vertex_attr_names(graph)=="community")==FALSE) {
        stop("no community as node attribute in graph")
    }
    if(is.null(vertex_attr(graph = graph, name = "community"))) {
        stop("no community as node attribute in graph")
    }
}

check_community_id <- function(community_id, 
                               graph) {
    if(missing(community_id)) {
        stop("no community_id")
    }
    if(length(community_id)!=1) {
        stop("community_id must have length one")
    }
    if(is.numeric(community_id)==FALSE) {
        stop("community_id is not numeric")
    }
    if(community_id<0) {
        stop("community_id is negative")
    }
    if(is.infinite(community_id)) {
        stop("community_id is infinite")
    }
    j <- which(vertex_attr(graph = graph, name = "community")==community_id)
    if(length(j)==0) {
        stop("input community_id not found in graph")
    }
}

check_edge_filter <- function(edge_filter,
                              graph) {
    if(missing(edge_filter)|is.null(edge_filter)) {
        warning("no edge_filter")
    } 
    else {
        if(is.data.frame(edge_filter)==FALSE) {
            stop("edge_filter provided but not data frame")  
        }
        if(nrow(edge_filter)==0) {
            stop("edge_filter provided but no rows")  
        }
        if(!all(colnames(edge_filter) %in% c("name", "value", "operation"))) {
            stop("edge_filter columns must be: name, value and operation")
        }
        if(!all(edge_filter$operation %in% c("<",">",">=","<=","==","!="))) {
            stop("allowed edge_filter operation: <, >, >=, <=, ==, !=")
        }
        if(any(is.character(edge_filter$name)==FALSE)) {
            stop("edge_filter name must be character")
        }
        if(any(is.character(edge_filter$name)==FALSE)) {
            stop("edge_filter name must be character")
        }
        if(any(is.numeric(edge_filter$value)==FALSE)) {
            stop("edge_filter value must be numeric")
        }
        if(any(is.infinite(edge_filter$value)==TRUE)) {
            stop("edge_filter value must be numeric")
        }
        
        # graph
        if(!all(edge_filter$name %in% edge_attr_names(graph = graph))) {
            stop("some edge_filter names not found as edge attributes in graph")
        }
    }
}

check_node_filter <- function(node_filter, 
                              graph) {
    if(missing(node_filter)|is.null(node_filter)) {
        warning("no node_filter")
    } 
    else {
        if(is.data.frame(node_filter)==FALSE) {
            stop("node_filter provided but not data frame")  
        }
        if(nrow(node_filter)==0) {
            stop("node_filter provided but no rows")  
        }
        if(!all(colnames(node_filter) %in% c("name"))) {
            stop("node_filter columns must be: name")
        }
        if(any(is.character(node_filter$name)==FALSE)) {
            stop("node_filter name must be character")
        }
        if(any(is.character(node_filter$name)==FALSE)) {
            stop("node_filter name must be character")
        }
        
        # graph
        if(!all(node_filter$name %in% vertex_attr_names(graph = graph))) {
            stop("some node_filter names not found as node attributes in graph")
        }
    }
}

check_node_and_edges_filter <- function(node_filter,
                                        edge_filter) {
    
    if(missing(node_filter) & missing(edge_filter)) {
        stop("no nodes AND edge filter provided")
    }
}

apply_filter_op <- function(vec, op, val) {
    ops <- list("==" = `==`,
                "!=" = `!=`,
                "<"  = `<`,
                ">"  = `>`,
                "<=" = `<=`,
                ">=" = `>=`)
    
    if (!op %in% names(ops)) {
        stop("Invalid operator, choose: '==', '!=', '<', '>', '<=', '>='")
    }
    
    return(ops[[op]](vec, val))
}

filter_edges <- function(g, 
                         edge_filter) {
    if(is.null(edge_filter)==FALSE) {
        etm <- matrix(data = 0, nrow = nrow(edge_filter), ncol = length(E(g)))
        for(i in seq_len(nrow(edge_filter))) {
            a_n <- edge_filter$name[i]
            a_v <- edge_filter$value[i]
            a_o <- edge_filter$operation[i]
            
            j <- which(edge_attr_names(g) == a_n)
            if(length(j) != 0) {
                v <- edge_attr(graph = g, name = a_n)
                etm[i,] <- apply_filter_op(vec = v, val = a_v, op = a_o)
            }
        }
        etm <- apply(X = etm, MARGIN = 2, FUN = prod)
        i <- which(etm == FALSE)
        if(length(i) != 0) {
            g <- delete_edges(graph = g, edges = i)
        }
    }
    return(g)
}

filter_nodes <- function(g, 
                         node_filter) {
    if(is.null(node_filter)==FALSE) {
        vs <- as_data_frame(x = g, what = "vertices")
        V(g)$key <- apply(X = vs[, node_filter$name, drop=FALSE], 
                          MARGIN = 1, FUN = paste, collapse = '|')
        
        sgs <- lapply(X = unique(V(g)$key), g = g, 
                      FUN = function(x, g) {
                          sg <- subgraph(graph = g, vids = which(V(g)$key == x))
                          
                          V(sg)$components <- components(graph = sg)$membership
                          V(sg)$component_id <- paste0(V(sg)$key, '|', 
                                                       V(sg)$components)
                          return(disjoint_union(lapply(
                              X = unique(V(sg)$component_id), g = sg, 
                              FUN = function(x, g) {
                                  vids <- which(V(g)$component_id == x)
                                  return(subgraph(graph = g, vids = vids))
                              })))
                      })
        sgs <- disjoint_union(sgs)
        V(sgs)$component_id <- as.numeric(as.factor(V(sgs)$component_id))
        
        sgs_stat <- get_component_stats(x = sgs)
        vs <- as_data_frame(x = sgs, what = "vertices")
        
        return(list(community_graph = sgs, 
                    component_stats = sgs_stat,
                    node_summary = vs))
    } 
    else {
        sgs <- lapply(
            X = unique(V(g)$community), g = g, 
            FUN = function(x, g) {
                # get a subgraph with shared node attributes
                sg <- subgraph(graph = g, vids = which(V(g)$community == x))
                
                # find connected components
                V(sg)$components <- components(graph = sg)$membership
                V(sg)$component_id <- paste0(V(sg)$community, '|', 
                                             V(sg)$components)
                V(sg)$component_id <- as.numeric(as.factor(V(sg)$component_id))
                return(disjoint_union(lapply(
                    X = unique(V(sg)$component_id), g = sg, 
                    FUN = function(x, g) {
                        vids <- which(V(g)$component_id == x)
                        return(subgraph(graph = g, vids = vids))
                    })))
            })
        sgs <- disjoint_union(sgs)
        
        sgs_stat <- get_component_stats(x = sgs)
        
        vs <- as_data_frame(x = sgs, what = "vertices")
        
        return(list(community_graph = sgs, 
                    component_stats = sgs_stat,
                    node_summary = vs))
    }
}

get_honeycombs <- function(com) {
    n <- ncol(com)
    gs <- vector(mode = "list", length = n*(n-1)/2)
    iter <- 1
    for(i in seq_len(ncol(com)-1)) {
        for(j in (i+1):ncol(com)) {
            
            m <- data.frame(x = com[,i], 
                            y = com[,j], 
                            community = seq_len(nrow(com)),
                            sample_1 = colnames(com)[i], 
                            sample_2 = colnames(com)[j],
                            contrast = paste0(colnames(com)[i], "-", colnames(com)[j]),
                            title = paste0(colnames(com)[i], ' (x) vs ', 
                                           colnames(com)[j], " (y)"))
            
            m$x_adj <- ifelse(test = m$x==0, yes = m$x+0.5, no = m$x)
            m$y_adj <- ifelse(test = m$y==0, yes = m$y+0.5, no = m$y)
            
            gs[[iter]] <- ggplot(data = m)+
                facet_wrap(facets = ~title)+
                geom_hex(aes(x = x_adj, y = y_adj, fill=log10(..count..)), 
                         col = "white", bins = 5)+
                geom_abline(slope = 1, intercept = 0, linetype = "dashed")+
                geom_point(aes(x = x_adj, y = y_adj), 
                           alpha = 0.75, size = 0.5, stroke = 0.3)+
                scale_x_continuous(name = "x", trans = "log10")+
                scale_y_continuous(name = "y", trans = "log10")+
                annotation_logticks(base = 10, sides = "lb")+
                scale_fill_gradient(name = "log10(C)",
                                    low = "white", high = "#FFC68A")+
                theme_bw(base_size = 10)+
                theme(legend.position = "right",
                      strip.text.x = element_text(
                          margin = margin(0.04,0,0.04,0, "cm")))
            
            iter <- iter + 1
        }
    }
    
    return(gs)
}

get_cdr3_motifs <- function(node_summary, community_id, gap_remove_prob = 0.8) {
    
    
    chains <- get_chains(colnames(node_summary))
    
    i <- which(node_summary$community == community_id)
    if(length(i)==0) {
        stop("community not found")
    }
    else if(length(i)==1) {
        stop(paste0("community has only one clonotype: ", 
                    node_summary[, c(chains, clone_size)]))
    } else {
        gs <- lapply(X = chains, FUN = get_motif, 
                     node_summary = node_summary[i, ],
                     gap_remove_prob = gap_remove_prob)
        return(patchwork::wrap_plots(gs, nrow = 1))
    }
}

get_motif <- function(chain, node_summary, gap_remove_prob) {
    cdrs <- node_summary[,chain]
    cells <- node_summary[,"clone_size"]
    
    i <- which(is.na(cdrs))
    if(length(i)!=0) {
        cdrs <- cdrs[-i]
        cells <- cells[-i]
        if(length(cdrs)==0) {
            warning("no CDRs after removing NAs")
            return(ggplot() + theme_bw())
        }
    }
    
    # remove gaps if they exceed specific threshold on position
    aln <- msa::msaClustalOmega(inputSeqs = AAStringSet(cdrs), type = "protein")
    aln <- as.character(aln)
    alnm <- do.call(rbind, strsplit(aln, split = ""))
    gap_rm <- apply(X = alnm, MARGIN = 2, gap = gap_remove_prob, 
                    FUN = function(x, gap) {
        return(sum(x=="-")/length(x) >= gap)
    })
    if(any(gap_rm)) {
        alnm <- alnm[, -which(gap_rm), drop = FALSE]
    }
    aln <- apply(alnm, 1, paste0, collapse = "")
    
    g <- ggseqlogo(aln, seq_type = 'aa', method = "probability")+
        theme_logo(base_size = 10)+
        theme(legend.position = "none")+
        scale_y_continuous(breaks = c(0, 0.5, 1), labels = c(0, 0.5, 1))
    
    return(g)
}

# This script describes how to download and prepare the small example
# dataset of human CD8+ T cells. The original data is publicly available
# at http://50.255.35.37:8080/

# download data (last tested on 09 January 2025)
utils::download.file(url = "http://50.255.35.37:8080/downloads/human_v2.0.zip",
                     destfile = "human_v2.0.zip")

# unzip
utils::unzip(zipfile = "human_v2.0.zip", exdir = ".")

# human (hs) CD8
CD8 <- read.csv(file = "human_v2.0/ref_CD8_v2.0.txt", sep = "\t",
                header = FALSE)

set.seed(seed = 1234321)
CDR3b <- CD8[sample(x = 1:nrow(CD8), size = 10^4, replace = FALSE), ]
colnames(CDR3b) <- c("CDR3b", "TRBV", "TRBJ")

set.seed(seed = 1245421)
CDR3a <- CD8[sample(x = 1:nrow(CD8), size = 10^4, replace = FALSE), ]
colnames(CDR3a) <- c("CDR3a", "TRAV", "TRAJ")

# create dummy CDR3ab
CDR3ab <- cbind(CDR3a, CDR3b)
CDR3ab$TRAV <- gsub(pattern = "TRB", replacement = "TRA", x = CDR3ab$TRAV)
CDR3ab$TRAJ <- gsub(pattern = "TRB", replacement = "TRA", x = CDR3ab$TRAJ)
save(CDR3ab, file = "data/CDR3ab.RData", compress = "xz")


##### Dataset D1: TCRab repertoires 'a', 'b', and 'c' with n=500 #####
# repertoire size
n <- 500

# a
a <- data.frame(CDR3a = CDR3ab$CDR3a[1:n], 
                CDR3b = CDR3ab$CDR3b[1:n], 
                sample = "a")

# metadata a
ma <- data.frame(clone_id = 1:n, 
                 cell = sample(x = c("CD8", "CD4"), replace = TRUE, size = n),
                 HLA_A = "HLA-A∗24",
                 age = 24,
                 TRAV = CDR3ab$TRAV[1:n],
                 TRAJ = CDR3ab$TRAJ[1:n],
                 TRBV = CDR3ab$TRBV[1:n],
                 TRBJ = CDR3ab$TRBJ[1:n])
                 
# b
b <- data.frame(CDR3a = CDR3ab$CDR3a[1:n], 
                CDR3b = CDR3ab$CDR3b[1:n], 
                sample = "b")

# metadata b
mb <- data.frame(clone_id = 1:n, 
                 cell = sample(x = c("CD8", "CD4"), replace = TRUE, size = n),
                 HLA_A = "HLA-A∗02",
                 age = 30,
                 TRAV = CDR3ab$TRAV[1:n],
                 TRAJ = CDR3ab$TRAJ[1:n],
                 TRBV = CDR3ab$TRBV[1:n],
                 TRBJ = CDR3ab$TRBJ[1:n])

# c
c <- data.frame(CDR3a = CDR3ab$CDR3a[1:n], 
                CDR3b = CDR3ab$CDR3b[1:n], 
                sample = "c")

# metadata c
mc <- data.frame(clone_id = 1:n, 
                 cell = sample(x = c("CD8", "CD4"), replace = TRUE, size = n),
                 HLA_A = "HLA-A∗11",
                 age = 40,
                 TRAV = CDR3ab$TRAV[1:n],
                 TRAJ = CDR3ab$TRAJ[1:n],
                 TRBV = CDR3ab$TRBV[1:n],
                 TRBJ = CDR3ab$TRBJ[1:n])


get_clonal_expansion <- function(n, p_expanded) {
    s <- sample(x = c(0, 1), size = n, prob = c(1-p_expanded, 
                                                p_expanded), replace = T)
    y <- vapply(X = s, FUN.VALUE = numeric(1), FUN = function(x) {
        if(x == 0) {
            return(rpois(n = 1, lambda = 0.5))
        }
        return(rpois(n = 1, lambda = 50))
    })
    return(y)
}

# simulate expansion of specific communities
set.seed(1243)
clone_size <- rpois(n = n, lambda = 3)+1
expansion_factor <- get_clonal_expansion(n = n, p_expanded = 0.02)

a$clone_size <- clone_size
b$clone_size <- clone_size+expansion_factor*1
c$clone_size <- clone_size+expansion_factor*2

D1 <- list(a = a, b = b, c = c, ma = ma, mb = mb, mc = mc)
save(D1, file = "data/D1.RData", compress = "xz")
rm(a, b, c, ma, mb, mc)




set.seed(12341)
A1 <- D1$a[sample(x = 1:nrow(D1$a), size = 2000, replace = TRUE, prob = D1$a$clone_size/sum(D1$a$clone_size)),]
A1$sample <- "A1"
set.seed(12342)
A2 <- D1$a[sample(x = 1:nrow(D1$a), size = 2000, replace = TRUE, prob = D1$a$clone_size/sum(D1$a$clone_size)),]
A2$sample <- "A2"
set.seed(12343)
A3 <- D1$a[sample(x = 1:nrow(D1$a), size = 2000, replace = TRUE, prob = D1$a$clone_size/sum(D1$a$clone_size)),]
A3$sample <- "A3"
A <- rbind(A1, A2, A3)
rm(A1, A2, A3)

set.seed(12344)
C1 <- D1$c[sample(x = 1:nrow(D1$c), size = 2000, replace = TRUE, prob = D1$c$clone_size/sum(D1$c$clone_size)),]
C1$sample <- "C1"
set.seed(12345)
C2 <- D1$c[sample(x = 1:nrow(D1$c), size = 2000, replace = TRUE, prob = D1$c$clone_size/sum(D1$c$clone_size)),]
C2$sample <- "C2"
set.seed(12346)
C3 <- D1$c[sample(x = 1:nrow(D1$c), size = 2000, replace = TRUE, prob = D1$c$clone_size/sum(D1$c$clone_size)),]
C3$sample <- "C3"
C <- rbind(C1, C2, C3)

D2 <- rbind(A, C)
D2$clone_size <- 1
rm(C1, C2, C3, A, C)

D2 <- aggregate(clone_size~CDR3a+CDR3b+sample, data = D2, FUN = sum)
save(D2, file = "data/D2.RData", compress = "xz")

get_bscore <- function(x, o, b, gap_o, gap_e, trim) {
    q <- o$qseq[x] 
    t <- o$sseq[x]
    len_s <- o$length[x]
    q <- unlist(strsplit(x = q, split = NULL, fixed = TRUE))
    t <- unlist(strsplit(x = t, split = NULL, fixed = TRUE))
    
    # trim region = 1, else = 0
    tr <- numeric(length = len_s)
    if(trim != 0) {
        if(len_s-2*trim <= 0) {
            tr[seq_len(length(tr))] <- 1
        } else {
            tr[c(seq_len(trim), (len_s-trim+1):len_s)] <- 1
        }
    }
    
    cscore <- 0
    score <- 0
    gap_o_on <- 0
    iq <- 1
    it <- 1
    for(i in seq_len(len_s)) {
        if(q[i]!="-" & t[i]!= "-") {
            bi <- b[q[i],t[i]]
            score <- score + bi
            cscore <- cscore + bi * (tr[i]==0)
            gap_o_on <- 0
        }
        else {
            if(gap_o_on==1) {
                score <- score + gap_e
                cscore <- cscore + gap_e * (tr[i]==0)
            } 
            else {
                score <- score + gap_o + gap_e
                cscore <- cscore + (gap_o + gap_e) * (tr[i]==0)
                gap_o_on <- 1
            }
        }
    }
    
    res <- numeric(length = 3)
    res[1] <- score
    res[2] <- cscore
    res[3] <- sum(tr==0)
    return(res)
}

get_score <- function(s, control) {
    
    # rblast db
    db <- AAStringSet(s$cdr3)
    names(db) <- s$id
    writeXStringSet(db, filepath = "tmp.fasta")
    makeblastdb(db_name = "db/tmp", dbtype = "prot", 
                file = "tmp.fasta", verbose = FALSE)
    bdb <- blast("db/tmp", type = "blastp")
    blast_fmt <- paste("qseqid sseqid pident length qstart qend",
                       "sstart send evalue score qseq sseq qlen slen")
    blast_args <- paste0("-num_threads ", control$blast_cores, 
                         " -evalue 10 -gapopen 11 -gapextend 2", 
                         " -word_size 3 -matrix BLOSUM62 -comp_based_stats 0")
    o <- predict(bdb, db, BLAST_args = blast_args, custom_format = blast_fmt)
    
    # clean up
    unlink("tmp.fasta")
    unlink("db/tmp", recursive = TRUE)
    
    # remove self-hits
    o <- o[o$qseqid!=o$sseqid,]
    # if empty and no duplicates found stop
    if(nrow(o)==0) {
        return(NULL)
    }
    
    # remove low gmi matches
    o <- o[o$pident >= control$blast_gmi*100,]
    if(nrow(o)==0) {
        return(NULL)
    }
    
    # remove partial hits
    j <- which(o$qstart!=1 | o$sstart!=1 | o$qend != o$qlen | o$send != o$slen)
    if(length(j)!=0) {
        o <- o[-j,]
    }
    # if empty and no duplicates found stop
    if(nrow(o)==0) {
        return(NULL)
    }
    
    # remove self-hits
    key <- paste(pmin(o$qseqid, o$sseqid), pmax(o$qseqid, o$sseqid), 
                 sep = "-")
    o <- o[!duplicated(key), , drop = FALSE]
    if(nrow(o)>0) {
        out <- data.frame(from = o$qseqid,
                          to = o$sseqid,
                          len = o$length,
                          weight = o$score,
                          nweight = o$score/o$length)
        
        data_env <- get_blosum62()
        bs <- t(vapply(X = seq_len(nrow(o)), 
                       FUN.VALUE = numeric(3),
                       FUN = get_bscore, 
                       o = o, 
                       gap_o = -11, 
                       gap_e = -2, 
                       trim = control$trim_flank_aa,
                       b = data_env[["BLOSUM62"]]))
        out$cweight <- bs[,2]
        out$clen <- bs[,3]
        
        out$nweight <- out$weight/out$len
        out$ncweight <- out$cweight/out$clen
        out$chain <- s$chain[1]
    }
    
    # KNN 
    if(control$knn == TRUE) {
        out <- out[order(out$nweight, decreasing = TRUE), ]
        out <- out %>%
            group_by(from) %>%
            arrange(desc(nweight), .by_group = TRUE) %>%
            mutate(rank = row_number()) %>%
            ungroup()
        out <- out[out$rank <= control$k,]
        out$rank <- NULL
    }
    
    return(out)
}

get_score_pair <- function(s_from, s_to, control) {
    # rblast query
    db_from <- AAStringSet(s_from$cdr3)
    names(db_from) <- s_from$id
    
    # rblast db
    db_to <- AAStringSet(s_to$cdr3)
    names(db_to) <- s_to$id
    writeXStringSet(db_to, filepath = "tmp.fasta")
    makeblastdb(db_name = "db/tmp", dbtype = "prot", 
                file = "tmp.fasta", verbose = FALSE)
    bdb <- blast("db/tmp", type = "blastp")
    blast_fmt <- paste("qseqid sseqid pident length qstart qend",
                       "sstart send evalue score qseq sseq qlen slen")
    blast_args <- paste0("-num_threads ", control$blast_cores, 
                         " -evalue 10 -gapopen 11 -gapextend 2", 
                         " -word_size 3 -matrix BLOSUM62 -comp_based_stats 0")
    o <- predict(bdb, db_from, BLAST_args = blast_args, 
                 custom_format = blast_fmt)
    
    # clean up
    unlink("tmp.fasta")
    unlink("db/tmp", recursive = TRUE)
    
    # remove low gmi matches
    o <- o[o$pident >= control$blast_gmi*100,]
    if(nrow(o)==0) {
        return(NULL)
    }
    
    # remove partial hits
    j <- which(o$qstart!=1 | o$sstart!=1 | o$qend != o$qlen | o$send != o$slen)
    if(length(j)!=0) {
        o <- o[-j,]
    }
    # if empty and no duplicates found stop
    if(nrow(o)==0) {
        return(NULL)
    }
    
    if(nrow(o)>0) {
        out <- data.frame(from = o$qseqid,
                          to = o$sseqid,
                          len = o$length,
                          weight = o$score,
                          nweight = o$score/o$length)
        
        data_env <- get_blosum62()
        bs <- t(vapply(X = seq_len(nrow(o)), 
                       FUN.VALUE = numeric(3),
                       FUN = get_bscore, 
                       o = o, 
                       gap_o = -11, 
                       gap_e = -2, 
                       trim = control$trim_flank_aa,
                       b = data_env[["BLOSUM62"]]))
        out$cweight <- bs[,2]
        out$clen <- bs[,3]
        
        out$nweight <- out$weight/out$len
        out$ncweight <- out$cweight/out$clen
        out$chain <- s_from$chain[1]
    }
    
    # KNN 
    if(control$knn == TRUE) {
        out <- out[order(out$nweight, decreasing = TRUE), ]
        out <- out %>%
            group_by(from) %>%
            arrange(desc(nweight), .by_group = TRUE) %>%
            mutate(rank = row_number()) %>%
            ungroup()
        out <- out[out$rank <= control$k,]
        out$rank <- NULL
    }
    
    return(out)
}

get_ag_species_hits <- function(node_summary, 
                                db = "vdjdb", 
                                ag_species) {
    db_cols <- which(regexpr(pattern = paste0("info_", db, "_*"), 
                             text = colnames(node_summary))!=-1)
    
    node_summary$cells <- node_summary$clone_size
    node_summary$clones <- 1
    
    table_summary <- c()
    for(i in db_cols) {
        name_col <- gsub(pattern = paste0("info_", db, "_"), 
                         replacement = '', x = colnames(node_summary)[i])
        new_col <- paste0(paste0(ag_species, collapse = '_'), "_", name_col)
        node_summary[,new_col] <- 0
        
        ann <- strsplit(x = node_summary[,i], split = "\\|")
        js <- which(is.na(ann)==FALSE)
        if(length(js)!=0) {
            hits <- vapply(X = ann[js], FUN = function(x, ag_species) {
                x <- gsub(pattern="Antigen_species\\:",replacement='',x=x[[3]])
                x <- unlist(strsplit(x = x, split = "\\;"))
                return(any(x %in% ag_species))
            }, ag_species = ag_species, FUN.VALUE = logical(length = 1))
            js <- js*hits
            if(any(js!=0)) {
                node_summary[js, new_col] <- 1
                
                # table summary
                ts <- node_summary[,c("sample", "community", 
                                      "cells", "clones", new_col)]
                ts$ag <- ts[, new_col]
                
                # compute repertoire properties
                rs <- node_summary %>% 
                    group_by(sample, .drop = TRUE) %>%
                    summarise(rep_cells = sum(cells), 
                              rep_clones = sum(clones),
                              .groups = "drop")
                
                # compute community properties
                cs <- ts %>% 
                    group_by(sample, community, .drop = TRUE) %>%
                    summarise(com_cells = sum(cells), 
                              com_clones = sum(clones),
                              .groups = "drop") %>%
                    complete(sample, community, 
                             fill = list(total_cells = 0, total_clones = 0))
                
                # compute community and ag-specific properties
                as <- ts %>% 
                    group_by(sample, community, ag, .drop = TRUE) %>%
                    summarise(ag_cells = sum(cells), 
                              ag_clones = sum(clones))
                as <- as[as$ag==1,]
                
                # merge stuff
                cs <- merge(x = cs, y = rs, by = c("sample"), all.x = TRUE)
                as <- merge(x = as, y = cs, by = c("sample", "community"), 
                            all.y = TRUE)
                as[which(is.na(as), arr.ind = TRUE)] <- 0
                as$ag <- NULL
                as$ag_key <- new_col
                
                table_summary <- rbind(table_summary, as)
            }
        }
    }
    
    cols <- paste0(paste0(ag_species, collapse = '_'), "_", 
                   gsub(pattern = paste0("info_", db, "_"), 
                        replacement = '', x = colnames(node_summary)[db_cols]))
    
    return(list(node_summary = node_summary,
                new_columns = cols,
                table_summary = table_summary))
}

get_ag_gene_hits <- function(node_summary, 
                             db = "vdjdb", 
                             ag_gene) {
    db_cols <- which(regexpr(pattern = paste0("info_", db, "_*"), 
                             text = colnames(node_summary))!=-1)
    
    node_summary$cells <- node_summary$clone_size
    node_summary$clones <- 1
    
    table_summary <- c()
    for(i in db_cols) {
        name_col <- gsub(pattern = paste0("info_", db, "_"), 
                         replacement = '', x = colnames(node_summary)[i])
        new_col <- paste0(paste0(ag_gene, collapse = '_'), "_", name_col)
        node_summary[,new_col] <- 0
        
        ann <- strsplit(x = node_summary[,i], split = "\\|")
        js <- which(is.na(ann)==FALSE)
        if(length(js)!=0) {
            hits <- vapply(X = ann[js], FUN = function(x, ag_gene) {
                x <- gsub(pattern = "Antigen_gene\\:", replacement='', x=x[[4]])
                x <- unlist(strsplit(x = x, split = "\\;"))
                return(any(x %in% ag_gene))
            }, ag_gene = ag_gene, FUN.VALUE = logical(length = 1))
            js <- js*hits
            if(any(js!=0)) {
                node_summary[js, new_col] <- 1
                
                # table summary
                ts <- node_summary[,c("sample", "community", 
                                      "cells", "clones", new_col)]
                ts$ag <- ts[, new_col]
                
                # compute repertoire properties
                rs <- node_summary %>% 
                    group_by(sample, .drop = TRUE) %>%
                    summarise(rep_cells = sum(cells), 
                              rep_clones = sum(clones),
                              .groups = "drop")
                
                # compute community properties
                cs <- ts %>% 
                    group_by(sample, community, .drop = TRUE) %>%
                    summarise(com_cells = sum(cells), 
                              com_clones = sum(clones),
                              .groups = "drop") %>%
                    complete(sample, community, 
                             fill = list(total_cells = 0, total_clones = 0))
                
                # compute community and ag-specific properties
                as <- ts %>% 
                    group_by(sample, community, ag, .drop = TRUE) %>%
                    summarise(ag_cells = sum(cells), 
                              ag_clones = sum(clones))
                as <- as[as$ag==1,]
                
                # merge stuff
                cs <- merge(x = cs, y = rs, by = c("sample"), all.x = TRUE)
                as <- merge(x = as, y = cs, by = c("sample", "community"), 
                            all.y = TRUE)
                as[which(is.na(as), arr.ind = TRUE)] <- 0
                as$ag <- NULL
                as$ag_key <- new_col
                
                table_summary <- rbind(table_summary, as)
            }
        }
    }
    
    cols <- paste0(paste0(ag_gene, collapse = '_'), "_", 
                   gsub(pattern = paste0("info_", db, "_"), 
                        replacement = '', x = colnames(node_summary)[db_cols]))

    return(list(node_summary = node_summary,
                new_columns = cols,
                table_summary = table_summary))
}

# Download TCR3d data
# https://tcr3d.ibbr.umd.edu/cancerseqs
# https://tcr3d.ibbr.umd.edu/virusseqs
t <- read.csv("tcr3d_cancer.csv", sep = ",")
t <- t[, c("CDR3.alpha.", "CDR3.beta.", "Cancer.BR.Type", "Antigen", "Reference")]
colnames(t) <- c("CDR3a", "CDR3b", "Antigen_species", "Antigen_gene", "Reference")
t_c <- t

t <- read.csv("tcr3d_virus.csv", sep = ",")
t <- t[, c("CDR3.alpha.", "CDR3.beta.", "Virus.BR.Type", "Antigen", "Reference")]
colnames(t) <- c("CDR3a", "CDR3b", "Antigen_species", "Antigen_gene", "Reference")
t_v <- t

t <- rbind(t_c, t_v)
t$CDR3_species <- "Human"
t$CDR3g <- NA
t$CDR3d <- NA
t$CDR3h <- NA
t$CDR3l <- NA

t <- t[, c("CDR3a", "CDR3b",
           "CDR3g", "CDR3d", 
           "CDR3h", "CDR3l", 
           "CDR3_species", "Antigen_species", 
           "Antigen_gene", "Reference")]

tcr3d <- t
save(tcr3d, file = "data/tcr3d.RData", compress = T)

config_edges <- function(es) {
  
  # edge color by type
  get_type_edge <- function(x) {
    x <- sort(unique(x))
    if(length(x)==2) {
      return("black")
    }
    if(x == "local") {
      return("purple")
    }
    if(x == "global") {
      return("#27AE60")
    }
    return("black")
  }
  
  # edge shape by chain
  get_chain_edge <- function(x) {
    x <- sort(unique(x))
    if(length(x)==2) {
      return("solid")
    }
    if(x %in% c("CDR3b", "CDR3g", "CDR3h")) {
      return("dashed")
    }
    if(x %in% c("CDR3a", "CDR3d", "CDR3l")) {
      return("dotted")
    }
  }
  
  if(nrow(es) == 0) {
    return(NULL)
  }
  
  attr_type <- aggregate(type~from+to, data = es, FUN = get_type_edge)
  attr_type$type_color <- attr_type$type
  attr_type$type <- NULL
  
  attr_chain <- aggregate(chain~from+to, data = es, FUN = get_chain_edge)
  attr_chain$chain_shape <- attr_chain$chain
  attr_chain$chain <- NULL
  
  return(merge(x = attr_chain, y = attr_type, by = c("from", "to")))
}

config_edges_plot <- function(g, is_jg) {
  n_e <- length(E(g))
  if(n_e != 0) {
    E(g)$color <- E(g)$type_color
    E(g)$lty <- E(g)$chain_shape
  }
  return(g)
}

config_vertices_plot <- function(g, is_jg, node_opacity) {
  # default features
  V(g)$size <- 1.5+log2(V(g)$clone_size)
  
  if(is_jg==TRUE) {
    V(g)$color_num <- as.numeric(as.factor(V(g)$sample))
    max_n <- max(V(g)$color_num)
    V(g)$color <- hcl.colors(n=max(5, max_n), palette = "Roma",
                             alpha = node_opacity)[V(g)$color_num]
    V(g)$frame.color <- V(g)$color
  } 
  else {
    V(g)$color <- adjustcolor("black", alpha.f = node_opacity)
    V(g)$frame.color <- V(g)$color
  }
  
  return(g)
}


save_interactive_graph <- function(graph, 
                                   file_name, 
                                   output_folder, 
                                   overwrite = TRUE){
    
    if (!requireNamespace("htmlwidgets", quietly = TRUE)) {
        stop(
            "\"htmlwidgets\" is required to export interactive graphs.\n",
            "Please install it using install.packages('htmlwidgets')."
        )
    }
    
    check_missing(graph)
    if (!inherits(graph, "visNetwork")) {
        stop("Input 'graph' must be a 'visNetwork' object.")
    }
    check_missing(file_name)
    check_missing(output_folder)
    check_logical(overwrite)
    
    if(!dir.exists(output_folder) & output_folder != ""){
        message("Directory '", output_folder, "' not found. Creating it.")
        dir.create(output_folder, recursive = TRUE)
    }
    
    base_file <- paste0(file_name, ".html")
    target_path <- file.path(output_folder, base_file)
    
    # to avoid overwriting files in the top layer
    # we need this because of the way htmlwidgets saves files
    if(file.exists(base_file) & !overwrite){
        stop(paste0(base_file ," already exists in work space home folder.\n",
                    "Please move/rename the file or set overwrite to TRUE ",
                    "to overwrite it"))
    }
    
    if(file.exists(target_path) & !overwrite){
        stop(paste0(target_path ," already exists.\n",
                    "Set overwrite to TRUE to overwrite it."))
    }
    
    graph$width <- "100%"
    graph$height <- "100vh"
    
    htmlwidgets::saveWidget(
        widget = graph, 
        file = paste0(file_name, ".html"), 
        selfcontained = TRUE, 
        background = "white",
        title = file_name
    )
    
    # this step is necessary to ensure self-contained files
    # if we put the full path in saveWidget, it will not delete the files folder
    # also double check if directory actually exists to catch unexpected errors
    if(dir.exists(output_folder)){
        if(!file.rename(from = base_file, 
                        to = target_path)) {
            file.copy(from = base_file, 
                      to = target_path, 
                      overwrite = overwrite)
            file.remove(base_file)
        }
        message(file_name, " exported to: ", target_path)
    } else {
        message("Directory '", output_folder, "' does not exist.\n",
                "File saved to current working directory as: ", base_file)
    }
    

}

skip_if_not(rBLAST::has_blast(), message = "BLAST+ is not installed.")

test_that("save_interactive_graph works and cleans up locally", {
    
    # be sure not to break anything because of missing package
    skip_if_not_installed("htmlwidgets")
    
    # Dummy visNetwork
    n <- data.frame(id = 1:3)
    e <- data.frame(from = c(1,2), to = c(2,3))
    g <- visNetwork::visNetwork(n, e)
    
    file_name <- "test"
    output_folder <- tempdir()
    
    
    # Run function
    expect_message(save_interactive_graph(graph = g, 
                                          file_name = file_name, 
                                          output_folder = output_folder,
                                          overwrite = T), 
                   "exported to")
    
    expect_true(file.exists(file.path(output_folder, 
                                      paste0(file_name, ".html"))))
    

    expect_false(file.exists(paste0(file_name, ".html")))
    
    expect_error(save_interactive_graph(graph = g, 
                                        file_name = file_name, 
                                        output_folder = output_folder,
                                        overwrite = F))
})

# Description:
# annotate nodes with data from databases: VDJdb, tcr3d, mcpas-tcr
match_db <- function(cs, control) {
    
    get_db_info <- function(cs, db, db_type, chain, index) {
        
        get_vdjdb_info <- function(x, cs, db, chain, index) {
            if(x == "") {
                return("")
            }
            xs <- as.numeric(unlist(strsplit(index[x], split = "\\|")))
            
            return(paste0("<db:VDJdb|chain:", chain, "|",
                          "Antigen_species:", 
                          paste0(db[xs, "Antigen_species"], collapse = ';'),"|",
                          "Antigen_gene:", 
                          paste0(db[xs, "Antigen_gene"], collapse = ';'), "|",
                          "CDR3_species:", 
                          paste0(db[xs, "CDR3_species"], collapse = ';'), "|",
                          "Reference:", 
                          paste0(db[xs, "PMID"], collapse = ';'), ">"))
        }
        
        get_tcr3d_info <- function(x, cs, db, chain, index) {
            if(x == "") {
                return("")
            }
            xs <- as.numeric(unlist(strsplit(index[x], split = "\\|")))
            
            return(paste0("<db:tcr3d|chain:", chain, "|",
                          "Antigen_species:", 
                          paste0(db[xs, "Antigen_species"], collapse = ';'),"|",
                          "Antigen_gene:", 
                          paste0(db[xs, "Antigen_gene"], collapse = ';'), "|",
                          "Reference:", 
                          paste0(db[xs, "Reference"], collapse = ';'), ">"))
        }
        
        get_mcpas_info <- function(x, cs, db, chain, index) {
            if(x == "") {
                return("")
            }
            xs <- as.numeric(unlist(strsplit(index[x], split = "\\|")))
            
            return(paste0("<db:mcpas|chain:", chain, "|",
                          "Antigen_species:", 
                          paste0(db[xs, "Antigen_species"], collapse = ';'),"|",
                          "Antigen_gene:", 
                          paste0(db[xs, "Antigen_gene"], collapse = ';'), "|",
                          "CDR3_species:", 
                          paste0(db[xs, "CDR3_species"], collapse = ';'), "|",
                          "Reference:", 
                          paste0(db[xs, "Reference"], collapse = ';'), ">"))
        }
        
        if(db_type == "vdjdb") {
            return(vapply(X = seq_len(nrow(cs)), 
                          FUN = get_vdjdb_info, 
                          cs = cs,
                          db = db[,c(chain, "CDR3_species", "Antigen_species", 
                                     "Antigen_gene", "Reference")],
                          chain = chain,
                          index = index,
                          FUN.VALUE = character(1)))
            
            return(unlist(lapply(X=which(cs[,paste0("db_vdjdb_", chain)]==1),
                                 cs=cs,
                                 db=db[,c(chain, "CDR3_species", 
                                          "Antigen_species", 
                                          "Antigen_gene", "Reference")],
                                 chain = chain,
                                 index = index,
                                 FUN=get_vdjdb_info)))
        }
        if(db_type == "tcr3d") {
            return(unlist(lapply(X = seq_len(nrow(cs)),
                                 cs = cs,
                                 db = db[,c(chain, "Antigen_species", 
                                            "Antigen_gene", 
                                            "Reference")],
                                 chain = chain,
                                 index = index,
                                 FUN = get_tcr3d_info)))
        }
        if(db_type == "mcpas") {
            return(unlist(lapply(X = seq_len(nrow(cs)),
                                 cs = cs,
                                 db = db[,c(chain, "CDR3_species",
                                            "Antigen_species", "Antigen_gene", 
                                            "Reference")],
                                 chain = chain,
                                 index = index,
                                 FUN = get_mcpas_info)))
        }
    }
    
    get_db_index <- function(x, a, b, d) {
        if(d==0) {
            z <- which(a==b[x])
        } else {
            z <- which(stringdist(a=a,b=b[x],method="lv")<=d)
        }
        if(length(z)!=0) {
            return(paste0(z, collapse = '|'))
        }
        return('')
    }
    
    load_data <- function(d) {
        
        e <- new.env()
        if(d=="vdjdb") {
            name <- data("vdjdb", package = "ClustIRR", envir = e)[1]
        }
        if(d=="mcpas") {
            name <- data("mcpas", package = "ClustIRR", envir = e)[1]
        }
        if(d=="tcr3d") {
            name <- data("tcr3d", package = "ClustIRR", envir = e)[1]
        }
        return(e[[name]])
    }
    
    # make sure cs is a data.frame
    cs <- data.frame(cs)
    
    # what type of chaisn are there in the data -> use them to match DBs
    chains <- get_chains(x = colnames(cs))
    
    # load DBs and pack into one list -> db
    db_names <- get_annotation_dbs()
    db <- vector(mode = "list", length = length(db_names))
    names(db) <- db_names
    for(i in seq_len(length(db))) {
        db[[i]] <- load_data(d = names(db)[i])
    }
    
    if(is.null(control$db_custom)==FALSE) {
        db[["custom"]] <- control$db_custom
    }
    
    for(db_name in names(db)) {
        for(chain in chains) {
            key_db <- paste0("db_", db_name, "_", chain)
            key_index <- paste0("index_", db_name, "_", chain)
            key_info <- paste0("info_", db_name, "_", chain)
            
            cs[, key_db] <- 0
            cs[, key_index] <- ''
            cs[, key_info] <- ''
            
            # insert indices
            cs[, key_index] <- vapply(X = seq_len(nrow(cs)), 
                                      a = db[[db_name]][, chain],
                                      b = cs[, chain],
                                      d = control$db_dist,
                                      FUN.VALUE = character(1), 
                                      FUN = get_db_index)
            
            cs[cs[, key_index]!='', key_db] <- 1
            cs[, key_info] <- get_db_info(cs = cs,
                                          db_type = db_name,
                                          db = db[[db_name]],
                                          index = cs[, key_index],
                                          chain = chain)
            cs[cs[, key_db]==0, key_info] <- NA
            cs[, key_index] <- NULL
        }
    }
    
    # get aggregate infos
    x <- cs[, which(regexpr(pattern = "info_", text = colnames(cs))!=-1)]
    a <- apply(X = x, MARGIN = 1, FUN = function(x, key) {
        if(all(is.na(x))) {
            return(list(ag_species = '', ag_gene = ''))
        }
        
        ag_species <- c()
        ag_gene <- c()
        x <- x[is.na(x)==FALSE]
        for(i in seq_len(length(x))) {
            y <- unlist(strsplit(x = x[i], split = "\\|"))
            ag_species <- c(ag_species, unlist(strsplit(x = y[3], 
                                                        split = '\\;')))
            ag_gene <- c(ag_gene, unlist(strsplit(x = y[4], split = '\\;')))
        }
        ag_species <- paste0(unique(gsub(pattern = "Antigen_species\\:", 
                                         replacement = '', x = ag_species)), 
                             collapse = ',')
        ag_gene <- paste0(unique(gsub(pattern = "Antigen_gene\\:", 
                                      replacement = '', x = ag_gene)),
                          collapse = ',')
        
        return(list(ag_species = ag_species, ag_gene = ag_gene))
    })
    
    cs$Ag_species <- unlist(lapply(X = a, FUN = function(x){x[["ag_species"]]}))
    cs$Ag_gene <- unlist(lapply(X = a, FUN = function(x) {x[["ag_gene"]]}))
    
    return(cs)
}

get_annotation_dbs <- function() {
    return(c("vdjdb", "mcpas", "tcr3d"))
}

# Description:
# integrate nodes with data from databases: VDJdb, tcr3d, mcpas-tcr
get_node_ann <- function(ns, ag_key, db) {
    
    get_ann <- function(ns, ag, type, id, db) {
        
        # created column
        agk <- paste0(id, "_", db, "_summary")
        
        # clone size (multiplier)
        clone_size <- ns$clone_size
        
        # columns of interest
        i <- which(regexec(pattern = paste0(
            paste0("info_", db, "_"), collapse = "|"), 
            text = colnames(ns))!=-1)
        is <- do.call(rbind, strsplit(x = colnames(ns)[i], split = "\\_"))
        is <- data.frame(db = is[,2], chain = is[,3], 
                         info_key = colnames(ns)[i])
        
        # results
        m <- matrix(data = 0, nrow = nrow(ns), ncol = nrow(is)+length(agk))
        colnames(m) <- c(gsub(pattern = "info\\_", 
                              replacement = paste0(id, "_"), 
                              x = is$info_key), agk)
        
        for(i in seq_len(nrow(is))) {
            k <- do.call(rbind, strsplit(x = ns[,is$info_key[i]], 
                                         split = "\\|"))
            if(type == "species") {
                g <- gsub(pattern = "Antigen\\_species\\:", 
                          replacement = '', x = k[,3])
                m[,i] <- vapply(X = g, 
                                ag = ag, 
                                clone_size = clone_size,
                                FUN.VALUE = numeric(1),
                                FUN = function(x, ag, clone_size) {
                                    if(ag=="") {
                                        return(FALSE)
                                    }
                                    return(regexpr(pattern = ag, 
                                                   text = x)!=-1)
                                })*clone_size
            }
            else if(type == "gene") {
                g <- gsub(pattern = "Antigen\\_gene\\:", 
                          replacement = '', x = k[,4])
                m[,i] <- vapply(X = g, 
                                ag = ag, 
                                clone_size = clone_size,
                                FUN.VALUE = numeric(1),
                                FUN = function(x, ag, clone_size) {
                                    return(regexpr(pattern = ag, 
                                                   text = x)!=-1)
                                })*clone_size
            }
        }
        
        # DB-specific cells -> summary for both chains A|B cells
        ags <- paste0(id, "_", db, "_summary")
        mm <- m[, which(regexpr(pattern = db, text = colnames(m))!=-1 & 
                            regexpr(pattern = ags, text = colnames(m))==-1),
                drop = FALSE]
        m[,ags] <- apply(X = mm, MARGIN = 1, FUN = max)
        m <- data.frame(m)
        return(m)
    }
    
    m <- ns
    vars <- c()
    seq_len(nrow(ag_key))
    for(i in seq_len(nrow(ag_key))) {
        a <- get_ann(ns = ns, ag = ag_key$ag[i], type = ag_key$type[i], 
                     id = ag_key$id[i], db = db)
        vars <- c(vars, colnames(a))
        m <- cbind(m, a)
    }
    
    return(list(ann = m, vars = vars))
}

# Get annotation database matches for visualization utilizies
get_db_match <- function(ns, db, db_dist) {
    
    get_db_info <- function(ns, db, db_type, chain, index) {
        
        get_vdjdb_info <- function(x, ns, db, chain, index) {
            if(x == "") {
                return("")
            }
            xs <- as.numeric(unlist(strsplit(index[x], split = "\\|")))
            
            return(paste0("<db:VDJdb|chain:", chain, "|",
                          "Antigen_species:", 
                          paste0(db[xs, "Antigen_species"], collapse = ';'),"|",
                          "Antigen_gene:", 
                          paste0(db[xs, "Antigen_gene"], collapse = ';'), "|",
                          "CDR3_species:", 
                          paste0(db[xs, "CDR3_species"], collapse = ';'), "|",
                          "Reference:", 
                          paste0(db[xs, "PMID"], collapse = ';'), ">"))
        }
        
        get_tcr3d_info <- function(x, ns, db, chain, index) {
            if(x == "") {
                return("")
            }
            xs <- as.numeric(unlist(strsplit(index[x], split = "\\|")))
            
            return(paste0("<db:tcr3d|chain:", chain, "|",
                          "Antigen_species:", 
                          paste0(db[xs, "Antigen_species"], collapse = ';'),"|",
                          "Antigen_gene:", 
                          paste0(db[xs, "Antigen_gene"], collapse = ';'), "|",
                          "Reference:", 
                          paste0(db[xs, "Reference"], collapse = ';'), ">"))
        }
        
        get_mcpas_info <- function(x, ns, db, chain, index) {
            if(x == "") {
                return("")
            }
            xs <- as.numeric(unlist(strsplit(index[x], split = "\\|")))
            
            return(paste0("<db:mcpas|chain:", chain, "|",
                          "Antigen_species:", 
                          paste0(db[xs, "Antigen_species"], collapse = ';'),"|",
                          "Antigen_gene:", 
                          paste0(db[xs, "Antigen_gene"], collapse = ';'), "|",
                          "CDR3_species:", 
                          paste0(db[xs, "CDR3_species"], collapse = ';'), "|",
                          "Reference:", 
                          paste0(db[xs, "Reference"], collapse = ';'), ">"))
        }
        
        if(db_type == "vdjdb") {
            return(vapply(X = seq_len(nrow(ns)), 
                          FUN = get_vdjdb_info, 
                          ns = ns,
                          db = db[,c(chain, "CDR3_species", "Antigen_species", 
                                     "Antigen_gene", "Reference")],
                          chain = chain,
                          index = index,
                          FUN.VALUE = character(1)))
            
            return(unlist(lapply(X=which(ns[,paste0("db_vdjdb_", chain)]==1),
                                 ns=ns,
                                 db=db[,c(chain, "CDR3_species", 
                                          "Antigen_species", "Antigen_gene", 
                                          "Reference")],
                                 chain = chain,
                                 index = index,
                                 FUN=get_vdjdb_info)))
        }
        if(db_type == "tcr3d") {
            return(unlist(lapply(X = seq_len(nrow(ns)),
                                 ns = ns,
                                 db = db[,c(chain, "Antigen_species", 
                                            "Antigen_gene", "Reference")],
                                 chain = chain,
                                 index = index,
                                 FUN = get_tcr3d_info)))
        }
        if(db_type == "mcpas") {
            return(unlist(lapply(X = seq_len(nrow(ns)),
                                 ns = ns,
                                 db = db[,c(chain, "CDR3_species",
                                            "Antigen_species", "Antigen_gene", 
                                            "Reference")],
                                 chain = chain,
                                 index = index,
                                 FUN = get_mcpas_info)))
        }
    }
    
    get_db_index <- function(x, a, b, d) {
        if(d==0) {
            z <- which(a==b[x])
        } else {
            z <- which(stringdist(a=a,b=b[x],method="lv")<=d)
        }
        if(length(z)!=0) {
            return(paste0(z, collapse = '|'))
        }
        return('')
    }
    
    load_data <- function(d) {
        
        e <- new.env()
        if(d=="vdjdb") {
            name <- data("vdjdb", package = "ClustIRR", envir = e)[1]
        }
        if(d=="mcpas") {
            name <- data("mcpas", package = "ClustIRR", envir = e)[1]
        }
        if(d=="tcr3d") {
            name <- data("tcr3d", package = "ClustIRR", envir = e)[1]
        }
        return(e[[name]])
    }
    
    # what type of chaisn are there in the data -> use them to match DBs
    chains <- get_chains(x = colnames(ns))
    
    # load DBs and pack into one list -> db
    db_name <- db
    db <- vector(mode = "list", length = 1)
    names(db) <- db_name
    db[[1]] <- load_data(d = names(db)[1])
    
    for(chain in chains) {
        key_db <- paste0("db_", db_name, "_", chain)
        key_index <- paste0("index_", db_name, "_", chain)
        key_info <- paste0("info_", db_name, "_", chain)
        
        ns[, key_db] <- 0
        ns[, key_index] <- ''
        ns[, key_info] <- ''
        
        # insert indices
        ns[, key_index] <- vapply(X = seq_len(nrow(ns)), 
                                  a = db[[db_name]][, chain],
                                  b = ns[, chain],
                                  d = db_dist,
                                  FUN.VALUE = character(1), 
                                  FUN = get_db_index)
        
        ns[ns[, key_index]!='', key_db] <- 1
        ns[, key_info] <- get_db_info(ns = ns,
                                      db_type = db_name,
                                      db = db[[db_name]],
                                      index = ns[, key_index],
                                      chain = chain)
        ns[, key_index] <- NULL
    }
    
    # get aggregate infos
    x <- ns[, which(regexpr(pattern = "info_", text = colnames(ns))!=-1), 
            drop=FALSE]
    a <- apply(X = x, MARGIN = 1, FUN = function(x, key) {
        if(all(x=="")) {
            return(list(ag_species = '', ag_gene = ''))
        }
        
        ag_species <- c()
        ag_gene <- c()
        x <- x[x!=""]
        for(i in seq_len(length(x))) {
            y <- unlist(strsplit(x = x[i], split = "\\|"))
            ag_species <- c(ag_species, unlist(strsplit(x = y[3],split ='\\;')))
            ag_gene <- c(ag_gene, unlist(strsplit(x = y[4], split = '\\;')))
        }
        ag_species <- paste0(unique(gsub(pattern = "Antigen_species\\:", 
                                         replacement = '', x = ag_species)), 
                             collapse = ',')
        ag_gene <- paste0(unique(gsub(pattern = "Antigen_gene\\:", 
                                      replacement = '', x = ag_gene)),
                          collapse = ',')
        
        return(list(ag_species = ag_species, ag_gene = ag_gene))
    })
    
    ns$Ag_species <- unlist(lapply(X = a, FUN = function(x){x[["ag_species"]]}))
    ns$Ag_gene <- unlist(lapply(X = a, FUN = function(x) {x[["ag_gene"]]}))
    
    return(ns)
}

clustirr <- function(s,
                     meta = NULL,
                     control = list(blast_gmi = 0.8,
                                    blast_cores = 1,
                                    trim_flank_aa = 3,
                                    db_dist = 0,
                                    db_custom = NULL,
                                    knn = FALSE,
                                    k = 30)) {
    
    # control check
    control <- get_control(control_in = control)
    
    # input check
    input_check(s = s, meta = meta, control = control)
    
    # get chains to be analyzed
    chains <- get_chains(colnames(s))
    
    # add clone size info, sample and clone id
    s <- get_clone_size(s)
    s <- get_sample(s)
    s$id <- paste0(s$sample, "|", seq_len(length.out = nrow(s)))
    
    if(is.null(meta)) {
        meta <- data.frame(id = seq_len(length.out = nrow(s)), 
                           sample = s$sample)
    } else {
        meta$id <- paste0(s$sample, "|", seq_len(length.out = nrow(meta)))
        meta$sample <- s$sample
    }
    
    # run clustirr on individual samples
    message("Step 1: Repertoire analysis \n")
    co <- lapply(X = unique(s$sample), FUN = run_clustirr, s = s, 
                 meta = meta, chains = chains, control = control)
    names(co) <- unique(s$sample)
    
    
    message("Step 2: Building graphs \n")
    if(length(co) == 1) {
        g <- get_graph(clust_irr = co[[1]])
        g$clones <- NULL
        return(g)
    }
    return(get_joint_graph(clust_irrs = co))
}

# Description:
# Run ClustIRR on individual samples
run_clustirr <- function(x, s, control, chains, meta) {
    # annotate s with known CDR3-antigen data 
    message("analysis: ", x, "\n")
    
    # subset by sample
    r <- s[s$sample == x,]
    m <- meta[meta$sample == x,]
    
    r <- match_db(cs = r, control = control)
    
    # do clustering
    clust <- lapply(X = chains, FUN = get_clust, s = r, control = control)
    names(clust) <- chains
    
    # setup clustirr object
    return(get_clustirr_obj(clust = clust, s = r, meta = m, control = control))
}

# Description:
# Wrapper of the main functions performed separately for CDR3b and CDR3a
# (if available)
get_clust <- function(x, s, control) {
    
    r <- s[, c("id", x)]
    colnames(r) <- c("id", "cdr3")
    r <- r[is.na(r$cdr3)==FALSE,]
    if(nrow(r)==0) {
        return(NULL)
    }
    if(is.null(r)) {
        return(NULL)
    }
    
    r$chain <- x
    return(get_score(s = r, control = control))
}

skip_if_not(rBLAST::has_blast(), message = "BLAST+ is not installed.")

test_that("get_blosum does not delete duplicate edges", {
    
    data("CDR3ab", package = "ClustIRR")
    s <- data.frame(CDR3b = CDR3ab[1:5, "CDR3b"],
                    CDR3a = CDR3ab[1:5, "CDR3a"],
                    clone_size = 1,
                    sample = "a")
    
    
    # insert beta chain
    cdr3b <- s[3,]$CDR3b # CSALTPGLIYNEQFF
    cdr3a <- CDR3ab[6, "CDR3a"] # CSLGPSKSQYF
    
    # add one identical clone
    s <- rbind (s, data.frame(CDR3b = cdr3b,
                              CDR3a = cdr3a,
                              clone_size = 1,
                              sample = "a"))
    
    
    # run ClustIRR analysis
    c <- clustirr(s = s)
    
    
    df_g_e <- igraph::as_data_frame(c$graph, what = "edges") 
    
    expect_true(nrow(df_g_e)>0)
    
    
})

skip_if_not(rBLAST::has_blast(), message = "BLAST+ is not installed.")

test_that("clustering two chains - within-repertoire", {
    
    # test data
    data("CDR3ab", package = "ClustIRR")
    a1 <- data.frame(CDR3a = CDR3ab[1:100, "CDR3a"],
                     CDR3b = CDR3ab[1:100, "CDR3b"],
                     clone_size = 1,
                     sample = "a")
    a2 <- data.frame(CDR3a = CDR3ab[401:500, "CDR3a"],
                     CDR3b = CDR3ab[401:500, "CDR3b"],
                     clone_size = 1,
                     sample = "a")
    
    # insert clones with two identical chains
    cdr3a <- "CAVEYSGAGSYQLTF"
    cdr3b <- "CASSQEFGSSYEQYF"
    a1_cdr3ab <- data.frame(CDR3a = cdr3a,
                            CDR3b = cdr3b,
                            clone_size = 135,
                            sample = "a")
    a2_cdr3ab <- data.frame(CDR3a = cdr3a,
                            CDR3b = cdr3b,
                            clone_size = 230,
                            sample = "a")
    
    # insert big clones that perfectly overlap on cdr3a chain 
    # set cdr3b of the clones to non-overlapping sequences
    cdr3a_only <- "CASSSSSSSSSSSSF"
    a1_cdr3a <- data.frame(CDR3a = cdr3a_only,
                           CDR3b = "CAGGGGGGGGGGGGF",
                           clone_size = 500,
                           sample = "a")
    a2_cdr3a <- data.frame(CDR3a = cdr3a_only,
                           CDR3b = "CAQQQQQQQQQQQQF",
                           clone_size = 300,
                           sample = "a")
    
    # insert big clones that perfectly overlap on cdr3b chain 
    # set cdr3a of the clones to non-overlapping sequences
    cdr3b_only <- "CAYYYYYYYYYYYYF"
    a1_cdr3b <- data.frame(CDR3a = "CAAAAAAAAAAAAAF",
                           CDR3b = cdr3b_only,
                           clone_size = 150,
                           sample = "a")
    a2_cdr3b <- data.frame(CDR3a = "CAEEEEEEEEEEEEF",
                           CDR3b = cdr3b_only,
                           clone_size = 200,
                           sample = "a")
    
    s <- rbind(a1, a1_cdr3ab, a1_cdr3b, a1_cdr3a, 
               a2, a2_cdr3ab, a2_cdr3b, a2_cdr3a)
    
    # run ClustIRR analysis
    c <- clustirr(s = s)
    
    # check nodes
    df_v <- igraph::as_data_frame(c$graph, what = "vertices")
    
    # check that the 2 nodes for each test pair exist in the graph
    cdr3ab_n <- which(df_v$CDR3b == cdr3b & df_v$CDR3a == cdr3a,)
    cdr3a_n <- which(df_v$CDR3a == cdr3a_only,)
    cdr3b_n <- which(df_v$CDR3b == cdr3b_only,)
    
    # there should be two clones for each test
    expect_true(length(cdr3ab_n) == 2)
    expect_true(length(cdr3a_n) == 2)
    expect_true(length(cdr3b_n) == 2)
    
    # check edges
    df_e <- igraph::as_data_frame(c$graph, what = "edges")
    
    cdr3ab_e_n1 <- df_v$name[cdr3ab_n[1]]
    cdr3ab_e_n2 <- df_v$name[cdr3ab_n[2]]
    cdr3ab_e <- df_e[df_e$from == cdr3ab_e_n1 & df_e$to == cdr3ab_e_n2 |
                         df_e$from == cdr3ab_e_n2 & df_e$to == cdr3ab_e_n1,]
    
    cdr3a_e_n1 <- df_v$name[cdr3a_n[1]]
    cdr3a_e_n2 <- df_v$name[cdr3a_n[2]]
    cdr3a_e <- df_e[df_e$from == cdr3a_e_n1 & df_e$to == cdr3a_e_n2 |
                         df_e$from == cdr3a_e_n2 & df_e$to == cdr3a_e_n1,]
    
    cdr3b_e_n1 <- df_v$name[cdr3b_n[1]]
    cdr3b_e_n2 <- df_v$name[cdr3b_n[2]]
    cdr3b_e <- df_e[df_e$from == cdr3b_e_n1 & df_e$to == cdr3b_e_n2 |
                        df_e$from == cdr3b_e_n2 & df_e$to == cdr3b_e_n1,]
    
    # there should be two edges between the clones with two identical chains
    # and one edge between each clone pair with one identical chain
    expect_true(nrow(cdr3ab_e) == 2)
    expect_true(nrow(cdr3a_e) == 1)
    expect_true(nrow(cdr3b_e) == 1)
    
    
})


test_that("clustering two chains - between-repertoire", {
    
    # test data
    data("CDR3ab", package = "ClustIRR")
    a <- data.frame(CDR3a = CDR3ab[1:100, "CDR3a"],
                     CDR3b = CDR3ab[1:100, "CDR3b"],
                     clone_size = 1,
                     sample = "a")
    b <- data.frame(CDR3a = CDR3ab[401:500, "CDR3a"],
                     CDR3b = CDR3ab[401:500, "CDR3b"],
                     clone_size = 1,
                     sample = "b")
    
    # insert clones with two identical chains
    cdr3a <- "CAVEYSGAGSYQLTF"
    cdr3b <- "CASSQEFGSSYEQYF"
    a_cdr3ab <- data.frame(CDR3a = cdr3a,
                            CDR3b = cdr3b,
                            clone_size = 135,
                            sample = "a")
    b_cdr3ab <- data.frame(CDR3a = cdr3a,
                            CDR3b = cdr3b,
                            clone_size = 230,
                            sample = "b")
    
    # insert big clones that perfectly overlap on cdr3a chain 
    # set cdr3b of the clones to non-overlapping sequences
    cdr3a_only <- "CASSSSSSSSSSSSF"
    a_cdr3a <- data.frame(CDR3a = cdr3a_only,
                           CDR3b = "CAGGGGGGGGGGGGF",
                           clone_size = 500,
                           sample = "a")
    b_cdr3a <- data.frame(CDR3a = cdr3a_only,
                           CDR3b = "CAQQQQQQQQQQQQF",
                           clone_size = 300,
                           sample = "b")
    
    # insert big clones that perfectly overlap on cdr3b chain 
    # set cdr3a of the clones to non-overlapping sequences
    cdr3b_only <- "CAYYYYYYYYYYYYF"
    a_cdr3b <- data.frame(CDR3a = "CAAAAAAAAAAAAAF",
                           CDR3b = cdr3b_only,
                           clone_size = 150,
                           sample = "a")
    b_cdr3b <- data.frame(CDR3a = "CAEEEEEEEEEEEEF",
                           CDR3b = cdr3b_only,
                           clone_size = 200,
                           sample = "b")
    
    s <- rbind(a, a_cdr3ab, a_cdr3b, a_cdr3a, b, b_cdr3ab, b_cdr3b, b_cdr3a)
    
    # run ClustIRR analysis
    c <- clustirr(s = s)
    
    # check nodes
    df_v <- igraph::as_data_frame(c$graph, what = "vertices")
    
    # check that the 2 nodes for each test pair exist in the graph
    cdr3ab_n <- which(df_v$CDR3b == cdr3b & df_v$CDR3a == cdr3a,)
    cdr3a_n <- which(df_v$CDR3a == cdr3a_only,)
    cdr3b_n <- which(df_v$CDR3b == cdr3b_only,)
    
    # there should be two clones for each test
    expect_true(length(cdr3ab_n) == 2)
    expect_true(length(cdr3a_n) == 2)
    expect_true(length(cdr3b_n) == 2)
    
    # check edges
    df_e <- igraph::as_data_frame(c$graph, what = "edges")
    
    cdr3ab_e_n1 <- df_v$name[cdr3ab_n[1]]
    cdr3ab_e_n2 <- df_v$name[cdr3ab_n[2]]
    cdr3ab_e <- df_e[df_e$from == cdr3ab_e_n1 & df_e$to == cdr3ab_e_n2 |
                         df_e$from == cdr3ab_e_n2 & df_e$to == cdr3ab_e_n1,]
    
    cdr3a_e_n1 <- df_v$name[cdr3a_n[1]]
    cdr3a_e_n2 <- df_v$name[cdr3a_n[2]]
    cdr3a_e <- df_e[df_e$from == cdr3a_e_n1 & df_e$to == cdr3a_e_n2 |
                        df_e$from == cdr3a_e_n2 & df_e$to == cdr3a_e_n1,]
    
    cdr3b_e_n1 <- df_v$name[cdr3b_n[1]]
    cdr3b_e_n2 <- df_v$name[cdr3b_n[2]]
    cdr3b_e <- df_e[df_e$from == cdr3b_e_n1 & df_e$to == cdr3b_e_n2 |
                        df_e$from == cdr3b_e_n2 & df_e$to == cdr3b_e_n1,]
    
    # there should be two edges between the clones with two identical chains
    # and one edge between each clone pair with one identical chain
    expect_true(nrow(cdr3ab_e) == 2)
    expect_true(nrow(cdr3a_e) == 1)
    expect_true(nrow(cdr3b_e) == 1)
    
    
})

skip_if_not(rBLAST::has_blast(), message = "BLAST+ is not installed.")

test_that("samples with one chain only containing NA do not stop clustirr", {
    
    data("CDR3ab", package = "ClustIRR")
    s <- data.frame(CDR3b = CDR3ab[1:5, "CDR3b"],
                    CDR3a = CDR3ab[1:5, "CDR3a"],
                    clone_size = 1,
                    sample = c(rep("a", 3), rep("b", 2)))

    # set 1 CDR3a chain of sample a and all CDR3a chains of sample b to NA 
    s$CDR3a[c(1, 4, 5)] <- NA
    
    # check clustering run - should run and give out warning
    expect_warning(c <- clustirr(s = s),
                   "s contains NA value")
    
    # check edges
    df_e <- igraph::as_data_frame(c$graph, what = "edges")
    
    # there should be no edges between the NA values
    expect_true(nrow(df_e) == 0)
    
})

skip_if_not(rBLAST::has_blast(), message = "BLAST+ is not installed.")
###### testing s with weird inputs #######

test_that("s parameter takes only valid input", {
  expect_error(clustirr(), 
               regexp = "s is missing")
  
  expect_error(clustirr(s = NULL), 
               regexp = "s is missing")
  
  expect_error(clustirr(s = "C"), 
               regexp = "s has to be a dataframe")
  
  expect_error(clustirr(s = TRUE), 
               regexp = "s has to be a dataframe")
  
  expect_error(clustirr(s = 1), 
               regexp = "s has to be a dataframe")
  
  expect_error(clustirr(s = NA), 
               regexp = "s has to be a dataframe")
})



###### testing s with complex inputs #######

test_that("s parameter takes only valid input", {
  data("CDR3ab", package = "ClustIRR")
  s <- CDR3ab[1:100,c("CDR3a", "CDR3b")]
  s$clone_size <- 1
  s$sample <- "a"
  expect_no_error(clustirr(s))
  
  
  # test s
  s <- CDR3ab[1:100,c("CDR3a", "CDR3b")]
  s$clone_size <- 1
  s$sample <- "a"
  s$CDR3b[1] <- NA
  expect_warning(clustirr(s = s))
  
  
  # test sample
  data("CDR3ab", package = "ClustIRR")
  s <- CDR3ab[1:100,c("CDR3a", "CDR3b")]
  s$clone_size <- 1
  s$sample <- NA
  expect_error(clustirr(s = s),
               regexp = "sample must be character")
  
  data("CDR3ab", package = "ClustIRR")
  s <- CDR3ab[1:100,c("CDR3a", "CDR3b")]
  s$clone_size <- 1
  s$sample <- 1
  expect_error(clustirr(s = s),
               regexp = "sample must be character")
  
  data("CDR3ab", package = "ClustIRR")
  s <- CDR3ab[1:100,c("CDR3a", "CDR3b")]
  s$clone_size <- 1
  s$sample <- "a"
  s$sample <- as.factor(s$sample)
  expect_error(clustirr(s = s),
               regexp = "sample must be character")
  
  data("CDR3ab", package = "ClustIRR")
  s <- CDR3ab[1:100,c("CDR3a", "CDR3b")]
  s$clone_size <- 1
  s$sample <- T
  expect_error(clustirr(s = s),
               regexp = "sample must be character")
  
  data("CDR3ab", package = "ClustIRR")
  s <- CDR3ab[1:100,c("CDR3a", "CDR3b")]
  s$clone_size <- 1
  s$sample <- "a"
  s$sample[1] <- "b"
  expect_no_error(clustirr(s = s))
})



# more coming soon ...

---
title: "Finding **biological condition**-specific changes in T- and B-cell 
receptor repertoires with ClustIRR"
output:
    BiocStyle::html_document
vignette: >
    %\VignetteIndexEntry{Finding biological condition-specific changes in T- and B-cell receptor repertoires with ClustIRR}
    %\VignetteEncoding{UTF-8}
    %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  markdown: 
    wrap: 72
---

```{r, include=FALSE}
knitr::opts_chunk$set(comment = "", warning = FALSE, message = FALSE)
```

```{r}
library(knitr)
library(ClustIRR)
library(ggplot2)
library(patchwork)
library(ggforce)
library(rBLAST)
theme_set(new = theme_bw(base_size = 10))
```


```{r, include = FALSE}
# only run code if blast+ is installed
run <- has_blast()
```

```{r, echo = FALSE, eval = !run, results='asis'}
cat("**Note: BLAST was not installed when this vignette was built!**")
```


```{r, eval=run}
# System requirements
#  The BLAST+ software needs to be installed on your system. Installation
# instructions are available in this package's
# [INSTALL](https://github.com/mhahsler/rBLAST/blob/devel/INSTALL) file and
# at \url{https://www.ncbi.nlm.nih.gov/books/NBK569861/}.

# R needs to be able to find the executable. After installing the software,
# try in R
Sys.which("blastp")

# If the command returns "" instead of the path to the executable,
# then you need to set the environment variable called PATH. In R
Sys.setenv(PATH = paste(Sys.getenv("PATH"),
   "path_to_your_BLAST_installation", sep=.Platform$path.sep))
```


```{r, eval=run}
data("D2", package = "ClustIRR")
```

```{r, eval=run}
cl <- clustirr(s = D2, control = list(blast_gmi = 0.8))
```


```{r, eval=run}
gcd <- detect_communities(graph = cl$graph, 
                          algorithm = "leiden",
                          metric = "average",
                          resolution = 1,
                          iterations = 100,
                          chains = c("CDR3a", "CDR3b"))
```


```{r, eval=run}
dim(gcd$community_occupancy_matrix)
```


```{r, fig.width=8, fig.height=9, eval=run}
honeycomb <- get_honeycombs(com = gcd$community_occupancy_matrix)
wrap_plots(honeycomb, nrow = 5, ncol = 3)+
    plot_annotation(tag_levels = 'A')
```



```{r, eval=run}
d <- dco(community_occupancy_matrix = gcd$community_occupancy_matrix,
         groups = c(1, 1, 1, 2, 2, 2),
         mcmc_control = list(mcmc_warmup = 300,
                             mcmc_iter = 600,
                             mcmc_chains = 2,
                             mcmc_cores = 1,
                             mcmc_algorithm = "NUTS",
                             adapt_delta = 0.9,
                             max_treedepth = 10))
```



```{r, fig.width=6, fig.height=3, eval=run}
ggplot(data = d$posterior_summary$beta)+
    geom_sina(aes(x = sample, y = mean))|
    ggplot(data = d$posterior_summary$beta_mu)+
    geom_sina(aes(x = as.character(g), y = mean))
```


```{r, fig.width=7, fig.height=3, eval=run}
ggplot(data = d$posterior_summary$epsilon)+
    facet_wrap(facets = ~contrast, ncol = 2)+
    geom_errorbar(aes(x = community, y = mean, ymin = L95, ymax = H95), 
                  col = "lightgray", width = 0)+
    geom_point(aes(x = community, y = mean), shape = 21, fill = "black", 
               stroke = 0.4, col = "white", size = 1.25)+
    theme(legend.position = "top")+
    ylab(label = expression(delta))+
    scale_x_continuous(expand = c(0,0))
```

---
title: "Decoding T- and B-cell receptor repertoires with ClustIRR"
output:
    BiocStyle::html_document
vignette: >
    %\VignetteIndexEntry{Decoding T- and B-cell receptor repertoires with ClustIRR}
    %\VignetteEncoding{UTF-8}
    %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  markdown: 
    wrap: 72
---

```{r, include=FALSE}
knitr::opts_chunk$set(comment = "", warning = FALSE, message = FALSE)
```

```{r}
library(knitr)
library(ClustIRR)
library(igraph)
library(ggplot2)
theme_set(new = theme_bw(base_size = 10))
library(ggrepel)
library(patchwork)
library(rBLAST)
options(digits=2)
```


```{r, include = FALSE}
# only run code if blast+ is installed
run <- has_blast()
```

```{r, echo = FALSE, eval = !run, results='asis'}
cat("**Note: BLAST was not installed when this vignette was built!**")
```

# Introduction

Adaptive immunity employs diverse immune receptor repertoires (IRRs; B-
and T-cell receptors) to combat evolving pathogens including viruses,
bacteria, and cancers. Receptor diversity arises through V(D)J
recombination - combinatorial assembly of germline genes generating
unique sequences. Each naive lymphocyte consequently expresses a
distinct receptor, enabling broad antigen recognition.

B cells engage antigens directly via BCR complementarity-determining
regions (CDRs), while T cells recognize peptide-MHC complexes through
TCR CDRs. Antigen recognition triggers clonal expansion, producing
effector populations that mount targeted immune responses.

High-throughput sequencing (HT-seq) enables tracking of TCR/BCR community 
dynamics across biological conditions (e.g., pre-/post-treatment), offering 
insights into responses to immunotherapy and vaccination. However, two key 
challenges complicate this **clonotype-centric** approach:

1.  **Extreme diversity and privacy**: TCRs/BCRs are highly
    personalized, with incomplete sampling particularly problematic in
    clinical settings where sample volumes are limited. Even
    comprehensive sampling reveals minimal repertoire overlap in terms of
    clonotypes between individuals.

2.  **Similar TCRs/BCRs recognize the same antigen**: consequently, analyses 
    focused on exact clonotypes may miss biologically meaningful shared immune 
    responses.


This vignette introduces `r Biocpkg("ClustIRR")`, a computational method
that addresses these challenges by: (1) Identifying specificity-associated 
receptor communities through sequence clustering, and (2) Applying Bayesian 
models to quantify differential community abundance across conditions.

# Installation

`r Biocpkg("ClustIRR")` is freely available as part of Bioconductor,
filling the gap that currently exists in terms of software for
quantitative analysis of IRRs.

To install `r Biocpkg("ClustIRR")` please start R and enter:

```{r, eval=FALSE}
if(!require("BiocManager", quietly = TRUE)) {
  install.packages("BiocManager")
}
BiocManager::install("ClustIRR")
```


# System requirements
The BLAST+ software needs to be installed on your system. Installation
instructions are available in this package's
[INSTALL](https://github.com/mhahsler/rBLAST/blob/devel/INSTALL) file and
at \url{https://www.ncbi.nlm.nih.gov/books/NBK569861/}.

R needs to be able to find the executable. After installing the software,
try in R

```{r, eval=run}
Sys.which("blastp")
```

If the command returns "" instead of the path to the executable,
then you need to set the environment variable called PATH. In R

```{r, eval=run}
Sys.setenv(PATH = paste(Sys.getenv("PATH"),
   "path_to_your_BLAST_installation", sep=.Platform$path.sep))
```


# ClustIRR algorithm

```{r graphic, echo = FALSE, fig.align="left", out.width='100%'}
knitr::include_graphics("../inst/extdata/logo.png")
```

## Input

The main input of `r Biocpkg("ClustIRR")` is a repertoire (`s`), which
should be provided as data.frame. The rows in the data.frame correspond
to **clonotype** (clonotype = group of cells derived from a common parent 
cell by clonal expansion). We use the following data from each clonotype:

-   **CDR3 amino acid sequences** from one/both chains (e.g.
    CDR3$\alpha$ and CDR3$\beta$ from TCR$\alpha\beta$s).
-   **Clone size**, which refers to the frequency of cells that belong
    to the clonotype.

In a typical scenario, the user will have more than one repertoire (see
workflow). For instance, the user will analyze longitudinal repertoire
data, i.e., two or three repertoires taken at different time points; or
across different biological conditions.

Let's look at dataset `D1` that is provided within
`r Biocpkg("ClustIRR")`. `D1` contains three TCR$\alpha\beta$
repertoires: $a$, $b$, and $c$ and their metadata: `ma`, `mb` and `mc`.

```{r}
data("D1", package = "ClustIRR")
str(D1)
```

Extract the data.frames for each TCR repertoire and their metadata:

We will merge three TCR repertoires into the data.frame tcr_reps.

```{r}
tcr_reps <- rbind(D1$a, D1$b, D1$c)
```

We will do the same for the metadata

```{r}
meta <- rbind(D1$ma, D1$mb, D1$mc)
```

## Algorithm

`r Biocpkg("ClustIRR")` performs the following steps.

1.  Compute similarities between T-cell clonotypes within each TCR
    repertoire

2.  Construct a graph from each TCR repertoire

3.  Construct a joint similarity graph ($J$)

4.  Detect communities in $J$

5.  Analyze Differential Community Occupancy (DCO)

    a\. Between individual TCR repertoires with model $M$

    b\. Between groups of TCR repertoires from biological conditions
    with model $M_h$

6.  Inspect results

## **Step 1.** Compute TCR clonotype similarities in a repertoire with `cluster_irr`

`r Biocpkg("ClustIRR")` aims to quantify the similarity between pairs of
TCR clonotypes based on the similarities of their CDR3s sequences. For this
it employs Basic Local-Alignment Search Tool (BLAST) via the R-package
`r CRANpkg("blaster")`. Briefly, a protein database is constructed from
all CDR3 sequences, and each CDR3 sequence is used as a query. This
enables fast sequence similarity searches. Furthermore, only CDR3
sequences matches with $\geq$ 80% sequence identity to the query are
retained. This step reduces the computational and memory requirements,
without impacting downstream community analyses, as CDR3 sequences with
lower typically yield low similarity scores.

For matched CDR3 pair, an alignment score ($\omega$) is computed using
BLOSUM62 substitution scores with gap opening penalty of -10 and gap
extension penalty of -4. $\omega$ is the sum of substitution scores and
gap penalties in the alignment. Identical or highly similar CDR3
sequence pairs receive large positive $\omega$ scores, while dissimilar
pairs receive low or negative $\omega$. To normalize $\omega$ for
alignment length, `r Biocpkg("ClustIRR")` computes
$\bar{\omega} = \omega/l$, where $l$ is the alignment length yielding
normalized alignment score $\bar{\omega}$. This normalization, also used
in iSMART (Zhang, 2020), ensures comparability across CDR3 pairs of
varying lengths.

`r Biocpkg("ClustIRR")` also computes alignment scores for the CDR3
**core** regions ($\omega^c$ and $\bar{\omega}^c$). The CDR3 core,
representing the central loop region with high antigen-contact
probability (Glanville, 2017), is generated by trimming three residues
from each end of the CDR3 sequence. Comparing $\bar{\omega}^c$ and
$\bar{\omega}$ allows assessment of whether sequence similarity is
concentrated in the core or flanking regions.

## **Step 2-3.** Construct TCR repertoire graphs and join them into $J$

Next, `r Biocpkg("ClustIRR")` builds a graph for each TCR repertoire.
The graphs have *nodes* and *weighted edges*:

-   nodes: clonotypes from each TCR repertoire. Each clonotype attribute 
    (clone size, CDR3 sequences, etc.) is provided as node attribute
-   edges: undirected edges connecting pairs of nodes based on
    CDR3$\alpha$ and CDR3$\beta$ similarity scores ($\bar{\omega}$ and
    $\bar{\omega}^c$) in each TCR repertoire (computed in step 1.)

Then the graphs are joined together: edges between TCR clonotypes from
different TCR repertoires are computed using the same procedure outlined
in step 1. The joint graph $J$ is stored as an `igraph` object.

## Run steps 1-3 with `clustirr`

Step 1. involves calling the function `clust_irr` which returns an S4
object of class `clust_irr`.

```{r, eval=run}
cl <- clustirr(s = tcr_reps, meta = meta, control = list(blast_gmi = 0.8))
```

The output **complex** list with three elements:

1.  `graph` = the joint graph $J$

2.  `clust_irrs` = list with S4 `clust_irr` objects one for each TCR
    repertoire

3.  `multigraph` = logical value which tell us whether $J$ contains
    multiple or a single TCR repertoire

### Inspect the content of `clust_irrs`

We can look at the similarity scores between CDR3 sequences of TCR
repertoire `a`. Each row is a pair of CDR3 sequences from the repertoire
annotated with the following metrics:

-   `max_len`: length of the longer CDR3 sequence in the pair
-   `max_clen`: length of the longer CDR3 core sequence in the pair
-   `weight`: $\omega$ = BLOSUM62 score of the **complete** CDR3
    alignment
-   `cweight`= $\omega_c$: BLOSUM62 score of CDR3 **cores**
-   `nweight` = $\bar{\omega}$: normalized `weight` by `max_len`
-   `ncweight` = $\bar{\omega}_c$: normalized `cweight` by `max_clen`

The results for CDR3$\alpha$ sequence pairs from repertoire `a`:

```{r, eval=run}
kable(head(cl$clust_irrs[["a"]]@clust$CDR3a), digits = 2)
```

... the same table for CDR3$\beta$ sequence pairs from repertoire `a`:

```{r, eval=run}
kable(head(cl$clust_irrs[["a"]]@clust$CDR3b), digits = 2)
```

Notice that very similar CDR3$\alpha$ or CDR3$\beta$ pairs have high
normalized alignment scores ($\bar{\omega}$). We have similar tables for
repertoire `b` and `c`. These are used internally to construct graphs in
the next step.

### Inspect graphs with `plot_graph`

We can use the function `plot_graph` for interactive visualization of
relatively small graphs.

The function `clust_irr` performs automatic annotation of TCR clonotypes
based on multiple databases (DBs), including: VDJdb, TCR3d, McPAS-TCR.
Each TCR clonotype recieves two types of annotations (per chain and per
database):

-   **Ag_species**: the name of the antigen species recognized by the
    clonotype's CDR3

-   **Ag_gene**: the name of the antigen gene recognized by clonotype's CDR3

Hence, in the plot we can highlight TCR clonotypes that recognize certain
antigenic species or genes (see dropdown menu), or use the hoovering
function to look at the CDR3 sequences of nodes.

Do this now!

```{r, eval=run}
plot_graph(cl, select_by = "Ag_species", as_visnet = TRUE)
```

Notice that even in this small case study--where each TCR repertoire
contains **only 500 TCR clonotypes**--we observe that the **joint graph is
complex**! This complexity makes qualitative analyses impractical. To
address this, `r Biocpkg("ClustIRR")` focuses on **quantitative
analyses** (see the next steps).

### You can evaluate $J$ with igraph

We can use igraph functions to inspect various properties of the graph
in `cl$graph`. For instance, below, we extract the edge attributes and
visualize the distributions of the edge attributes `ncweight` and
`nweight` for all CDR3$\alpha$ and CDR3$\beta$ sequence pairs.

```{r, fig.width=6, fig.height=4.5, eval=run}
# data.frame of edges and their attributes
e <- igraph::as_data_frame(x = cl$graph, what = "edges")
```

```{r, fig.width=5, fig.height=3.5, eval=run}
ggplot(data = e)+
  geom_density(aes(ncweight, col = chain))+
  geom_density(aes(nweight, col = chain), linetype = "dashed")+
  xlab(label = "edge weight (solid = ncweight, dashed = nweight)")+
  theme(legend.position = "top")
```

Can you guess why we observe **trimodal** distributions?

-   *Top mode: weights of identical CDR3 sequence pairs from the
    different TCR repertoires*

-   *Middle mode: weights of CDR3 sequences with same lengths*

-   *Bottom mode: weights of CDR3 sequences with different lengths -\>
    scores penalized by gap cost*

## **Step 4.** community detection with `detect_communities`

`r Biocpkg("ClustIRR")` employs graph-based community detection (GCD)
algorithms, such as Louvain, Leiden or InfoMap, to identify
**communities** of nodes that have high density of edges among each
other, and low density of edges with nodes outside the community.

First, the similarity score between T-cell clonotypes $i$ and $j$ is 
defined as the average CDR3$\alpha$ and CDR3$\beta$ alignment scores:

```{=tex}
\begin{align}
\omega(i,j) = \dfrac{{\bar{\omega}}_\alpha + {\bar{\omega}}_\beta}{2}
\end{align}
```
where $\bar{\omega}_\alpha$ and $\bar{\omega}_\beta$ are the alignment
scores for the CDR3$\alpha$ and CDR3$\beta$, respectively. If a chain is
missing, its alignment score is set to 0.

The user has the following options:

-   `algorithm`: "leiden" (default) "louvain", or "infomap"
-   `resolution`: GCD resolution = 1 (default)
-   `iterations`: number of clustering iterations (default = 100) to
    ensure robust results
-   `chains`: "CDR3a" or "CDR3b" or c("CDR3a", "CDR3b")

```{r, eval=run}
gcd <- detect_communities(graph = cl$graph, 
                          algorithm = "leiden",
                          metric = "average",
                          resolution = 1,
                          iterations = 100,
                          chains = c("CDR3a", "CDR3b"))
```

### Inspecting the outputs of `detect_communities`

The function `detect_communities` generates a complex output. Lets
investigate its elements:

```{r, eval=run}
names(gcd)
```

The main element is `community_occupancy_matrix`, which contains the
number of T-cells in each community (row) and repertoire (column). Here
we have three repertoires (three columns) and over 400 communities.
This matrix is the main input of the function `dco` (step 5.), to detect
differences in the community occupancy between repertoires.

```{r, eval=run}
dim(gcd$community_occupancy_matrix)
```

```{r, eval=run}
head(gcd$community_occupancy_matrix)
```

### **Qualitative** similarity between community abundance vectors with `get_honeycombs`

```{r, fig.width=5, fig.height=5, eval=run}
honeycomb <- get_honeycombs(com = gcd$community_occupancy_matrix)
```

In the **honeycomb plots** shown below, several communities (black dots)
appear **far** from the diagonal. This indicates that these communities
contain more cells in repertoires b and c (y-axes in panels A and B)
compared to repertoire a (x-axes in panels A and B). Meanwhile, the same
points are generally close to the diagonal in panel C but remain
slightly more abundant in repertoire c (y-axis) compared to b (x-axis).

In step 5, `r Biocpkg("ClustIRR")` will provide a quantitative answer to
the question: *Which communities are differentially abundant between
pairs of repertoires?*

Importantly, the color of the hexagons encodes the density of
communities in the 2D scatterplots: **dark hexagons** indicate high a
frequency of communities, while **light hexagons** represent sparsely
populated regions.

```{r, fig.width=10, fig.height=2.5, eval=run}
wrap_plots(honeycomb, nrow = 1)+
    plot_annotation(tag_levels = 'A')
```

### **Quantitative** similarity between community abundance vectors with `get_cosine_similarity`

In the **heatmap** shown below, we see high cosine similarity (CS) close 
to 1 between repertoires b vs. c, and lower CS values (0.55 -- 0.75) 
between a vs. b/c. This is consistent with the qualitative honeycomb plot 
based analysis.

```{r, fig.width=3, fig.height=2.5, eval=run}
cos_sim <- get_cosine_similarity(com = gcd$community_occupancy_matrix)
cos_sim$g
```

### Summary of communities is provided in the `detect_communities` outputs  

See the object `community_summary`. In this data.frame we provide
community summaries in each community across all TCR repertoires,
including:

-   `clones_a`, `clone_b`, `clone_c`, `clones_n`: the frequency of
    clonotypes in the community coming from repertoire `a`, `b`, `c` and in
    total (n)
-   `cells_a`, `cells_b`, `cells_c`, `cells_n`: the frequency of cell in
    the community coming from repertoires `a`, `b`, `c` and in total (n)
-   `w`: average inter-clonotype similarity
-   `ncweight_CDR3a/b`, `nweight_CDR3a/b`: raw and normalized similarity
    for CDR3$\alpha$ and CDR3$\beta$ sequences
-   `n_CDR3a`, `n_CDR3b`: number of edges between CDR3$\alpha$ and
    CDR3$\beta$ sequences

```{r, eval=run}
kable(head(gcd$community_summary), digits = 1, 
      row.names = FALSE)
```


Node-specific (TCR clonotype-specific) summaries are provided in `node_summary`

```{r, eval=run}
kable(head(gcd$node_summary), digits = 1, row.names = FALSE)
```


### Special functions: decoding communities with `decode_community`

Community with ID=22 contains 12 TCR clonotypes. These 
are connected based on their CDR3$\alpha$ and CDR3$\beta$ 
sequences.

```{r, eval=run}
ns_com <- gcd$node_summary[gcd$node_summary$community == 22, ]

table(ns_com$sample)
```

We can extract it and visualize it using igraph:

```{r, fig.width=6, fig.height=4, eval=run}
par(mai = c(0,0,0,0))
plot(subgraph(graph = gcd$graph, vids = which(V(gcd$graph)$community == 22)))
```

Furthermore, we can "decompose" this graph using `decode_community`
based on the attributes of the edges (`edge_filter`) and nodes
(`node_filter`).

```{r, eval=run}
# we can pick from these edge attributes
edge_attr_names(graph = gcd$graph)
```

The following edge-filter will instruct ClustIRR to keep edges with with
edge attributes: nweight $>=$ 4 **AND** ncweight $>=$ 4

```{r, eval=run}
edge_filter <- rbind(data.frame(name = "nweight", value = 4, operation = ">="),
                     data.frame(name = "ncweight", value = 4, operation = ">="))
```

```{r, eval=run}
# we can pick from these node attributes
vertex_attr_names(graph = gcd$graph)
```

The following node-filter will instruct ClustIRR to retain edges between
nodes that have shared node attributed with respect to **ALL** of the
following node attributes:

```{r, eval=run}
node_filter <- data.frame(name = c("TRBV", "TRAV"))
```

```{r, eval=run}
c22 <- decode_community(community_id = 22, 
                        graph = gcd$graph,
                        edge_filter = edge_filter,
                        node_filter = node_filter)
```

```{r, fig.width=6, fig.height=4, eval=run}
par(mar = c(0, 0, 0, 0))
plot(c22$community, vertex.size = 10)
```

```{r, eval=run}
kable(as_data_frame(x = c22$community, what = "vertices")
      [, c("name", "component_id", "CDR3b", "TRBV", 
           "TRBJ", "CDR3a", "TRAV", "TRAJ")],
      row.names = FALSE)
```

... or we can summarize the properties of each component in the next
table as rows with:

-   component id, community id (=22 in this example because this is what
    we selected)
-   mean edge weights (for all core and complete CDR3 pairs)
-   number of nodes, number of edges and expected number edges if the
    component were a clique
-   diameter of the component

```{r, eval=run}
kable(c22$component_stats, row.names = FALSE)
```

## **Step 5.** differential community occupancy (DCO) with `dco`

Do we see **expanding** or **contracting** communities in a given
repertoire?

We employ a Bayesian model to quantify the relative abundance
(occupancy) of individual communities in each repertoire.

The model output for repertoire $a$ is the parameter vector
$\beta^a=\beta^a_1,\beta^a_2,\ldots,\beta^a_k$, which describes the
effect of repertoire $a$ on the relative occupancy in each community.

Given two repertoires, $a$ and $b$, we can quantify the differential
community occupancy (DCO):

```{=tex}
\begin{align}
\delta^{a-b}_i = \beta^a_i - \beta^b_i
\end{align}
```

```{r, eval=run}
d <- dco(community_occupancy_matrix = gcd$community_occupancy_matrix,
         mcmc_control = list(mcmc_warmup = 300,
                             mcmc_iter = 600,
                             mcmc_chains = 2,
                             mcmc_cores = 1,
                             mcmc_algorithm = "NUTS",
                             adapt_delta = 0.9,
                             max_treedepth = 10))
```

## **Step 6.** Inspect results

### Visualizing the distribution of $\beta$ with `get_beta_violin_ag`

```{r, eval=run}
beta_violins <- get_beta_violin_ag(node_summary = gcd$node_summary,
                                   beta = d$posterior_summary$beta,
                                   ag = "",
                                   ag_species = TRUE,
                                   db = "vdjdb")
```

```{r, fig.width=5, fig.height=3, eval=run}
beta_violins
```

### Compare $\beta$s of clonotypes specific for *CMV*, *EBV*, *flu* or *MLANA*?

```{r, eval=run}
beta_violins <- get_beta_violin_ag(node_summary = gcd$node_summary,
                                   beta = d$posterior_summary$beta,
                                   ag = "CMV",
                                   ag_species = TRUE,
                                   db = "vdjdb")
```

```{r, fig.width=4, fig.height=3, eval=run}
beta_violins
```


### Posterior predictive checks

Before we can start interpreting the model results, we have to make sure
that the model is valid. One standard approach is to check whether our
model can retrodict the observed data (community occupancy matrix) which
was used to fit model parameters.

General idea of posterior predictive checks:

1.  fit model based on data $y$
2.  simulate new data $\hat{y}$
3.  compare $y$ and $\hat{y}$

`r Biocpkg("ClustIRR")` provides $y$ and $\hat{y}$ of each repertoire,
which we can visualize with ggplot:

```{r, fig.width=6, fig.height=2.5, eval=run}
ggplot(data = d$posterior_summary$y_hat)+
  facet_wrap(facets = ~sample, nrow = 1, scales = "free")+
  geom_abline(intercept = 0, slope = 1, linetype = "dashed", col = "gray")+
  geom_errorbar(aes(x = y_obs, y = mean, ymin = L95, ymax = H95),
                col = "darkgray", width=0)+
  geom_point(aes(x = y_obs, y = mean), size = 0.8)+
  xlab(label = "observed y")+
  ylab(label = "predicted y (and 95% HDI)")
```

### Differential community abundance results $\rightarrow$ par. $\delta$

Given two repertoires, $a$ and $b$, we can quantify the differential
community occupancy (DCO):

```{=tex}
\begin{align}
\delta^{a-b}_i = \beta^a_i - \beta^b_i
\end{align}
```

Importantly, `r Biocpkg("ClustIRR")` always computes both contrasts ($a$
vs. $b$ and $b$ vs. $a$): $\delta^{a-b}_i$ and $\delta^{b-a}_i$.

```{r, fig.width=7, fig.height=6, eval=run}
ggplot(data = d$posterior_summary$delta)+
    facet_wrap(facets = ~contrast, ncol = 2)+
    geom_errorbar(aes(x = community, y = mean, ymin = L95, ymax = H95), 
                  col = "lightgray", width = 0)+
    geom_point(aes(x = community, y = mean), shape = 21, fill = "black", 
               stroke = 0.4, col = "white", size = 1.25)+
    theme(legend.position = "top")+
    ylab(label = expression(delta))+
    scale_x_continuous(expand = c(0,0))
```

Given two repertoires, $a$ and $b$, `r Biocpkg("ClustIRR")` also
quantifies absolute differences in community probabilities:

```{=tex}
\begin{align}
\epsilon^{a-b} = \mathrm{softmax}(\alpha + \beta^a) - 
\mathrm{softmax}(\alpha + \beta^b)
\end{align}
```

Again, both contrasts are computed: $\epsilon^{a-b}_i$ and
$\epsilon^{b-a}_i$.

```{r, fig.width=7, fig.height=6, eval=run}
ggplot(data = d$posterior_summary$epsilon)+
    facet_wrap(facets = ~contrast, ncol = 2)+
    geom_errorbar(aes(x = community, y = mean, ymin = L95, ymax = H95), 
                  col = "lightgray", width = 0)+
    geom_point(aes(x = community, y = mean), shape = 21, fill = "black", 
               stroke = 0.4, col = "white", size = 1.25)+
    theme(legend.position = "top")+
    ylab(label = expression(epsilon))+
    scale_x_continuous(expand = c(0,0))
```

```{r, echo=FALSE, include=FALSE, eval=run}
rm(a, b, cl_a, cl_b, cl_c, meta_a, meta_b, meta_c, d, e, g, gcd)
```

## Conclusion: you can also use **custom** community occupancy matrix for DCO!

The function `dco` takes as its main input a community occupancy matrix.
This enables users who are accustomed to using complementary algorithm
for detecting specificity groups, such as, GLIPH, TCRdist3, GIANA, and
iSMART, to skip steps 1-4 of the `r Biocpkg("ClustIRR")` workflow, and
to proceed with analysis for DCO.

\docType{data}
\name{tcr3d}
\alias{tcr3d}
\title{CDR3 sequences and their matching epitopes obtained from TCR3d}

\format{
\code{data.frame} with columns: 
\enumerate{
\item \code{CDR3a}: CDR3a amino acid sequence
\item \code{CDR3b}: CDR3b amino acid sequence
\item \code{CDR3g}: CDR3g amino acid sequence -> NA
\item \code{CDR3d}: CDR3d amino acid sequence -> NA
\item \code{CDR3h}: CDR3h amino acid sequence -> NA
\item \code{CDR3l}: CDR3l amino acid sequence -> NA
\item \code{CDR3_species}: CDR3 species (e.g. human, mouse, ...)   
\item \code{Antigen_species}: antigen species
\item \code{Antigen_gene}: antigen gene
\item \code{Reference}: Reference ID
}
}

\source{
\href{https://tcr3d.ibbr.umd.edu/}{TCR3d, June 2024}
}
\usage{
data(tcr3d)
}
\description{
data.frame with paired \code{CDR3a} and \code{CDR3b} CDR3 sequences and their 
matching epitopes obtained from TCR3d. The remaining CDR3 columns are set to 
NA. The antigenic epitopes come from cancer antigens and from viral antigens. 
For data processing details see the script inst/script/get_tcr3d.R
}
\examples{
data("tcr3d")
}
\value{
data(tcr3d) loads the object tcr3d
}
\keyword{datasets}

\docType{data}
\name{mcpas}
\alias{mcpas}
\title{CDR3 sequences and their matching epitopes obtained from McPAS-TCR}

\format{
\code{data.frame} with columns: 
\enumerate{
\item \code{CDR3a}: CDR3a amino acid sequence
\item \code{CDR3b}: CDR3b amino acid sequence
\item \code{CDR3g}: CDR3g amino acid sequence -> NA
\item \code{CDR3d}: CDR3d amino acid sequence -> NA
\item \code{CDR3h}: CDR3h amino acid sequence -> NA
\item \code{CDR3l}: CDR3l amino acid sequence -> NA
\item \code{CDR3_species}: CDR3 species (e.g. human, mouse, ...)
\item \code{Antigen_species}: antigen species
\item \code{Antigen_gene}: antigen gene
\item \code{Reference}: Reference (Pubmed ID)
}
}
\source{
\href{http://friedmanlab.weizmann.ac.il/McPAS-TCR/}{McPAS-TCR, June 2024}
}
\usage{
data(mcpas)
}
\description{
data.frame with \code{CDR3a} and/or \code{CDR3b} sequences and their 
matching antigenic epitopes obtained from McPAS-TCR. The remaining CDR3 
columns are set to NA. For data processing details see the script 
inst/script/get_mcpastcr.R
}
\examples{
data(mcpas)
}
\value{
data(mcpas) loads the object McPAS-TCR
}
\keyword{datasets}

\name{BLOSUM62}
\alias{BLOSUM62}
\docType{data}
\title{
BLOSUM62 matrix
}
\description{
Predefined scoring matrix for amino acid or nucleoitide alignments.
}
\usage{data("BLOSUM62")}
\format{
BLOSUM62 is a square symmetric matrix. Rows and columns are identical 
single letters, representing nucleotide or amino acid. Elements are 
integer coefficients (substitution scores).
}
\details{
BLOSUM62 was obtained from NCBI (the same matrix used by the stand-
alone BLAST software). 
}
\source{
See https://ftp.ncbi.nih.gov/blast/matrices/BLOSUM62
}
\references{
See https://ftp.ncbi.nih.gov/blast/matrices/BLOSUM62
}
\examples{
data(BLOSUM62, package = "ClustIRR")
BLOSUM62
}
\keyword{datasets}

\name{get_community_feature_stats}
\alias{get_community_feature_stats}
\title{Compute descriptive statistics of a community node feature}
\description{
Given a \code{node_summary} object containing community assignments and node-
level attributes, this function computes descriptive statistics of a specified 
node feature within a single community.
}
\details{
The function requires a \code{node_summary} data.frame containing a
\code{community} column and a valid \code{node_feature} column.

The type of statistics returned depends on whether the node feature is numeric
or categorical:

\itemize{
\item For numeric features, the function computes mean, median, sum, and the
number of nodes.
\item For categorical (character, factor, or logical) features, the function
computes counts and proportions for each feature level.
}

The community identifier is inferred from the \code{community} column and is
assumed to be constant within \code{node_summary}.
}
\usage{
get_community_feature_stats(node_summary, node_feature, community_id)
}
\arguments{
\item{node_summary}{A data.frame containing node-level attributes and a
\code{community} column.}
\item{node_feature}{Character scalar specifying the node attribute for which
statistics should be computed.}
\item{community_id}{Numeric community ID}
}
\value{
A \code{data.frame} summarizing feature statistics for the given community:

\itemize{
\item For numeric features: columns \code{community}, \code{feature},
\code{feature_mean}, \code{feature_median}, \code{feature_sum},
\code{feature_type}, and \code{n}.
\item For categorical features: columns \code{community}, \code{feature},
\code{feature_count}, \code{feature_prop}, \code{feature_type}, and \code{n}.
}
}
\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("D1", package = "ClustIRR")
    
    # run ClustIRR analysis
    c <- clustirr(s = rbind(D1$a, D1$b), meta = rbind(D1$ma, D1$mb))
    
    # detect communities
    gcd <- detect_communities(graph = c$graph, 
                              algorithm = "leiden",
                              metric = "average",
                              resolution = 1,
                              iterations = 100,
                              chains = c("CDR3a", "CDR3b"))
    
    # numeric feature
    get_community_feature_stats(
        community_id = 1,
        node_summary = gcd$node_summary,
        node_feature = "age")
    
    # categorical feature
    get_community_feature_stats(
        community_id = 1,
        node_summary = gcd$node_summary,
        node_feature = "HLA_A")
}
}

\docType{data}
\name{Datasets}
\alias{CDR3ab}
\alias{D1}
\alias{D2}
\title{Datasets \code{CDR3ab}, \code{D1} and \code{D2} with TCR\eqn{\alpha\beta} 
mock repertoires}

\format{
CDR3ab is a \code{data.frame} with rows as TCR clones and 6 columns 
\itemize{
\item \code{CDR3a}: CDR3\eqn{\alpha} amino acid sequence
\item \code{TRAV}: variable (V) gene of TCR\eqn{\alpha}
\item \code{TRAV}: joining (J) gene of TCR\eqn{\alpha}
\item \code{CDR3b}: CDR3\eqn{\beta} amino acid sequence
\item \code{TRBV}: variable (V) gene of TCR\eqn{\beta}
\item \code{TRBV}: joining (J) gene of TCR\eqn{\beta}
}
}
\source{
\href{http://50.255.35.37:8080/}{GLIPH version 2}
}
\usage{
# For the raw data with 10,000 TCR clones
data(CDR3ab)

# For dataset D1
data(D1)

# For dataset D2
data(D2)
}
\description{
TCR\eqn{\alpha\beta} repertoire with 10,000 T-cells (rows). Each T-cell 
has the following features: amino acid sequences of their complementarity 
determining region 3 (CDR3); and variable (V) and joining (J) gene names 
for TCR chains \eqn{\alpha} and \eqn{\beta}. 

Important remark: this is a mock dataset, all CDR3 sequences and the genes were 
sampled from a larger set of CDR3\eqn{\beta} sequences and genes of naive 
CD8+ T cells in humans.

About dataset \code{D1}:

We used this data to create dataset D1: three TCR\eqn{\alpha\beta} 
repertoires \code{a}, \code{b}, and \code{c}, each with 500 TCR 
clones. We simulated clonal expansion with increasing degree in TCR 
repertoires \code{b} and \code{c}. The TCR repertoires are stored as 
element of a list. For each TCR repertoires we have a metadata: 
\code{ma}, \code{mb}, and \code{mc}.

About dataset \code{D2}:

We used \code{b} and \code{c} from D1 to create dataset D2. Three 
TCR\eqn{\alpha\beta} repertoires (replicates) were generated from 
two biological conditions: A (A1, A2, A3) and C (C1, C2, C3), each 
with 2,000 T-cells.
}
\examples{
data("CDR3ab")
data("D1")
data("D2")
}
\value{
data(CDR3ab) loads the object CDR3ab, which is a data.frame with six columns
(3 for TCR\eqn{\alpha} and 3 for TCR\eqn{\beta}) and rows for each TCR clone
(see details).
}
\keyword{datasets}

\name{detect_communities}
\alias{detect_communities}
\title{Graph-based community detection (GCD)}
\description{
Graph-based community detection in graphs constructed by \code{get_graph} 
or \code{get_joint_graph}.
}
\details{
ClustIRR employs graph-based community detection (GCD) algorithms, such as 
Louvain, Leiden or InfoMap, to identify \code{communities} of nodes that have 
high density of edges among each other, and low density of edges with nodes 
outside the community.
}
\usage{
detect_communities(graph,
                   algorithm = "leiden", 
                   metric = "average",
                   resolution = 1,
                   iterations = 100,
                   chains)
}
\arguments{
\item{graph}{\code{igraph} object}
\item{algorithm}{graph-based community detection (GCD) method: leiden 
(default), louvain or infomap.}
\item{metric}{possible metrics: "average" (default) or "max".}
\item{resolution}{clustering resolution (default = 1) for GCD.}
\item{iterations}{clustering iterations (default = 100) for GCD.}
\item{chains}{which chains should be used for clustering? For instance:
chains = "CDR3a"; or chains = "CDR3b"; or chains = c("CDR3a", "CDR3b").}
}
\value{
The output is a list with the folling elements:
\item{community_occupancy_matrix}{matrix, rows are communities, columns 
are repertoires, matrix entries are numbers of cells in each community and 
repertoire.}
\item{community_summary}{data.frame, rows are communities and their properties
are provided as columns.}
\item{node_summary}{data.frame, rows are nodes (clones) and their properties 
are provided as columnscontains all user provided.}
\item{graph}{igraph object, processed graph object.}
\item{graph_structure_quality}{graph modularity and quality (only for Leiden) 
measure of the strength of division of the graph into communities.}
\item{input_config}{list, inputs provided as list.}
}
\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("CDR3ab", package = "ClustIRR")
    a <- data.frame(CDR3a = CDR3ab[1:500, "CDR3a"],
                    CDR3b = CDR3ab[1:500, "CDR3b"],
                    clone_size = 1,
                    sample = "a")
    
    b <- data.frame(CDR3a = CDR3ab[401:900, "CDR3a"],
                    CDR3b = CDR3ab[401:900, "CDR3b"],
                    clone_size = 1,
                    sample = "b")
    b$clone_size[1] <- 20
    
    # run ClustIRR analysis
    c <- clustirr(s = rbind(a, b))
    
    # detect communities
    gcd <- detect_communities(graph = c$graph, 
                              algorithm = "leiden",
                              metric = "average",
                              resolution = 1,
                              iterations = 100,
                              chains = c("CDR3a", "CDR3b"))
    
    # look at outputs
    names(gcd)
    
    # look at the community occupancymatrix
    head(gcd$community_occupancy_matrix)
    
    # look at the community summary
    head(gcd$community_summary)
    
    # look at the node summary
    head(gcd$node_summary)
}
}

\name{clustirr}
\alias{clustirr}
\title{Clustering of immune receptor repertoires (IRRs)}
\description{
\code{clustirr} computes similarities between immune receptors (IRs = 
T-cell and B-cell receptors) based on their CDR3 sequences.
}
\usage{
clustirr(s,
         meta = NULL,
         control = list(blast_gmi = 0.8,
                        blast_cores = 1,
                        trim_flank_aa = 3,
                        db_dist = 0,
                        db_custom = NULL,
                        knn = FALSE,
                        k = 30))
}
\arguments{
\item{s}{a data.frame consisting of one or more IRRs. Each row is a clone
of a given IRR with the following columns (clone features):
\itemize{
\item{\code{sample}: names of the repertoires (e.g. 'A', 'B', etc.)}
\item{\code{clone_size}: cell count in the clone (=clonal expansion)}
\item{\code{CDR3?}: amino acid CDR3 sequence. Replace '?' with the appropriate 
name of the immmune receptor chain (e.g. CDR3a for CDR3s from TCR\eqn{\alpha} 
chain; or CDR3d for CDR3s from TCR\eqn{\delta} chain}. Meanwhile, if paired 
CDR3s from both chains are available, then you can provide both in separate 
columns e.g.:
\itemize{
    \item \emph{CDR3b} and \emph{CDR3a} [for \eqn{\alpha\beta} TCRs]
    \item \emph{CDR3g} and \emph{CDR3d} [for \eqn{\gamma\delta} TCRs]
    \item \emph{CDR3h} and \emph{CDR3l} [for heavy/light chain BCRs]
}
}
}
\item{meta}{data.frame with meta-data for each clone, which may contain
clone-specific data, such as, V/J genes, cell-type (e.g. CD8+, CD4+), nut
also repertoire-specific data, such as, biological condition, HLA type, 
age, etc. This data will be used to annotate the graph nodes and help 
downstream analyses.}
\item{control}{auxiliary parameters to control the algorithm's behavior. See 
the details below:
\itemize{
\item \code{blast_gmi}: the minimum sequence identity between a pair of CDR3 
sequences for them to even be considered for alignment and scoring 
(default = 0.8; 80 percent identity).
\item \code{blast_cores}: the number of cores to use with BLAST (default = 1).
\item \code{trim_flank_aa}: how many amino acids should be trimmed from 
the flanks of all CDR3 sequences to isolate the \bold{CDR3 cores}. 
\code{trim_flank_aa} = 3 (default).
\item \code{db_custom}: additional database (data.frame) which allows us 
to annotate CDR3 sequences from the input (\code{s}) with their cognate 
antigens. The structure of \code{db_custom} must be identical to that in 
\code{data(vdjdb, package = "ClustIRR")}. ClustIRR will use the internal 
databases if \code{db_custom}=NULL (default). Three databases (\bold{data 
only from human CDR3}) are integrated in ClustIRR: \code{VDJdb}, \code{TCR3d}
and \code{McPAS-TCR}. 
\item \code{db_dist}: we compute edit distances between CDR3 sequences from 
\code{s} and from a database (e.g. VDJdb). If a particular distance is 
smaller than or equal to \code{db_dist} (default = 0), then we annotate 
the CDR3 from \code{s} with the specificity of the database CDR3 sequence.
\item \code{knn and k}: Should ClustIRR use a k-nearest-neighbor (KNN)
approach to construct the graphs? The default is \code{knn = FALSE}.
If \code{knn = TRUE}, \code{k} specifies the maximum number of neighbors
each node can have per chain. For example, with paired-chain data and
\code{k = 1}, a node can have at most two neighbors (one per chain).
If the analysis involves graph joining, then for each pair of graphs
a node may have up to \code{k} neighbors per chain.}
}
}
\value{
The output is a list with the following elements. 

\itemize{
\item graph: the resulting \code{igraph} object
\item clust_irrs: list of clust_irr objects for each repertoire (sample)

Each element is an \code{S4} object of class \code{clust_irr}. This object 
contains two sublists:
\itemize{
\item{\code{clust}, list, contains clustering results for each receptor chain. 
The results are stored as data.frame in separate sub-list named appropriately 
(e.g. CDR3a, CDR3b, CDR3g, etc.). Each row in the data.frames contains a pair 
of CDR3s.

The remaining columns contain similarity scores for the complete CDR3 sequences 
(column \code{weight}) or their cores (column \code{cweight}). The columns 
\code{max_len} and \code{max_clen} store the length of the longer CDR3 sequence
and core in the pair, and these used to normalize the scores \code{weight} and 
\code{cweight}: the normalized scores are shown in the columns \code{nweight} 
and \code{ncweight}}

\item{\code{inputs}, list, contains all user provided inputs (see Arguments)}
}

\item multigraph: logical variable multigraph, which is set to TRUE if
the graph is a joint graph made up of two or more repertoires (samples) 
and FALSE if the graph contains only one repertoire
}
}
\details{
ClustIRR performs the following steps.
\enumerate{ 
\item Compute similarities between clones within each repertoire 
\item Construct a graph from each TCR repertoire
\item Construct a joint similarity graph (\eqn{J})
\item Detect communities in \eqn{J}
\item Analyze Differential Community Occupancy (DCO)
\itemize{
    \item Between individual TCR repertoires with model \eqn{M}
    \item Between groups of TCR repertoires from biological conditions
    with model \eqn{M_h}
}
\item Inspect results
}
\strong{the function \code{clustirr} performs the steps 1. to 3.}
}
\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("CDR3ab", package = "ClustIRR")
    s <- data.frame(CDR3b = CDR3ab[1:100, "CDR3b"], sample = "A", clone_size=1)
    
    # run analysis
    c <- clustirr(s = s)
    
    # output class
    class(c)
    
    # output structure
    str(c)
}
}

\name{get_nrads}
\alias{get_nrads}
\title{Compute Normalized Rank Abundance Distributions (NRADs)}
\description{
This function NRADs for a given community occupancy matrix. It performs 
normalization using the \code{RADnormalization_matrix} function implemented
in \code{RADanalysis}.
}

\details{
The function computes the NRADs by ranking the community abundances in 
each sample (repertoire), determining the maximum rank, and normalizing 
the abundances using the \code{RADnormalization_matrix} function. The 
result is returned as a melted data frame containing the normalized abundances 
for each sample and rank. This enables comparison of community structures 
across repertoires with different depths (numbers of clonotypes).

The parameter \code{B} specifies the number of bootstrap iterations used in 
the normalization process. A higher value of \code{B} increases the stability 
and reliability of the normalized abundances but also increases computation 
time. The default value is 1000, which is a common choice for balancing 
accuracy and computational efficiency.
}

\usage{
  get_nrads(community_occupancy_matrix, B = 1000)
}

\arguments{
  \item{community_occupancy_matrix}{A matrix where rows represent communities 
  and columns represent samples (generated by \code{detect_communities}). 
  Entries are the abundances of communities in each sample (column).}
  \item{B}{A positive integer specifying the number of iterations for 
  averaging during normalization. Default is 1000.}
}

\value{
  A data frame containing the normalized abundances for each sample and rank. 
  The data frame has the following columns:
  \itemize{
    \item{sample: The sample identifier.}
    \item{rank: The rank of the abundance.}
    \item{norm.abundance: The normalized abundance at the given rank.}
  }
}

\examples{
  # Example usage:
  # Create a sample community occupancy matrix
  community_occupancy_matrix <- matrix(rpois(100, lambda = 10),nrow=20,ncol=5)
  
  # Compute normalized RADs
  nrads <- get_nrads(community_occupancy_matrix, B = 100)
  
  # Display the first few rows of the result
  head(nrads)
}

\name{get_community_feature_purity}
\alias{get_community_feature_purity}
\title{Compute community purity with respect to a node feature}
\description{
Compute the purity of graph communities with respect to a node feature.

Given a \code{node_summary} object returned by \code{detect_communities} 
containing a \code{community} column, this function evaluates how homogeneous 
each community is with respect to a specified node feature.

If the feature is numeric (e.g., gene expression, clone size), purity is 
measured using the coefficient of variation (CV). If the feature is categorical 
(e.g., tissue type, sample, or cell type), purity is measured using 
Gini impurity (GI) and Shannon's entropy (H). For binary categorical features, 
the signed dominance score (D) is additionally reported to indicate which 
class dominates a community.
}
\details{
The function verifies that \code{node_summary} contains a \code{community}
column and that the requested \code{node_feature} exists. The feature type is 
determined automatically.

For categorical features, purity metrics are computed per community:

\itemize{
\item \strong{Gini impurity (GI)} measures the probability that two randomly 
selected nodes from the community have different feature labels.
\item \strong{Shannon's entropy (H)} measures how evenly feature labels are 
distributed within the community.
\item \strong{Signed dominance (D)} is computed when the feature has exactly 
two classes and quantifies which class dominates the community.
}

Lower values of GI and H indicate higher purity (i.e., communities dominated 
by a single feature value). The dominance score ranges from -1 to 1, where 
positive and negative values indicate dominance of one or the other class.

For numeric features, the coefficient of variation (CV) is computed:

\itemize{
\item \strong{Mean} and \strong{standard deviation (sd)} are computed per community.
\item \strong{CV = sd / mean} measures the relative dispersion of the feature 
within the community.
}

Lower CV values indicate more homogeneous communities with respect to the 
numeric feature.
}
\usage{
get_community_feature_purity(node_summary, node_feature)
}
\arguments{
\item{node_summary}{
A \code{data.frame} returned by \code{detect_communities} containing node 
attributes and a column named \code{community}.
}

\item{node_feature}{
Character scalar specifying the node attribute for which community purity 
should be evaluated. The feature must be either numeric or categorical.
}
}
\value{
A \code{data.frame} summarizing purity statistics for each community.

For categorical features the returned columns are:

\itemize{
\item \code{community} – community identifier
\item \code{GI} – Gini impurity
\item \code{H} – Shannon's entropy
\item \code{D} – signed dominance score (only meaningful for binary features)
\item \code{n} – number of nodes in the community
}

For numeric features the returned columns are:

\itemize{
\item \code{community} – community identifier
\item \code{mean} – mean feature value
\item \code{sd} – standard deviation
\item \code{n} – number of nodes in the community
\item \code{cv} – coefficient of variation
}
}
\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("D1", package = "ClustIRR")
    
    # run ClustIRR analysis
    c <- clustirr(s = rbind(D1$a, D1$b), meta = rbind(D1$ma, D1$mb))
    
    # detect communities
    gcd <- detect_communities(graph = c$graph, 
                              algorithm = "leiden",
                              metric = "average",
                              resolution = 1,
                              iterations = 100,
                              chains = c("CDR3a", "CDR3b"))
    
    # categorical feature
    get_community_feature_purity(node_summary = gcd$node_summary, 
                                 node_feature = "HLA_A")
    
    # another categorical feature
    get_community_feature_purity(node_summary = gcd$node_summary, 
                                 node_feature = "TRAV")
    
    # numeric feature
    get_community_feature_purity(node_summary = gcd$node_summary, 
                                 node_feature = "age")
}
}

\name{get_honeycombs}
\alias{get_honeycombs}
\title{Generate honycomb plot: visualize community occupancy of pairs of immune 
receptor repertoires}
\description{
Use the \code{community_occupancy_matrix} generated by the function 
\code{detect_communities} to generate honeycomb plots for each pair of
repertoires. In each plot, we will show communities (rows in the matric
\code{community_occupancy_matrix}) as dots and their intensities in a
pair of repertoires (x-axis and y-axis). The density of dots is encoded
by the color of the honeycomb-like hexagons.
}
\details{
Use the \code{community_occupancy_matrix} generated by the function 
\code{detect_communities} to generate honeycomb plots for each pair of
repertoires. In each plot, we will show communities (rows in the matric
\code{community_occupancy_matrix}) as dots and their intensities in a
pair of repertoires (x-axis and y-axis). The density of dots is encoded
by the color of the honeycomb-like hexagons.
}
\usage{
get_honeycombs(com)
}
\arguments{
\item{com}{\code{community_occupancy_matrix}, matrix generated by 
\code{detect_communities}}
}
\value{
The output is a list with ggplots. Given n repertoires (columns in input
\code{community_occupancy_matrix}), it will generate n*(n-1)/2 plots.
You can arrange the ggplots (or a portion of them) in any shape e.g. with 
the R-package patchwork.
}
\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("CDR3ab", package = "ClustIRR")
    a <- data.frame(CDR3a = CDR3ab[1:300, "CDR3a"],
                    CDR3b = CDR3ab[1:300, "CDR3b"],
                    clone_size = 1,
                    sample = "a")
    
    b <- data.frame(CDR3a = CDR3ab[201:400, "CDR3a"],
                    CDR3b = CDR3ab[201:400, "CDR3b"],
                    clone_size = 1,
                    sample = "b")
    b$clone_size[1] <- 20
    
    # run ClustIRR analysis
    c <- clustirr(s = rbind(a, b))
    
    # detect communities
    gcd <- detect_communities(graph = c$graph, 
                              algorithm = "leiden",
                              resolution = 1,
                              chains = c("CDR3a", "CDR3b"))
    
    # get honeycombs
    g <- get_honeycombs(com = gcd$community_occupancy_matrix)
    g
}
}

\name{dco}
\alias{dco}
\title{Model-based differential community occupancy (DCO) analysis}
\description{
This algorithm takes as input a community matrix, and quantifies the relative
enrichment/depletion of individual communities in each sample using a Bayesian
hierarchical model.
}
\usage{
dco(community_occupancy_matrix, mcmc_control, compute_delta=TRUE, groups = NA)
}
\arguments{
\item{community_occupancy_matrix}{matrix, rows are communities, columns 
are repertoires, matrix entries are numbers of cells in each community and 
repertoire.}
\item{mcmc_control}{list, configurations for the Markov Chain Monte Carlo 
(MCMC) simulation.}
\itemize{
\item mcmc_warmup = 750; number of MCMC warmups
\item mcmc_iter = 1500; number of MCMC iterations
\item mcmc_chains = 4; number of MCMC chains
\item mcmc_cores = 1; number of computer cores 
\item mcmc_algorithm = "NUTS"; which MCMC algorithm to use
\item adapt_delta = 0.95; MCMC step size
\item max_treedepth = 12; the max value, in exponents of 2, of what the binary 
tree size in NUTS should have.
}
\item{compute_delta}{should delta be computed by the Stan model? This may be 
take up extra memory.}
\item{groups}{vector with integers \eqn{\geq1}, one for each repertoire (column
in community_occupancy_matrix). This specifies the biological group of each 
repertoire (e.g. for cancer repertoire we may specify the index 1, and for 
normal repertoires the index 2). If this vector is specified, ClustIRR will 
employ a hierarchical model, modeling the dependence between the repertoires 
within each group. Else (which is the default setting in ClustIRR), ClustIRR 
will treat the repertoires as independent samples by employing a simpler model.}
}
\value{
The output is a list with the folling elements:
\item{fit}{model fit (stan object)}
\item{posterior_summary}{nested list with data.frames, summary of model 
parameters, including their means, medians, 95\% credible intervals, etc.
Predicted observations (y_hat), which are useful for posterior predictive
checks are also provided.}
\item{community_occupancy_matrix}{matrix, rows are communities, columns are 
repertoires, matrix entries are numbers of cells in each community and 
repertoire.}
\item{mcmc_control}{mcmc configuration inputs provided as list.}
\item{compute_delta}{the input compute_delta.}
\item{groups}{the input groups.}
}

\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("CDR3ab", package = "ClustIRR")
    a <- data.frame(CDR3a = CDR3ab[1:500, "CDR3a"],
                    CDR3b = CDR3ab[1:500, "CDR3b"],
                    clone_size = 1,
                    sample = "a")
    
    b <- data.frame(CDR3a = CDR3ab[401:900, "CDR3a"],
                    CDR3b = CDR3ab[401:900, "CDR3b"],
                    clone_size = 1,
                    sample = "b")
    b$clone_size[1] <- 20
    
    # run ClustIRR analysis
    c <- clustirr(s = rbind(a, b))
    
    # detect communities
    gcd <- detect_communities(graph = c$graph, 
                              algorithm = "leiden",
                              resolution = 1,
                              iterations = 100,
                              chains = c("CDR3a", "CDR3b"))
    
    # look at outputs
    names(gcd)
    
    # look at the community matrix
    head(gcd$community_occupancy_matrix)
    
    # look at the community summary
    head(gcd$community_summary$wide)
    
    # look at the node summary
    head(gcd$node_summary)
    
    # differential community occupancy analysis
    dco <- dco(community_occupancy_matrix = gcd$community_occupancy_matrix)
    
    names(dco)
}
}

\name{get_ag_species_hits}
\alias{get_ag_species_hits}
\title{Annotate antigen species hits in node summary}
\description{
Annotates clones (nodes) in the node summary output from the function 
\code{detect_communities} with specificity to given antigen species. 
Adds new binary columns indicating hits and computes antigen-specific 
cellular statistics per community and sample.
}
\details{
Searches for antigen species matches (e.g., "EBV" or "CMV") in annotation 
columns from specified databases (e.g., "vdjdb"). For each match, adds a 
new column to \code{node_summary} (1 = hit, 0 = no hit) and computes:
\itemize{
  \item Repertoire-level: Total cells/clones per sample
  \item Community-level: Cells/clones per community
  \item Antigen-specific: Cells/clones per antigen-community
}
Requires \code{node_summary} from \code{detect_communities} with database 
annotation columns).
}
\usage{
get_ag_species_hits(node_summary, 
                    db = "vdjdb", 
                    ag_species)
}
\arguments{
\item{node_summary}{Node summary data.frame from \code{detect_communities}}
\item{db}{Annotation database (e.g., "vdjdb", "mcpas", "tcr3d")}
\item{ag_species}{Antigen species (e.g., "EBV", "CMV", "SARS-CoV-2")}
}
\value{
List containing:
\item{node_summary}{Input with added antigen hit columns. See \code{new_columns}
for the names of the added columns}
\item{new_columns}{Names of added columns}
\item{table_summary}{Aggregated data.frame with columns:
  \itemize{
    \item \code{sample}, \code{community}, \code{ag_key}
    \item \code{rep_cells}, \code{rep_clones} (repertoire totals)
    \item \code{com_cells}, \code{com_clones} (community totals)
    \item \code{ag_cells}, \code{ag_clones} (antigen-specific counts)
  }
}
}
\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("CDR3ab", package = "ClustIRR")
    a <- data.frame(CDR3a = CDR3ab[1:500, "CDR3a"],
                    CDR3b = CDR3ab[1:500, "CDR3b"],
                    clone_size = 1,
                    sample = "a")
    
    b <- data.frame(CDR3a = CDR3ab[401:900, "CDR3a"],
                    CDR3b = CDR3ab[401:900, "CDR3b"],
                    clone_size = 1,
                    sample = "b")
    b$clone_size[1] <- 20
    
    # run ClustIRR analysis
    c <- clustirr(s = rbind(a, b))
    
    # detect communities
    gcd <- detect_communities(graph = c$graph, 
                              algorithm = "leiden",
                              resolution = 1,
                              chains = c("CDR3a", "CDR3b"))
    
    ag <- get_ag_species_hits(node_summary = gcd$node_summary,
                              db = "vdjdb",
                              ag_species = "EBV")
    
    head(ag)
}
}

\name{save_interactive_graph}
\alias{save_interactive_graph}
\title{Save interactive ClustIRR graph}
\usage{save_interactive_graph(graph,
            file_name,
            output_folder,
            overwrite = TRUE)
}
\arguments{
\item{graph}{Object returned by the function \code{plot_graph}.}
\item{file_name}{Name of the exported graph.}
\item{output_folder}{Path, where to store the graph.}
\item{overwrite}{Whether to overwrite existing files.}
}
\value{
This function saves an interactive \code{visNetwork} plot as self-contained
html file. If \code{output_folder} is not existent, it will be saved in the 
working directory.
}

\description{
This function saves an interactive \code{visNetwork} object as html file
of a \code{clustirr} graph.
}


\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("CDR3ab", package = "ClustIRR")
    s <- data.frame(CDR3b = CDR3ab[1:100, "CDR3b"], sample = "A", clone_size = 1)
    
    # run ClustIRR analysis
    c <- clustirr(s = s)
    
    # plot graph with vertices as clones (has to be a visNetwork)
    g <- plot_graph(c, as_visnet=TRUE, show_singletons=TRUE, node_opacity = 0.8)
    
    # # Save the graph to a temporary directory
    # my_temp_dir <- tempdir()
    # save_interactive_graph(graph = g, 
    #                    file_name = "test_graph", 
    #                    output_folder = my_temp_dir,
    #                    overwrite = TRUE)
}
}

\name{decode_all_communities}
\alias{decode_all_communities}
\title{Decode all graph communities}
\description{
Given a graph based on which we have detected communities (with the function
\code{detect_community}), this function applies \code{decode_communities}
to \bold{all} communities in the graph.  

Each community is partitioned according to user-defined filters on edges 
(\code{edge_filter}) and nodes (\code{node_filter}). This allows extraction 
of subgraphs, cliques, and connected components across the full set of 
communities in the graph.
}
\details{
Internally, this function iterates over all unique community IDs found in the 
vertex attribute \code{community}, and applies \code{decode_communities}.  

\itemize{
\item The \code{edge_filter} controls which edges are retained based on 
their attributes.
\item The \code{node_filter} groups nodes with shared attributes into 
subcomponents.
}
}
\usage{
decode_all_communities(graph, edge_filter, node_filter)
}
\arguments{
\item{graph}{\code{igraph} object that has been analyzed by graph-based 
community detection methods as implemented in \code{detect_community}. 
Must have a vertex attribute named \code{community}.}
\item{edge_filter}{data.frame with edge filters. The data.frame has three 
columns:}
\itemize{
\item name: edge attribute name
\item value: edge attribute value (threshold)
\item operation: logical operation that tells ClustIRR which edge attribute 
values should pass the filter. Possible operations: "<", ">", ">=", "<=", 
"==" and "!=".
}
\item{node_filter}{data.frame with node filters. Groups of nodes that have 
the same attribute values among \bold{ALL} provided attributes will be 
treated as a subcomponent.}
}
\value{
A named list of results, one per community. Each element of the list is the 
output of \code{decode_communities}, containing:
\itemize{
\item community_graph: "filtered" igraph object for the community
\item component_stats: data.frame with summary about each connected component
\item node_summary: data.frame with summary about each node
}
}
\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("CDR3ab", package = "ClustIRR")
    a <- data.frame(CDR3a = CDR3ab[1:500, "CDR3a"],
                    CDR3b = CDR3ab[1:500, "CDR3b"],
                    clone_size = 1,
                    sample = "a")
    
    b <- data.frame(CDR3a = CDR3ab[401:900, "CDR3a"],
                    CDR3b = CDR3ab[401:900, "CDR3b"],
                    clone_size = 1,
                    sample = "b")
    b$clone_size[1] <- 20
    
    # run ClustIRR analysis
    c <- clustirr(s = rbind(a, b))
    
    # detect communities
    gcd <- detect_communities(graph = c$graph, 
                              algorithm = "leiden",
                              resolution = 1,
                              iterations = 100,
                              chains = c("CDR3a", "CDR3b"))
    
    # Construct edge and node filters
    edge_filter <- rbind(data.frame(name = "nweight", value = 8, 
                                    operation = ">="),
                         data.frame(name = "ncweight", value = 8, 
                                    operation = ">="))
    node_filter <- data.frame(name = "Ag_gene")
    
    # Decode all communities at once
    all_decoded <- decode_all_communities(graph = gcd$graph, 
                                          edge_filter = edge_filter,
                                          node_filter = node_filter)
    
    # Inspect one decoded community
    names(all_decoded)
    str(all_decoded[[1]]$component_stats)
}
}

\name{get_cdr3_motifs}
\alias{get_cdr3_motifs}
\title{Generate CDR3 motif for communities}
\description{
This function extracts CDR3 motifs from the node summary of clonotypes in a 
specific community, and generates motif logos for each chain using sequence 
alignment and amino acid frequency calculations. It allows the removal of 
gaps in the alignment based on a user-defined probability threshold.
}
\details{
The function performs the following steps:
\enumerate{
  \item Extracts CDR3 sequences for each chain from the node summary.
  \item Aligns the CDR3 sequences using Clustal Omega and computes 
  position-specific amino acid frequencies.
  \item Generates motif logos for each chain, with the option to remove gaps 
  based on the specified threshold.
  \item The motif logos are arranged in a single row using the `patchwork` 
  package.
}
}
\usage{
get_cdr3_motifs(node_summary, community_id, gap_remove_prob = 0.8)
}
\arguments{
\item{node_summary}{A data frame containing node information generated by
the function \code{detect_communities}. The rows represent clonotypes, and 
the columns include chains (e.g., `CDR3a`, `CDR3b`) and other attributes 
such as `clone_size`.}
\item{community_id}{A numeric or character value representing the community 
ID for which CDR3 motifs should be extracted.}
\item{gap_remove_prob}{A numeric value between 0 and 1 specifying the 
probability threshold for removing gaps in the sequence alignment. The 
default is 0.8. Positions with a gap frequency above this threshold will 
have gaps excluded.}
}
\value{
A `ggplot2` object that displays a series of motif logos for each chain in the 
specified community. The logos show the amino acid frequency at each position 
in the CDR3 sequence, with optional gap removal based on the `gap_remove_prob`.
}
\examples{
# Create a mock node summary data frame
node_summary <- data.frame(
  community = rep(1, 4),
  CDR3a = c("CASSLAGTDTQYF", "CASSLAGTDTQYF", "CASSLAGTDTQYF", "CASSLAGTDTQYF"),
  CDR3b = c("CASSLAGTDTQYF", "CASSLAGTDTQYF", "CASSLAGTDTQYF", "CASSLAGTDTQYF"),
  clone_size = c(100, 150, 200, 50)
)

# Call the function to generate motif logos for community 1
motifs <- get_cdr3_motifs(node_summary, community_id = 1, gap_remove_prob = 0.8)

# Display the resulting motif logos
plot(motifs)
}

\name{clust_irr-class}
\docType{class}
\alias{clust_irr}
\alias{class:clust_irr}
\alias{clust_irr-class}

% Accessor methods:
\alias{get_clustirr_clust,clust_irr-method}
\alias{get_clustirr_inputs,clust_irr-method}
\alias{get_clustirr_clust}
\alias{get_clustirr_inputs}

\title{clust_irr class}

\arguments{
\item{clust}{list, contains clustering results for each TCR/BCR chain. The
results are stored in separate sub-list named appropriately (e.g. CDR3a, CDR3b, 
CDR3g, etc.)}
\item{inputs}{list, contains all user provided inputs}
}

\description{
Objects of the class \code{clust_irr} are generated by the function 
\code{cluster_irr}. These objects are used to store the clustering results 
in a structured way, such that they may be used as inputs of other ClustIRR 
functions (e.g. get_graph, plot_graph, etc.). 

The output is an \code{S4} object of class \code{clust_irr}. This object 
contains two sublists:
\itemize{
\item{\code{clust}, list, contains clustering results for each IR chain. 
The results are stored as data.frame in separate sub-list named appropriately 
(e.g. CDR3a, CDR3b, CDR3g, etc.). Each row in the data.frames contains a pair 
of CDR3s.

The remaining columns contain similarity scores for the complete CDR3 sequences 
(column \code{weight}) or their cores (column \code{cweight}). The columns 
\code{max_len} and \code{max_clen} store the length of the longer CDR3 and 
CDR3 core sequence in the pair, and these used to normalize the scores 
\code{weight} and \code{cweight}: the normalized scores are shown in the 
columns \code{nweight} and \code{ncweight}}

\item{\code{inputs}, list, contains all user provided inputs (see Arguments)}
}
}

\section{Accessors}{
To access the slots of \code{clust_irr} object we have two accessor 
functions. In the description below, \code{x} is a \code{clust_irr} 
object.

\describe{
\item{get_clustirr_clust}{
\code{get_clustirr_clust(x)}:
Extract the clustering results (slot clust)
}
\item{get_clustirr_inputs}{
\code{get_clustirr_inputs(x)}:
Extract the processed inputs (slot inputs)
}
}
}

\value{
The output is an S4 object of class \code{clust_irr}
}

\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    
    # load package input data
    data("CDR3ab", package = "ClustIRR")
    s <- data.frame(CDR3b = CDR3ab[1:100, "CDR3b"], sample = "A",clone_size = 1)
    
    # run analysis
    c <- clustirr(s = s)
    
    # output class
    class(c)
    
    # output structure
    str(c)
    
    # inspect which CDR3bs are globally similar
    knitr::kable(head(slot(c$clust_irrs, "clust")$CDR3b))
    
    
    # clust_irr S4 object generated 'manually' from the individual results
    new_clust_irr <- new("clust_irr", 
                         clust = slot(object = c$clust_irrs, name = "clust"),
                         inputs = slot(object = c$clust_irrs, name = "inputs"))
    
    # we should get identical outputs
    identical(x = new_clust_irr, y = c$clust_irrs)
}
}

\name{decode_community}
\alias{decode_community}
\title{Decode graph communities}
\description{
Given a graph based on which we have detected communities (with the function
\code{detect_communities}), and a community ID, the function will try to 
partition the community nodes according to user-defined filters: edge and
node filters.
}
\details{
How to decode a community? 

For instance, the user may only be interested in retaining edges with core 
edge weight > 4; or making sure that nodes that have same 'cell_type' (node 
meta datafrom) are grouped together. Or the user might want to treat all nodes 
that have the same V, D and J gene names and HLA types as subgroups, in which
case all edges between nodes that do not share the same sets of attributes 
are dicarded.

Based on these \code{filters}, ClustIRR will reformat the edges in the 
selected community and then find \bold{connected components} in the 
resulting graph.
}
\usage{
decode_community(community_id, graph, edge_filter, node_filter)
}
\arguments{
\item{graph}{\code{igraph} object that has been analyzed by graph-based 
community detection methods as implemented in \code{detect_communities}}
\item{community_id}{which community should be decoded?}
\item{edge_filter}{data.frame with edge filters. The deta.frame has three 
columns:}
\itemize{
\item name: edge attribute name
\item value: edge attribute value (threshold)
\item operation: logical operation that tells ClustIRR which edge attribute 
values should pass the filter. Possible operations: "<", ">", ">=", "<=", 
"==" and "!=".
}
\item{node_filter}{a vector with node attributes. Groups of nodes that 
have the same attribute values among \bold{ALL} provided attributes will 
be treated as a subcomponent.}
}
\value{
The output is a list with the following elements
\itemize{
\item community_graph: "filtered" igraph object
\item component_stats: data.frame with summary about each connected component
\item node_summary: data.frame with summary about each node
}
}
\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("CDR3ab", package = "ClustIRR")
    a <- data.frame(CDR3a = CDR3ab[1:500, "CDR3a"],
                    CDR3b = CDR3ab[1:500, "CDR3b"],
                    clone_size = 1,
                    sample = "a")
    
    b <- data.frame(CDR3a = CDR3ab[401:900, "CDR3a"],
                    CDR3b = CDR3ab[401:900, "CDR3b"],
                    clone_size = 1,
                    sample = "b")
    b$clone_size[1] <- 20
    
    # run ClustIRR analysis
    c <- clustirr(s = rbind(a, b))
    
    # detect communities
    gcd <- detect_communities(graph = c$graph, 
                              algorithm = "leiden",
                              resolution = 1,
                              iterations = 100,
                              chains = c("CDR3a", "CDR3b"))
    
    # We "decompose" the communities in the gcd object using decode_community 
    # using attributes of the edges (edge_filter) and nodes (node_filter).
    # We can pick from these edge attributes and create filters:
    library(igraph)
    edge_attr_names(graph = gcd$graph)
    
    # For instance, the following edge-filter will instruct ClustIRR to keep 
    # edges with: edge attributes: nweight>=8 \bold{AND} ncweight>=8
    edge_filter <- rbind(data.frame(name = "nweight", value = 8, 
                                    operation = ">="),
                         data.frame(name = "ncweight", value = 8, 
                                    operation = ">="))
    
    # In addition, we can construct filters using the following node attributes:
    vertex_attr_names(graph = gcd$graph)
    
    # The following node-filter will instruct ClustIRR to retain edges 
    # between nodes that have shared node attributed with respect to ALL 
    # of the following node attributes: 
    node_filter <- data.frame(name = "Ag_gene")
    
    # Lets inspect community with ID = 1.
    c1 <- decode_community(community_id = 1, 
                           graph = gcd$graph,
                           edge_filter = edge_filter,
                           node_filter = node_filter)
    
    # Plot resulting igraph
    par(mar = c(0, 0, 0, 0))
    plot(c1$community_graph, vertex.size = 10)
    
    # Now look at node attributes
    as_data_frame(x = c1$community_graph, what = "vertices")[,c("name", 
                                                                "component_id", 
                                                                "CDR3b", 
                                                                "CDR3a", 
                                                                "Ag_gene")]
    
    str(c1$component_stats)
    
    str(c1$node_summary)
}
}

\name{plot_graph}
\alias{plot_graph}
\title{Plot ClustIRR graph}
\usage{plot_graph(g,
           select_by = "Ag_species",
           as_visnet = FALSE,
           show_singletons = TRUE, 
           node_opacity = 1)
}
\arguments{
\item{g}{Object returned by the function \code{clustirr}}
\item{as_visnet}{logical, if \code{as_visnet}=TRUE we plot an interactive graph 
with visNetwork. If \code{as_visnet}=FALSE, we plot a static graph with igraph.}
\item{select_by}{character string, two values are possible: "Ag_species" or
"Ag_gene". This only has an effect if \code{as_visnet} = TRUE, i.e. if the graph
is interactive. It will allow the user to highligh clones (nodes) in the graph
that are associated with a specific antigenic specie or gene. The mapping 
between CDR3 and antigens is extracted from databases, such as, VDJdb, 
McPAS-TCR and TCR3d. If none of the clones in the graph are matched to a CDR3, 
then the user will have no options to select/highlight.}
\item{show_singletons}{logical, if \code{show_singletons}=TRUE we plot all 
vertices. If \code{show_singletons}=FALSE, we plot only vertices connected by 
edges.}
\item{node_opacity}{probability, controls the opacity of node colors. Lower 
values corresponding to more transparent colors.}
}
\value{
The output is an \code{igraph} or \code{visNetwork} plot.

The size of the vertices increases linearly as the logarithm of the degree of 
the clonal expansion (number of cells per clone) in the corresponding clones.
}

\description{
This function visualizes a graph. The main input is \code{g} object
created by the function \code{clustirr}.
}

\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("CDR3ab", package = "ClustIRR")
    s <- data.frame(CDR3b = CDR3ab[1:100, "CDR3b"], sample = "A", clone_size = 1)
    
    # run ClustIRR analysis
    c <- clustirr(s = s)
    
    # plot graph with vertices as clones
    plot_graph(c, as_visnet=FALSE, show_singletons=TRUE, node_opacity = 0.8)
}
}

\name{get_cosine_similarity}
\alias{get_cosine_similarity}
\title{Compute and Visualize Cosine Similarity (CS)}
\description{
This function calculates pairwise CSs between columns (repertoires) 
of the community occupancy matrix and generates a labeled heatmap 
visualization. Here CS  measures the cosine of the angle between 
vectors of cell counts (positive integers or zero), providing a 
value between 0 (perfect dissimilarity) and 1 (perfect similarity).
}
\details{
The function performs three main operations:
\enumerate{
  \item Computes CS between all column pairs using: 
  \deqn{\text{CS}(x, y) = \frac{x \cdot y}{||x|| \cdot ||y||}}
  \item Creates a heatmap with CS values annotated in each cell
}
Red and blue tiles in the heatmap indicates high and low CS, respectively.
}
\usage{
get_cosine_similarity(com)
}
\arguments{
\item{com}{Community occupancy matrix where columns represent repertoires for 
CS computation. Rows should are communities. Entries are the number of
cells in each repertoire and community.}
}
\value{
A list containing two elements:
\itemize{
  \item \code{g}: A \code{ggplot2} heatmap displaying the CS
  \item \code{cs}: A data frame in long format with columns:
    \itemize{
      \item \code{i}: First repertoire
      \item \code{j}: Second repertoire
      \item \code{CS}: CS (rounded to 2 decimals in plot labels)
    }
}
}
\examples{
# Create a sample matrix
mat <- matrix(rpois(n=15, lambda = 4), nrow = 5, 
              dimnames = list(NULL, c("A", "B", "C")))

# Compute similarities and plot
result <- get_cosine_similarity(mat)

# Display heatmap
print(result$g)

# Inspect similarity values
head(result$cs)
}

\name{get_beta_violin_ag}
\alias{get_beta_violin_ag}
\title{Visualize distribution of \eqn{\beta} means in each repertoire 
as violin plots}
\description{
Visualize the \eqn{\beta} means as violin plots, representing relative 
community occupancies for individual repertoires. At the same time, annotate 
the communities (dots) based on their specificity.
}
\details{
The user has to provide an antigen species (e.g. \code{ag} = "EBV" 
and \code{ag_species}=TRUE) or an antigen gene (e.g. \code{ag} = "MLANA" 
and \code{ag_species}=FALSE). Furthermore, the user has to provide 
nodes (\code{node_summary} data.frame created by the function 
\code{detect_communities}) and \code{beta} data.frame which is part of 
\code{posterior_summary} generated by the function \code{dco}. 

The user can also select an annotation database \code{db},
such as "vdjdb", "mcpas" or "tcr3d". We will look for perfect matches between 
CDR3 sequences in the input and in the annotation database for annotation.
}
\usage{
get_beta_violin_ag(beta,
                   node_summary,
                   ag,
                   ag_species,
                   db = "vdjdb")
}
\arguments{
\item{beta}{\code{beta} data.frame}
\item{node_summary}{\code{node_summary} data.frame}
\item{ag}{antigen species/gene, character, e.g. "EBV", "CMV", or "MLANA"}
\item{ag_species}{is the antigen a species (TRUE) or gene (FALSE)}
\item{db}{annotation database, character, e.g. "vdjdb"}
}
\value{
The output is a violin ggplot.

}
\examples{
# only run if blast is installed
if(rBLAST::has_blast()) {
    # load package input data
    data("CDR3ab", package = "ClustIRR")
    a <- data.frame(CDR3a = CDR3ab[1:500, "CDR3a"],
                    CDR3b = CDR3ab[1:500, "CDR3b"],
                    clone_size = 1,
                    sample = "a")
    
    b <- data.frame(CDR3a = CDR3ab[401:900, "CDR3a"],
                    CDR3b = CDR3ab[401:900, "CDR3b"],
                    clone_size = 1,
                    sample = "b")
    b$clone_size[1] <- 20
    
    # run ClustIRR analysis
    c <- clustirr(s = rbind(a, b))
    
    # detect communities
    gcd <- detect_communities(graph = c$graph, 
                              algorithm = "leiden",
                              resolution = 1,
                              chains = c("CDR3a", "CDR3b"))
    
    # differential community occupancy analysis
    dco <- dco(community_occupancy_matrix = gcd$community_occupancy_matrix)
    
    # generate beta violin plots
    v <- get_beta_violin_ag(beta = dco$posterior_summary$beta,
                           node_summary = gcd$node_summary,
                           ag = "EBV",
                           ag_species = TRUE,
                           db = "vdjdb")
}
}
